"use strict";(self.webpackChunk_goauthentik_website_docs=self.webpackChunk_goauthentik_website_docs||[]).push([[58800],{45752:(e,t,i)=>{i.r(t),i.d(t,{assets:()=>h,contentTitle:()=>o,default:()=>l,frontMatter:()=>r,metadata:()=>a,toc:()=>d});const a=JSON.parse('{"id":"add-secure-apps/providers/proxy/header_authentication","title":"Header authentication","description":"Sending authentication","source":"@site/docs/add-secure-apps/providers/proxy/header_authentication.md","sourceDirName":"add-secure-apps/providers/proxy","slug":"/add-secure-apps/providers/proxy/header_authentication","permalink":"/docs/add-secure-apps/providers/proxy/header_authentication","draft":false,"unlisted":false,"editUrl":"https://github.com/goauthentik/authentik/edit/main/website/docs/add-secure-apps/providers/proxy/header_authentication.md","tags":[],"version":"current","frontMatter":{"title":"Header authentication"},"sidebar":"docs","previous":{"title":"Custom headers","permalink":"/docs/add-secure-apps/providers/proxy/custom_headers"},"next":{"title":"Forward auth","permalink":"/docs/add-secure-apps/providers/proxy/forward_auth"}}');var n=i(74848),s=i(28453);const r={title:"Header authentication"},o=void 0,h={},d=[{value:"Sending authentication",id:"sending-authentication",level:2},{value:"Send HTTP Basic authentication",id:"send-http-basic-authentication",level:3},{value:"Receiving authentication",id:"receiving-authentication",level:2},{value:'Receiving HTTP Basic authentication <span class="badge badge--version">authentik 2023.1+</span>',id:"receiving-http-basic-authentication-authentik-20231",level:3},{value:'Receiving HTTP Bearer authentication <span class="badge badge--version">authentik 2023.1+</span>',id:"receiving-http-bearer-authentication-authentik-20231",level:3}];function c(e){const t={a:"a",admonition:"admonition",code:"code",em:"em",h2:"h2",h3:"h3",p:"p",pre:"pre",strong:"strong",...(0,s.R)(),...e.components};return(0,n.jsxs)(n.Fragment,{children:[(0,n.jsx)(t.h2,{id:"sending-authentication",children:"Sending authentication"}),"\n",(0,n.jsx)(t.h3,{id:"send-http-basic-authentication",children:"Send HTTP Basic authentication"}),"\n",(0,n.jsxs)(t.p,{children:["Proxy providers have the option to ",(0,n.jsx)(t.em,{children:"Send HTTP-Basic Authentication"})," to the upstream authentication. When the option in the provider is enabled, two attributes must be specified. These attributes are the keys of values which can be saved on a user or group level that contain the credentials."]}),"\n",(0,n.jsxs)(t.p,{children:["For example, with ",(0,n.jsx)(t.em,{children:"HTTP-Basic Username Key"})," set to ",(0,n.jsx)(t.code,{children:"app_username"})," and ",(0,n.jsx)(t.em,{children:"HTTP-Basic Password Key"})," set to ",(0,n.jsx)(t.code,{children:"app_password"}),", these attributes would have to be set either on a user or a group the user is member of:"]}),"\n",(0,n.jsx)(t.pre,{children:(0,n.jsx)(t.code,{className:"language-yaml",children:"app_username: admin\napp_password: admin-password\n"})}),"\n",(0,n.jsx)(t.p,{children:"These credentials are only retrieved when the user authenticates to the proxy."}),"\n",(0,n.jsx)(t.p,{children:"If the user does not have a matching attribute, authentik falls back to using the user's email address as username, and the password will be empty if not found."}),"\n",(0,n.jsx)(t.h2,{id:"receiving-authentication",children:"Receiving authentication"}),"\n",(0,n.jsxs)(t.p,{children:["By default, when ",(0,n.jsx)(t.em,{children:"Intercept header authentication"})," is enabled, authentik will intercept the authorization header. If the authorization header value is invalid, an error response will be shown with a 401 status code. Requests without an authorization header will still be redirected to the standard login flow."]}),"\n",(0,n.jsx)(t.p,{children:'If the proxied application requires usage of the "Authorization" header, the setting should be disabled. When this setting is disabled, authentik will still attempt to interpret the "Authorization" header, and fall back to the default behaviour if it can\'t.'}),"\n",(0,n.jsxs)(t.h3,{id:"receiving-http-basic-authentication-authentik-20231",children:["Receiving HTTP Basic authentication ",(0,n.jsx)("span",{class:"badge badge--version",children:"authentik 2023.1+"})]}),"\n",(0,n.jsxs)(t.p,{children:["Proxy providers can receive HTTP basic authentication credentials. The password is expected to be an ",(0,n.jsx)(t.em,{children:"App password"}),", as the credentials are used internally with the ",(0,n.jsx)(t.a,{href:"/docs/add-secure-apps/providers/oauth2/client_credentials",children:"OAuth2 machine-to-machine authentication flow"}),"."]}),"\n",(0,n.jsx)(t.p,{children:"Access control is done with the policies bound to the application being accessed."}),"\n",(0,n.jsx)(t.p,{children:"If the received credentials are invalid, a normal authentication flow is initiated. If the credentials are correct, the Authorization header is removed to prevent sending the credentials to the proxied application."}),"\n",(0,n.jsx)(t.admonition,{type:"danger",children:(0,n.jsxs)(t.p,{children:["It is ",(0,n.jsx)(t.strong,{children:"strongly"})," recommended that the client sending requests with HTTP-Basic authentication persists the cookies returned by the outpost. If this is not the case, every request must be authenticated independently, which will increase load on the authentik server and encounter a performance hit."]})}),"\n",(0,n.jsxs)(t.p,{children:["Starting with authentik 2023.2, logging in with the reserved username ",(0,n.jsx)(t.code,{children:"goauthentik.io/token"})," will behave as if a bearer token was used. All the same options as below apply. This is to allow token-based authentication for applications which might only support basic authentication."]}),"\n",(0,n.jsxs)(t.h3,{id:"receiving-http-bearer-authentication-authentik-20231",children:["Receiving HTTP Bearer authentication ",(0,n.jsx)("span",{class:"badge badge--version",children:"authentik 2023.1+"})]}),"\n",(0,n.jsxs)(t.p,{children:["Proxy providers can receive HTTP bearer authentication credentials. The token is expected to be a JWT token issued for the proxy provider. This is described ",(0,n.jsx)(t.a,{href:"/docs/add-secure-apps/providers/oauth2/client_credentials",children:"here"}),", using the ",(0,n.jsx)(t.em,{children:"client_id"})," value shown in the admin interface. Both static and JWT authentication methods are supported."]}),"\n",(0,n.jsx)(t.p,{children:"Access control is done with the policies bound to the application being accessed."}),"\n",(0,n.jsx)(t.p,{children:"If the received credentials are invalid, a normal authentication flow is initiated. If the credentials are correct, the Authorization header is removed to prevent sending the credentials to the proxied application."}),"\n",(0,n.jsx)(t.admonition,{type:"caution",children:(0,n.jsx)(t.p,{children:"It is recommended that the client sending requests with HTTP-Bearer authentication persists the cookies returned by the outpost. For bearer authentication this has a smaller impact than for Basic authentication, but each request is still verified with the authentik server."})})]})}function l(e={}){const{wrapper:t}={...(0,s.R)(),...e.components};return t?(0,n.jsx)(t,{...e,children:(0,n.jsx)(c,{...e})}):c(e)}}}]);