"use strict";(self.webpackChunk_goauthentik_website_docs=self.webpackChunk_goauthentik_website_docs||[]).push([[69437],{48364:(e,t,i)=>{i.r(t),i.d(t,{assets:()=>h,contentTitle:()=>r,default:()=>l,frontMatter:()=>o,metadata:()=>n,toc:()=>c});const n=JSON.parse('{"id":"add-secure-apps/providers/oauth2/index","title":"OAuth 2.0 provider","description":"In authentik, you can create an OAuth 2.0 provider that authentik uses to authenticate the user to the associated application. This provider supports both generic OAuth2 as well as OpenID Connect (OIDC).","source":"@site/docs/add-secure-apps/providers/oauth2/index.md","sourceDirName":"add-secure-apps/providers/oauth2","slug":"/add-secure-apps/providers/oauth2/","permalink":"/docs/add-secure-apps/providers/oauth2/","draft":false,"unlisted":false,"editUrl":"https://github.com/goauthentik/authentik/edit/main/website/docs/add-secure-apps/providers/oauth2/index.md","tags":[],"version":"current","frontMatter":{"title":"OAuth 2.0 provider"},"sidebar":"docs","previous":{"title":"Add an Entra ID provider","permalink":"/docs/add-secure-apps/providers/entra/add-entra-provider"},"next":{"title":"Create an OAuth2 provider","permalink":"/docs/add-secure-apps/providers/oauth2/create-oauth2-provider"}}');var s=i(74848),a=i(28453);const o={title:"OAuth 2.0 provider"},r=void 0,h={},c=[{value:"authentik and OAuth 2.0",id:"authentik-and-oauth-20",level:2},{value:"About OAuth 2.0 and OIDC",id:"about-oauth-20-and-oidc",level:2},{value:"Additional configuration options with Redirect URIs",id:"additional-configuration-options-with-redirect-uris",level:3},{value:"OAuth 2.0 flows and grant types",id:"oauth-20-flows-and-grant-types",level:2},{value:"1: Web-based application authorization",id:"1-web-based-application-authorization",level:3},{value:"Authorization code",id:"authorization-code",level:4},{value:"Implicit",id:"implicit",level:4},{value:"Hybrid",id:"hybrid",level:4},{value:"2. Client credentials",id:"2-client-credentials",level:3},{value:"3. Device code",id:"3-device-code",level:3},{value:"Refresh token grant",id:"refresh-token-grant",level:4},{value:"Scope mappings",id:"scope-mappings",level:2},{value:"Scope authorization",id:"scope-authorization",level:2},{value:"Default &amp; special scopes",id:"default--special-scopes",level:2},{value:"Default",id:"default",level:3},{value:"authentik",id:"authentik",level:3},{value:"GitHub compatibility",id:"github-compatibility",level:3},{value:"Signing &amp; Encryption",id:"signing--encryption",level:2},{value:'Encryption <span class="badge badge--version">authentik 2024.10+</span>',id:"encryption-authentik-202410",level:3}];function d(e){const t={a:"a",admonition:"admonition",code:"code",em:"em",h2:"h2",h3:"h3",h4:"h4",li:"li",mermaid:"mermaid",ol:"ol",p:"p",pre:"pre",strong:"strong",table:"table",tbody:"tbody",td:"td",th:"th",thead:"thead",tr:"tr",ul:"ul",...(0,a.R)(),...e.components};return(0,s.jsxs)(s.Fragment,{children:[(0,s.jsxs)(t.p,{children:["In authentik, you can ",(0,s.jsx)(t.a,{href:"/docs/add-secure-apps/providers/oauth2/create-oauth2-provider",children:"create"})," an ",(0,s.jsx)(t.a,{href:"https://oauth.net/2/",children:"OAuth 2.0"})," provider that authentik uses to authenticate the user to the associated application. This provider supports both generic OAuth2 as well as OpenID Connect (OIDC)."]}),"\n",(0,s.jsx)(t.h2,{id:"authentik-and-oauth-20",children:"authentik and OAuth 2.0"}),"\n",(0,s.jsxs)(t.p,{children:["It's important to understand how authentik works with and supports the OAuth 2.0 protocol, so before taking a ",(0,s.jsx)(t.a,{href:"#about-oauth-20-and-oidc",children:"closer look at OAuth 2.0 protocol"})," itself, let's cover a bit about authentik."]}),"\n",(0,s.jsxs)(t.p,{children:["authentik can act either as the OP, (OpenID Provider, with authentik as the IdP), or as the RP (Relying Party, or the application that uses OAuth 2.0 to authenticate). If you want to configure authentik as an OP, then you create a provider, then use the OAuth 2.0 provider. If you want authentik to serve as the RP, then configure a ",(0,s.jsx)(t.a,{href:"/docs/users-sources/sources/",children:"source"}),". Of course, authentik can serve as both the RP and OP, if you want to use the authentik OAuth provider and also use sources."]}),"\n",(0,s.jsxs)(t.p,{children:["All standard OAuth 2.0 flows (authorization code, client_credentials, implicit, hybrid, device code) and grant types are supported in authentik, and we follow the ",(0,s.jsx)(t.a,{href:"https://openid.net/specs/openid-connect-core-1_0.html",children:"OIDC spec"}),". OAuth 2.0 in authentik supports OAuth, PKCE, ",(0,s.jsx)(t.a,{href:"/docs/add-secure-apps/providers/oauth2/github-compatibility",children:"Github compatibility"})," and the RP receives data from our scope mapping system."]}),"\n",(0,s.jsx)(t.p,{children:"The authentik OAuth 2.0 provider comes with all the standard functionality and features of OAuth 2.0, including the OAuth 2.0 security principles such as no cleartext storage of credentials, configurable encryption, configurable short expiration times, and the configuration of automatic rotation of refresh tokens. In short, our OAuth 2.0 protocol support provides full coverage."}),"\n",(0,s.jsx)(t.h2,{id:"about-oauth-20-and-oidc",children:"About OAuth 2.0 and OIDC"}),"\n",(0,s.jsx)(t.p,{children:"OAuth 2.0 is an authorization protocol that allows an application (the RP) to delegate authorization to an OP. OIDC is an authentication protocol built on top of OAuth2, which provides identity credentials and other data on top of OAuth2."}),"\n",(0,s.jsxs)(t.p,{children:[(0,s.jsx)(t.strong,{children:"OAuth 2.0"}),' typically requires two requests (unlike the previous "three-legged" OAuth 1.0). The two "legs", or requests, for OAuth 2.0 are:']}),"\n",(0,s.jsxs)(t.ol,{children:["\n",(0,s.jsx)(t.li,{children:"An authorization request is prepared by the RP and contains parameters for its implementation of OAuth and which data it requires, and then the User's browser is redirected to that URL."}),"\n",(0,s.jsx)(t.li,{children:"The RP sends a request to authentik in the background to exchange the access code for an access token (and optionally a refresh token)."}),"\n"]}),"\n",(0,s.jsxs)(t.p,{children:["In detail, with OAuth2 when a user accesses the application (the RP) via their browser, the RP then prepares a URL with parameters for the OpenID Provider (OP), which the users's browser is redirected to. The OP authenticates the user and generates an authorization code. The OP then redirects the client (the user's browser) back to the RP, along with that authorization code. In the background, the RP then sends that same authorization code in a request authenticated by the ",(0,s.jsx)(t.code,{children:"client_id"})," and ",(0,s.jsx)(t.code,{children:"client_secret"})," to the OP. Finally, the OP responds by sending an Access Token saying this user has been authorised (the RP is recommended to validate this token using cryptography) and optionally a Refresh Token."]}),"\n",(0,s.jsx)(t.p,{children:"The image below shows a typical authorization code flow."}),"\n",(0,s.jsx)(t.mermaid,{value:"sequenceDiagram\n    participant user as User\n    participant rp as RP (Relying Party)\n    participant op as OP (OpenID Provider)\n\n    user->>rp: User accesses application\n    rp->>user: RP prepares authorization request & redirects user to OP\n\n    user->>op: User authentication & authorization occurs\n    op->>rp: Redirect back to the RP with an authorization code\n\n    rect rgb(255, 255, 191)\n\n        rp->>op: Exchange authorization code\n        op->>rp: RP receives Access token (optionally Refresh Token)\n    end\n\n    rp->>user: User is logged in"}),"\n",(0,s.jsxs)(t.table,{children:[(0,s.jsx)(t.thead,{children:(0,s.jsxs)(t.tr,{children:[(0,s.jsx)(t.th,{children:"Endpoint"}),(0,s.jsx)(t.th,{children:"URL"})]})}),(0,s.jsxs)(t.tbody,{children:[(0,s.jsxs)(t.tr,{children:[(0,s.jsx)(t.td,{children:"Authorization"}),(0,s.jsx)(t.td,{children:(0,s.jsx)(t.code,{children:"/application/o/authorize/"})})]}),(0,s.jsxs)(t.tr,{children:[(0,s.jsx)(t.td,{children:"Token"}),(0,s.jsx)(t.td,{children:(0,s.jsx)(t.code,{children:"/application/o/token/"})})]}),(0,s.jsxs)(t.tr,{children:[(0,s.jsx)(t.td,{children:"User Info"}),(0,s.jsx)(t.td,{children:(0,s.jsx)(t.code,{children:"/application/o/userinfo/"})})]}),(0,s.jsxs)(t.tr,{children:[(0,s.jsx)(t.td,{children:"Token Revoke"}),(0,s.jsx)(t.td,{children:(0,s.jsx)(t.code,{children:"/application/o/revoke/"})})]}),(0,s.jsxs)(t.tr,{children:[(0,s.jsx)(t.td,{children:"End Session"}),(0,s.jsx)(t.td,{children:(0,s.jsx)(t.code,{children:"/application/o/<application slug>/end-session/"})})]}),(0,s.jsxs)(t.tr,{children:[(0,s.jsx)(t.td,{children:"JWKS"}),(0,s.jsx)(t.td,{children:(0,s.jsx)(t.code,{children:"/application/o/<application slug>/jwks/"})})]}),(0,s.jsxs)(t.tr,{children:[(0,s.jsx)(t.td,{children:"OpenID Configuration"}),(0,s.jsx)(t.td,{children:(0,s.jsx)(t.code,{children:"/application/o/<application slug>/.well-known/openid-configuration"})})]})]})]}),"\n",(0,s.jsx)(t.h3,{id:"additional-configuration-options-with-redirect-uris",children:"Additional configuration options with Redirect URIs"}),"\n",(0,s.jsxs)(t.p,{children:["When using an OAuth 2.0 provider in authentik, the OP must validate the provided redirect URI by the RP. An authentik admin can configure a list in the ",(0,s.jsx)(t.strong,{children:"Redirect URI"})," field on the Provider."]}),"\n",(0,s.jsxs)(t.p,{children:["When you create a new OAuth 2.0 provider and app in authentik and you leave the ",(0,s.jsx)(t.strong,{children:"Redirect URI"})," field empty, then the first time a user opens that app, authentik uses that URL as the saved redirect URL."]}),"\n",(0,s.jsx)(t.p,{children:'For advanced use cases, an authentik admin can use regular expressions (regex) instead of a redirect URL. For example, if you want to list 10 diff applications, instead of listing all ten you can create an expression with wildcards. Be aware, when using regex, that authetnik uses a dot as a separator in the URL, but in regex a dot means "one of any character", a wildcard. So you should escape the dot to prevent its interpration as a wildcard.'}),"\n",(0,s.jsx)(t.h2,{id:"oauth-20-flows-and-grant-types",children:"OAuth 2.0 flows and grant types"}),"\n",(0,s.jsx)(t.p,{children:"There are three general flows of OAuth 2.0:"}),"\n",(0,s.jsxs)(t.ol,{children:["\n",(0,s.jsx)(t.li,{children:"Web-based application authorization (Authorization code, Implicit, Refresh token)"}),"\n",(0,s.jsx)(t.li,{children:"Client credentials (Machine-to-machine)"}),"\n",(0,s.jsx)(t.li,{children:"Device code"}),"\n"]}),"\n",(0,s.jsxs)(t.p,{children:["Additionally, the ",(0,s.jsx)(t.a,{href:"#refresh-token-grant",children:"Refresh token"})," (grant type) is optionally used with any of the above flows, as well as the client credentials and device code flows."]}),"\n",(0,s.jsx)(t.h3,{id:"1-web-based-application-authorization",children:"1: Web-based application authorization"}),"\n",(0,s.jsx)(t.p,{children:"The flows and grant types used in this case are those used for a typical authorization process, with a user and an application:"}),"\n",(0,s.jsxs)(t.ul,{children:["\n",(0,s.jsxs)(t.li,{children:[(0,s.jsx)(t.em,{children:"Authorization code"})," grant type"]}),"\n",(0,s.jsxs)(t.li,{children:[(0,s.jsx)(t.em,{children:"Implicit"})," grant type (legacy)"]}),"\n",(0,s.jsxs)(t.li,{children:[(0,s.jsx)(t.em,{children:"Hybrid"})," grant type"]}),"\n"]}),"\n",(0,s.jsx)(t.h4,{id:"authorization-code",children:"Authorization code"}),"\n",(0,s.jsx)(t.p,{children:"The authorization code is for environments with both a Client and a application server, where the back and forth happens between the client and an app server (the logic lives on app server). The RP needs to authorise itself to the OP. Client ID (public, identifies which app is talking to it) and client secret (the password) that the RP uses to authenticate."}),"\n",(0,s.jsx)(t.p,{children:'If you configure authentik to use "Offline access" then during the initial auth the OP sends two tokens, an access token (short-lived, hours, can be customised) and a refresh token (typically longer validity, days or infinite). The RP (the app) saves both tokens. When the access token is about to expire, the RP sends the saved refresh token back to the OP, and requests a new access token. When the refresh token itself is about to expire, the RP can also ask for a new refresh token. This can all happen without user interaction if you configured the offline access.'}),"\n",(0,s.jsx)(t.admonition,{type:"info",children:(0,s.jsxs)(t.p,{children:["Starting with authentik 2024.2, applications only receive an access token. To receive a refresh token, both applications and authentik must be configured to request the ",(0,s.jsx)(t.code,{children:"offline_access"})," scope. In authentik this can be done by selecting the ",(0,s.jsx)(t.code,{children:"offline_access"})," Scope mapping in the provider settings."]})}),"\n",(0,s.jsxs)(t.p,{children:["The authorization code grant type is used to convert an authorization code to an access token (and optionally a refresh token). The authorization code is retrieved through the authentik ",(0,s.jsx)(t.a,{href:"/docs/add-secure-apps/flows-stages/flow/",children:"Authorization flow"}),", can only be used once, and expires quickly."]}),"\n",(0,s.jsx)(t.h4,{id:"implicit",children:"Implicit"}),"\n",(0,s.jsx)(t.admonition,{type:"info",children:(0,s.jsxs)(t.p,{children:["The OAuth 2.0 ",(0,s.jsx)(t.a,{href:"https://tools.ietf.org/html/draft-ietf-oauth-security-topics",children:"Security Best Current Practice document"})," recommends against using the Implicit flow entirely, and OAuth 2.0 for Browser-Based Apps describes the technique of using the authorization code flow with PKCE instead. (",(0,s.jsx)(t.a,{href:"https://oauth.net/2/grant-types/implicit/",children:"source"}),")"]})}),"\n",(0,s.jsx)(t.p,{children:"This flow is for more modern single page-applications, or ones you download, that are all client-side (all JS, no backend logic, etc) and have no server to make tokens. Because the secret cannot be stored on the client machine, the implicit flow is required in these architectures. With the implicit flow, the flow skips the second part of the two requests seen in the authorization flow; after the initial author request, the implicit flow receives a token, and then with cryptocracy and with PKCE, it can validate that it is the correct client, and that is safe to send a token. The RP (still called that with this implicit flow) can use cryptography to validate the token."}),"\n",(0,s.jsx)(t.h4,{id:"hybrid",children:"Hybrid"}),"\n",(0,s.jsx)(t.p,{children:"The Hybrid Flow is an OpenID Connect flow that incorporates traits of both the Implicit flow and the Authorization Code flow. It provides an application instant access to an ID token while ensuring secure and safe retrieval of access tokens and refresh tokens. This can be useful in situations where the application needs to quickly access information about the user, while in the background doing further processing to get additional tokens before gaining access to additional resources."}),"\n",(0,s.jsx)(t.h3,{id:"2-client-credentials",children:"2. Client credentials"}),"\n",(0,s.jsx)(t.p,{children:"The client credentials flow and grant types are typically implemented for server-to-server scenarios, when code in a web application invokes a web API."}),"\n",(0,s.jsxs)(t.p,{children:["For more information, see ",(0,s.jsx)(t.a,{href:"/docs/add-secure-apps/providers/oauth2/client_credentials",children:"Machine-to-machine authentication"}),"."]}),"\n",(0,s.jsx)(t.h3,{id:"3-device-code",children:"3. Device code"}),"\n",(0,s.jsx)(t.p,{children:'The device code flow is used in situations where there is no browser and limited options for text or data input from a client ("input-constrained devices"). For example, using a subscription TV program on a television, where you use a website on your mobile device to input a code displayed on the TV, authenticate, and then you are logged in to the TV.'}),"\n",(0,s.jsxs)(t.p,{children:["For more information, see ",(0,s.jsx)(t.a,{href:"/docs/add-secure-apps/providers/oauth2/device_code",children:"Device code flow"}),"."]}),"\n",(0,s.jsx)(t.h4,{id:"refresh-token-grant",children:"Refresh token grant"}),"\n",(0,s.jsx)(t.p,{children:"Refresh tokens can be used as long-lived tokens to access user data, and further renew the refresh token down the road."}),"\n",(0,s.jsx)(t.admonition,{type:"info",children:(0,s.jsxs)(t.p,{children:["Starting with authentik 2024.2, the refresh token grant type requires the ",(0,s.jsx)(t.code,{children:"offline_access"})," scope."]})}),"\n",(0,s.jsx)(t.h2,{id:"scope-mappings",children:"Scope mappings"}),"\n",(0,s.jsxs)(t.p,{children:["Scopes can be configured using scope mappings, a type of ",(0,s.jsx)(t.a,{href:"/docs/add-secure-apps/providers/property-mappings/#scope-mappings",children:"property mapping"}),"."]}),"\n",(0,s.jsx)(t.h2,{id:"scope-authorization",children:"Scope authorization"}),"\n",(0,s.jsx)(t.p,{children:"By default, every user that has access to an application can request any of the configured scopes. Starting with authentik 2022.4, you can do additional checks for the scope in an expression policy (bound to the application):"}),"\n",(0,s.jsx)(t.pre,{children:(0,s.jsx)(t.code,{className:"language-python",children:'# There are additional fields set in the context, use `ak_logger.debug(request.context)` to see them.\nif "my-admin-scope" in request.context["oauth_scopes"]:\n    return ak_is_group_member(request.user, name="my-admin-group")\nreturn True\n'})}),"\n",(0,s.jsx)(t.h2,{id:"default--special-scopes",children:"Default & special scopes"}),"\n",(0,s.jsx)(t.p,{children:"When a client does not request any scopes, authentik will treat the request as if all configured scopes were requested. Depending on the configured authorization flow, consent still needs to be given, and all scopes are listed there."}),"\n",(0,s.jsxs)(t.p,{children:["This does ",(0,s.jsx)(t.em,{children:"not"})," apply to special scopes, as those are not configurable in the provider."]}),"\n",(0,s.jsx)(t.h3,{id:"default",children:"Default"}),"\n",(0,s.jsxs)(t.ul,{children:["\n",(0,s.jsxs)(t.li,{children:[(0,s.jsx)(t.code,{children:"openid"}),": A scope required by the OpenID Connect spec to specify that an OAuth interaction is OpenID Connect. Does not add any data to the token."]}),"\n",(0,s.jsxs)(t.li,{children:[(0,s.jsx)(t.code,{children:"profile"}),": Include basic profile information, such as username, name and group membership."]}),"\n",(0,s.jsxs)(t.li,{children:[(0,s.jsx)(t.code,{children:"email"}),": Include the users' email address."]}),"\n",(0,s.jsxs)(t.li,{children:[(0,s.jsx)(t.code,{children:"entitlements"}),": Include application entitlement data."]}),"\n",(0,s.jsxs)(t.li,{children:[(0,s.jsx)(t.code,{children:"offline_access"}),": An OAuth 2.0 scope which indicates that the application is requesting a refresh token."]}),"\n"]}),"\n",(0,s.jsx)(t.h3,{id:"authentik",children:"authentik"}),"\n",(0,s.jsxs)(t.ul,{children:["\n",(0,s.jsxs)(t.li,{children:[(0,s.jsx)(t.code,{children:"goauthentik.io/api"}),": This scope grants the refresh token access to the authentik API on behalf of the user"]}),"\n"]}),"\n",(0,s.jsx)(t.h3,{id:"github-compatibility",children:"GitHub compatibility"}),"\n",(0,s.jsxs)(t.ul,{children:["\n",(0,s.jsxs)(t.li,{children:[(0,s.jsx)(t.code,{children:"user"}),": No-op, is accepted for compatibility but does not give access to any resources"]}),"\n",(0,s.jsxs)(t.li,{children:[(0,s.jsx)(t.code,{children:"read:user"}),": Same as above"]}),"\n",(0,s.jsxs)(t.li,{children:[(0,s.jsx)(t.code,{children:"user:email"}),": Allows read-only access to ",(0,s.jsx)(t.code,{children:"/user"}),", including email address"]}),"\n",(0,s.jsxs)(t.li,{children:[(0,s.jsx)(t.code,{children:"read:org"}),": Allows read-only access to ",(0,s.jsx)(t.code,{children:"/user/teams"}),", listing all the user's groups as teams."]}),"\n"]}),"\n",(0,s.jsx)(t.h2,{id:"signing--encryption",children:"Signing & Encryption"}),"\n",(0,s.jsxs)(t.p,{children:[(0,s.jsx)(t.a,{href:"https://jwt.io/introduction",children:"JWTs"})," created by authentik will always be signed."]}),"\n",(0,s.jsxs)(t.p,{children:["When a ",(0,s.jsx)(t.em,{children:"Signing Key"})," is selected in the provider, the JWT will be signed asymmetrically with the private key of the selected certificate, and can be verified using the public key of the certificate. The public key data of the signing key can be retrieved via the JWKS endpoint listed on the provider page."]}),"\n",(0,s.jsxs)(t.p,{children:["When no ",(0,s.jsx)(t.em,{children:"Signing Key"})," is selected, the JWT will be signed symmetrically with the ",(0,s.jsx)(t.em,{children:"Client secret"})," of the provider, which can be seen in the provider settings."]}),"\n",(0,s.jsxs)(t.h3,{id:"encryption-authentik-202410",children:["Encryption ",(0,s.jsx)("span",{class:"badge badge--version",children:"authentik 2024.10+"})]}),"\n",(0,s.jsxs)(t.p,{children:["authentik can also encrypt JWTs (turning them into JWEs) it issues by selecting an ",(0,s.jsx)(t.em,{children:"Encryption Key"})," in the provider. When selected, all JWTs will be encrypted symmetrically using the selected certificate. authentik uses the ",(0,s.jsx)(t.code,{children:"RSA-OAEP-256"})," algorithm with the ",(0,s.jsx)(t.code,{children:"A256CBC-HS512"})," encryption method."]})]})}function l(e={}){const{wrapper:t}={...(0,a.R)(),...e.components};return t?(0,s.jsx)(t,{...e,children:(0,s.jsx)(d,{...e})}):d(e)}}}]);