"use strict";(self.webpackChunk_goauthentik_website_docs=self.webpackChunk_goauthentik_website_docs||[]).push([[39555],{49913:(e,t,s)=>{s.r(t),s.d(t,{assets:()=>l,contentTitle:()=>a,default:()=>h,frontMatter:()=>o,metadata:()=>n,toc:()=>c});const n=JSON.parse('{"id":"add-secure-apps/outposts/integrations/kubernetes","title":"Kubernetes","description":"The kubernetes integration will automatically deploy outposts on any Kubernetes Cluster.","source":"@site/docs/add-secure-apps/outposts/integrations/kubernetes.md","sourceDirName":"add-secure-apps/outposts/integrations","slug":"/add-secure-apps/outposts/integrations/kubernetes","permalink":"/docs/add-secure-apps/outposts/integrations/kubernetes","draft":false,"unlisted":false,"editUrl":"https://github.com/goauthentik/authentik/edit/main/website/docs/add-secure-apps/outposts/integrations/kubernetes.md","tags":[],"version":"current","frontMatter":{"title":"Kubernetes"},"sidebar":"docs","previous":{"title":"Docker","permalink":"/docs/add-secure-apps/outposts/integrations/docker"},"next":{"title":"Manual Outpost deployment in docker-compose","permalink":"/docs/add-secure-apps/outposts/manual-deploy-docker-compose"}}');var i=s(74848),r=s(28453);const o={title:"Kubernetes"},a=void 0,l={},c=[{value:"Permissions",id:"permissions",level:2},{value:"Remote clusters",id:"remote-clusters",level:2}];function d(e){const t={a:"a",code:"code",h2:"h2",li:"li",p:"p",ul:"ul",...(0,r.R)(),...e.components};return(0,i.jsxs)(i.Fragment,{children:[(0,i.jsx)(t.p,{children:"The kubernetes integration will automatically deploy outposts on any Kubernetes Cluster."}),"\n",(0,i.jsx)(t.p,{children:"This integration has the advantage over manual deployments of automatic updates (whenever authentik is updated, it updates the outposts), and authentik can (in a future version) automatically rotate the token that the outpost uses to communicate with the core authentik server."}),"\n",(0,i.jsx)(t.p,{children:"This integration creates the following objects:"}),"\n",(0,i.jsxs)(t.ul,{children:["\n",(0,i.jsx)(t.li,{children:"Deployment for the outpost container"}),"\n",(0,i.jsx)(t.li,{children:"Service"}),"\n",(0,i.jsx)(t.li,{children:"Secret to store the token"}),"\n",(0,i.jsx)(t.li,{children:"Prometheus ServiceMonitor (if the Prometheus Operator is installed in the target cluster)"}),"\n",(0,i.jsx)(t.li,{children:"Ingress (only Proxy outposts)"}),"\n",(0,i.jsx)(t.li,{children:"Traefik Middleware (only Proxy outposts with forward auth enabled)"}),"\n"]}),"\n",(0,i.jsx)(t.p,{children:"The following outpost settings are used:"}),"\n",(0,i.jsxs)(t.ul,{children:["\n",(0,i.jsxs)(t.li,{children:[(0,i.jsx)(t.code,{children:"object_naming_template"}),": Configures how the container is called"]}),"\n",(0,i.jsxs)(t.li,{children:[(0,i.jsx)(t.code,{children:"container_image"}),": Optionally overwrites the standard container image (see ",(0,i.jsx)(t.a,{href:"/docs/install-config/configuration/",children:"Configuration"})," to configure the global default)"]}),"\n",(0,i.jsxs)(t.li,{children:[(0,i.jsx)(t.code,{children:"kubernetes_replicas"}),": Replica count for the deployment of the outpost"]}),"\n",(0,i.jsxs)(t.li,{children:[(0,i.jsx)(t.code,{children:"kubernetes_namespace"}),": Namespace to deploy in, defaults to the same namespace authentik is deployed in (if available)"]}),"\n",(0,i.jsxs)(t.li,{children:[(0,i.jsx)(t.code,{children:"kubernetes_ingress_annotations"}),": Any additional annotations to add to the ingress object, for example cert-manager"]}),"\n",(0,i.jsxs)(t.li,{children:[(0,i.jsx)(t.code,{children:"kubernetes_ingress_secret_name"}),": Name of the secret that is used for TLS connections, can be empty to disable TLS config"]}),"\n",(0,i.jsxs)(t.li,{children:[(0,i.jsx)(t.code,{children:"kubernetes_ingress_class_name"}),": Optionally set the ingress class used for the generated ingress, requires authentik 2022.11.0"]}),"\n",(0,i.jsxs)(t.li,{children:[(0,i.jsx)(t.code,{children:"kubernetes_service_type"}),": Service kind created, can be set to LoadBalancer for LDAP outposts for example"]}),"\n",(0,i.jsxs)(t.li,{children:[(0,i.jsx)(t.code,{children:"kubernetes_disabled_components"}),": Disable any components of the kubernetes integration, can be any of","\n",(0,i.jsxs)(t.ul,{children:["\n",(0,i.jsx)(t.li,{children:"'secret'"}),"\n",(0,i.jsx)(t.li,{children:"'deployment'"}),"\n",(0,i.jsx)(t.li,{children:"'service'"}),"\n",(0,i.jsx)(t.li,{children:"'prometheus servicemonitor'"}),"\n",(0,i.jsx)(t.li,{children:"'ingress'"}),"\n",(0,i.jsx)(t.li,{children:"'traefik middleware'"}),"\n"]}),"\n"]}),"\n",(0,i.jsxs)(t.li,{children:[(0,i.jsx)(t.code,{children:"kubernetes_image_pull_secrets"}),": If the above docker image is in a private repository, use these secrets to pull. (NOTE: The secret must be created manually in the namespace first.)"]}),"\n",(0,i.jsxs)(t.li,{children:[(0,i.jsx)(t.code,{children:"kubernetes_json_patches"}),": Applies an RFC 6902 compliant JSON patch to the Kubernetes objects."]}),"\n"]}),"\n",(0,i.jsx)(t.h2,{id:"permissions",children:"Permissions"}),"\n",(0,i.jsxs)(t.p,{children:["The permissions required for this integration are documented in the helm chart. See ",(0,i.jsx)(t.a,{href:"https://github.com/goauthentik/helm/blob/main/charts/authentik-remote-cluster/templates/clusterrolebinding.yaml",children:"Cluster-level"})," and ",(0,i.jsx)(t.a,{href:"https://github.com/goauthentik/helm/blob/main/charts/authentik-remote-cluster/templates/rolebinding.yaml",children:"Namespace-level"}),"."]}),"\n",(0,i.jsx)(t.h2,{id:"remote-clusters",children:"Remote clusters"}),"\n",(0,i.jsxs)(t.p,{children:["To add a remote cluster, you can simply install this helm chart in the target cluster and namespace: ",(0,i.jsx)(t.a,{href:"https://artifacthub.io/packages/helm/goauthentik/authentik-remote-cluster",children:"https://artifacthub.io/packages/helm/goauthentik/authentik-remote-cluster"})]}),"\n",(0,i.jsx)(t.p,{children:"After installation, the helm chart outputs an example kubeconfig file, that you can enter in authentik to connect to the cluster."})]})}function h(e={}){const{wrapper:t}={...(0,r.R)(),...e.components};return t?(0,i.jsx)(t,{...e,children:(0,i.jsx)(d,{...e})}):d(e)}}}]);