"use strict";(self.webpackChunk_goauthentik_website_docs=self.webpackChunk_goauthentik_website_docs||[]).push([[13992],{85593:(e,i,s)=>{s.r(i),s.d(i,{assets:()=>c,contentTitle:()=>d,default:()=>p,frontMatter:()=>a,metadata:()=>t,toc:()=>h});const t=JSON.parse('{"id":"security/policy","title":"Security Policy","description":"","source":"@site/docs/security/policy.mdx","sourceDirName":"security","slug":"/security/policy","permalink":"/docs/security/policy","draft":false,"unlisted":false,"editUrl":"https://github.com/goauthentik/authentik/edit/main/website/docs/security/policy.mdx","tags":[],"version":"current","frontMatter":{},"sidebar":"docs","previous":{"title":"Security","permalink":"/docs/security"},"next":{"title":"Hardening authentik","permalink":"/docs/security/security-hardening"}}');var n=s(74848),r=s(28453);function l(e){const i={a:"a",h2:"h2",li:"li",ol:"ol",p:"p",table:"table",tbody:"tbody",td:"td",th:"th",thead:"thead",tr:"tr",...(0,r.R)(),...e.components};return(0,n.jsxs)(n.Fragment,{children:[(0,n.jsxs)(i.p,{children:["authentik takes security very seriously. We follow the rules of\xa0",(0,n.jsx)(i.a,{href:"https://en.wikipedia.org/wiki/Responsible_disclosure",children:"responsible disclosure"}),", and we urge our community to do so as well, instead of reporting vulnerabilities publicly. This allows us to patch the issue quickly, announce it's existence and release the fixed version."]}),"\n",(0,n.jsx)(i.h2,{id:"independent-audits-and-pentests",children:"Independent audits and pentests"}),"\n",(0,n.jsxs)(i.p,{children:['We are committed to engaging in regular pentesting and security audits of authentik. Defining and adhering to a cadence of external testing ensures a stronger probability that our code base, our features, and our architecture is as secure and non-exploitable as possible. For more details about specfic audits and pentests, refer to "Audits and Certificates" in our ',(0,n.jsx)(i.a,{href:"https://docs.goauthentik.io/docs/security",children:"Security documentation"}),"."]}),"\n",(0,n.jsx)(i.h2,{id:"what-authentik-classifies-as-a-cve",children:"What authentik classifies as a CVE"}),"\n",(0,n.jsx)(i.p,{children:"CVE (Common Vulnerability and Exposure) is a system designed to aggregate all vulnerabilities. As such, a CVE will be issued when there is a either vulnerability or exposure. Per NIST, A vulnerability is:"}),"\n",(0,n.jsx)(i.p,{children:"\u201cWeakness in an information system, system security procedures, internal controls, or implementation that could be exploited or triggered by a threat source.\u201d"}),"\n",(0,n.jsx)(i.p,{children:"If it is determined that the issue does qualify as a CVE, a CVE number will be issued to the reporter from GitHub."}),"\n",(0,n.jsx)(i.p,{children:"Even if the issue is not a CVE, we still greatly appreciate your help in hardening authentik."}),"\n",(0,n.jsx)(i.h2,{id:"supported-versions",children:"Supported Versions"}),"\n",(0,n.jsx)(i.p,{children:"(.x being the latest patch release for each version)"}),"\n",(0,n.jsxs)(i.table,{children:[(0,n.jsx)(i.thead,{children:(0,n.jsxs)(i.tr,{children:[(0,n.jsx)(i.th,{children:"Version"}),(0,n.jsx)(i.th,{children:"Supported"})]})}),(0,n.jsxs)(i.tbody,{children:[(0,n.jsxs)(i.tr,{children:[(0,n.jsx)(i.td,{children:"2024.12.x"}),(0,n.jsx)(i.td,{children:"\u2705"})]}),(0,n.jsxs)(i.tr,{children:[(0,n.jsx)(i.td,{children:"2025.2.x"}),(0,n.jsx)(i.td,{children:"\u2705"})]})]})]}),"\n",(0,n.jsx)(i.h2,{id:"reporting-a-vulnerability",children:"Reporting a Vulnerability"}),"\n",(0,n.jsxs)(i.p,{children:["To report a vulnerability, send an email to\xa0",(0,n.jsx)(i.a,{href:"mailto:security@goauthentik.io",children:"security@goauthentik.io"}),". Be sure to include relevant information like which version you've found the issue in, instructions on how to reproduce the issue, and anything else that might make it easier for us to find the issue."]}),"\n",(0,n.jsx)(i.h2,{id:"severity-levels",children:"Severity levels"}),"\n",(0,n.jsxs)(i.p,{children:["authentik reserves the right to reclassify CVSS as necessary. To determine severity, we will use the CVSS calculator from NVD (",(0,n.jsx)(i.a,{href:"https://nvd.nist.gov/vuln-metrics/cvss/v3-calculator",children:"https://nvd.nist.gov/vuln-metrics/cvss/v3-calculator"}),"). The calculated CVSS score will then be translated into one of the following categories:"]}),"\n",(0,n.jsxs)(i.table,{children:[(0,n.jsx)(i.thead,{children:(0,n.jsxs)(i.tr,{children:[(0,n.jsx)(i.th,{children:"Score"}),(0,n.jsx)(i.th,{children:"Severity"})]})}),(0,n.jsxs)(i.tbody,{children:[(0,n.jsxs)(i.tr,{children:[(0,n.jsx)(i.td,{children:"0.0"}),(0,n.jsx)(i.td,{children:"None"})]}),(0,n.jsxs)(i.tr,{children:[(0,n.jsx)(i.td,{children:"0.1 \u2013 3.9"}),(0,n.jsx)(i.td,{children:"Low"})]}),(0,n.jsxs)(i.tr,{children:[(0,n.jsx)(i.td,{children:"4.0 \u2013 6.9"}),(0,n.jsx)(i.td,{children:"Medium"})]}),(0,n.jsxs)(i.tr,{children:[(0,n.jsx)(i.td,{children:"7.0 \u2013 8.9"}),(0,n.jsx)(i.td,{children:"High"})]}),(0,n.jsxs)(i.tr,{children:[(0,n.jsx)(i.td,{children:"9.0 \u2013 10.0"}),(0,n.jsx)(i.td,{children:"Critical"})]})]})]}),"\n",(0,n.jsx)(i.h2,{id:"disclosure-process",children:"Disclosure process"}),"\n",(0,n.jsxs)(i.ol,{children:["\n",(0,n.jsx)(i.li,{children:"Report from Github or Issue is reported via Email as listed above."}),"\n",(0,n.jsx)(i.li,{children:"The authentik Security team will try to reproduce the issue and ask for more information if required."}),"\n",(0,n.jsx)(i.li,{children:"A severity level is assigned."}),"\n",(0,n.jsx)(i.li,{children:"A fix is created, and if possible tested by the issue reporter."}),"\n",(0,n.jsx)(i.li,{children:"The fix is backported to other supported versions, and if possible a workaround for other versions is created."}),"\n",(0,n.jsx)(i.li,{children:"An announcement is sent out with a fixed release date and severity level of the issue. The announcement will be sent at least 24 hours before the release of the security fix."}),"\n",(0,n.jsx)(i.li,{children:"The fixed version is released for the supported versions."}),"\n"]}),"\n",(0,n.jsx)(i.h2,{id:"getting-security-notifications",children:"Getting security notifications"}),"\n",(0,n.jsxs)(i.p,{children:["To get security notifications, subscribe to the mailing list\xa0",(0,n.jsx)(i.a,{href:"https://groups.google.com/g/authentik-security-announcements",children:"here"}),"\xa0or join the\xa0",(0,n.jsx)(i.a,{href:"https://goauthentik.io/discord",children:"discord"}),"\xa0server."]})]})}function o(e={}){const{wrapper:i}={...(0,r.R)(),...e.components};return i?(0,n.jsx)(i,{...e,children:(0,n.jsx)(l,{...e})}):l(e)}const a={},d="Security Policy",c={},h=[{value:"Independent audits and pentests",id:"independent-audits-and-pentests",level:2},{value:"What authentik classifies as a CVE",id:"what-authentik-classifies-as-a-cve",level:2},{value:"Supported Versions",id:"supported-versions",level:2},{value:"Reporting a Vulnerability",id:"reporting-a-vulnerability",level:2},{value:"Severity levels",id:"severity-levels",level:2},{value:"Disclosure process",id:"disclosure-process",level:2},{value:"Getting security notifications",id:"getting-security-notifications",level:2}];function u(e){const i={h1:"h1",header:"header",...(0,r.R)(),...e.components};return(0,n.jsxs)(n.Fragment,{children:[(0,n.jsx)(i.header,{children:(0,n.jsx)(i.h1,{id:"security-policy",children:"Security Policy"})}),"\n","\n",(0,n.jsx)(o,{})]})}function p(e={}){const{wrapper:i}={...(0,r.R)(),...e.components};return i?(0,n.jsx)(i,{...e,children:(0,n.jsx)(u,{...e})}):u(e)}}}]);