"use strict";(self.webpackChunk_goauthentik_website_docs=self.webpackChunk_goauthentik_website_docs||[]).push([[28235],{97229:(e,t,a)=>{a.r(t),a.d(t,{assets:()=>d,contentTitle:()=>o,default:()=>l,frontMatter:()=>r,metadata:()=>i,toc:()=>h});const i=JSON.parse('{"id":"add-secure-apps/providers/ssf/index","title":"Shared Signals Framework (SSF) Provider","description":"Preview","source":"@site/docs/add-secure-apps/providers/ssf/index.md","sourceDirName":"add-secure-apps/providers/ssf","slug":"/add-secure-apps/providers/ssf/","permalink":"/docs/add-secure-apps/providers/ssf/","draft":false,"unlisted":false,"editUrl":"https://github.com/goauthentik/authentik/edit/main/website/docs/add-secure-apps/providers/ssf/index.md","tags":[],"version":"current","frontMatter":{"title":"Shared Signals Framework (SSF) Provider","sidebar_label":"SSF Provider"},"sidebar":"docs","previous":{"title":"SCIM Provider","permalink":"/docs/add-secure-apps/providers/scim/"},"next":{"title":"Configure an SSF provider","permalink":"/docs/add-secure-apps/providers/ssf/create-ssf-provider"}}');var s=a(74848),n=a(28453);const r={title:"Shared Signals Framework (SSF) Provider",sidebar_label:"SSF Provider"},o=void 0,d={},h=[{value:"About Shared Signals Framework",id:"about-shared-signals-framework",level:2},{value:"Example use cases",id:"example-use-cases",level:2},{value:"About using SSF in authentik",id:"about-using-ssf-in-authentik",level:2},{value:"The application (the receiver)",id:"the-application-the-receiver",level:3},{value:"authentik (the transmitter)",id:"authentik-the-transmitter",level:3}];function c(e){const t={a:"a",admonition:"admonition",code:"code",em:"em",h2:"h2",h3:"h3",p:"p",strong:"strong",...(0,n.R)(),...e.components};return(0,s.jsxs)(s.Fragment,{children:[(0,s.jsxs)(t.p,{children:[(0,s.jsx)("span",{class:"badge badge--preview",children:"Preview"}),"\n",(0,s.jsx)("span",{class:"badge badge--version",children:"authentik 2025.2+"}),"\n\xa0"]}),"\n",(0,s.jsxs)(t.p,{children:["Shared Signals Framework (SSF) is a common standard for sharing asynchronous real-time security signals and events across multiple applications and an identity provider. The framework is a collection of standards and communication processes, documented in a ",(0,s.jsx)(t.a,{href:"https://openid.net/specs/openid-sharedsignals-framework-1_0-ID3.html",children:"specification"}),". SSF leverages the APIs of the application and the IdP, using privacy-protected, secure webhooks."]}),"\n",(0,s.jsx)(t.h2,{id:"about-shared-signals-framework",children:"About Shared Signals Framework"}),"\n",(0,s.jsxs)(t.p,{children:["In authentik, an SSF provider allows applications to subscribe to certain types of security signals (which are then translated into SETs, or Security Event Tokens) that are captured by authentik (the IdP), and then the application can respond to each event. In this scenario, authentik acts as the ",(0,s.jsx)(t.em,{children:"transmitter"})," and the application acts as the ",(0,s.jsx)(t.em,{children:"receiver"})," of the events."]}),"\n",(0,s.jsx)(t.p,{children:"Events in authentik that are tracked via SSF include when an MFA device is added or removed, logouts, sessions being revoked by Admin or user clicking logout, or credentials changed."}),"\n",(0,s.jsx)(t.h2,{id:"example-use-cases",children:"Example use cases"}),"\n",(0,s.jsx)(t.p,{children:"A common use case for SSF is when an Admin wants to know if a user logs out of authentik, so that the user is then also automaticlaly logged out of all other work-focused applications."}),"\n",(0,s.jsx)(t.p,{children:"Another example use case is when an application uses SSF to subscribe to authorization events because the application needs to know if a user changed their password in authentik. If a user did change their password, then the application receives a POST request to write the fact that the password was changed."}),"\n",(0,s.jsx)(t.h2,{id:"about-using-ssf-in-authentik",children:"About using SSF in authentik"}),"\n",(0,s.jsx)(t.p,{children:"Let's look at a few details about using SSF in authentik."}),"\n",(0,s.jsxs)(t.p,{children:["The SSF provider in authentik serves as a ",(0,s.jsx)(t.a,{href:"../../applications/manage_apps#backchannel-providers",children:"backchannel provider"}),". Backchannel providers are used to augment the functionality of the main provider for an application. Thus you will still need to ",(0,s.jsx)(t.a,{href:"../../applications/manage_apps#instructions",children:"create a typical application/provider pair"})," (using an OIDC provider), and when creating the application, assign the SSF provider as a backchannel provider."]}),"\n",(0,s.jsxs)(t.p,{children:["When an authentik Admin ",(0,s.jsx)(t.a,{href:"./create-ssf-provider",children:"creates an SSF provider"}),", they need to configure both the application (the receiver) and authentik (the IdP and the transmitter)."]}),"\n",(0,s.jsx)(t.h3,{id:"the-application-the-receiver",children:"The application (the receiver)"}),"\n",(0,s.jsxs)(t.p,{children:["Within the application, the admin creates an SSF stream (which comprises all the signals that the app wants to subscribe to) and defines the audience, called ",(0,s.jsx)(t.code,{children:"aud"})," in the specification (the URL that identifies the stream). A stream is basically an API request to authentik, which asks for a POST of all events. How that request is sent varies from application to application. An application can change or delete the stream."]}),"\n",(0,s.jsx)(t.p,{children:"Note that authentik doesn't specify which events to subscribe to; instead the application defines which they want to listen for."}),"\n",(0,s.jsx)(t.h3,{id:"authentik-the-transmitter",children:"authentik (the transmitter)"}),"\n",(0,s.jsxs)(t.p,{children:["To configure authentik as a shared signals transmitter, the authentik Admin ",(0,s.jsx)(t.a,{href:"./create-ssf-provider",children:"creates a new provider"}),', selecting the type "SSF", to serve as the backchannelprovider for the application.']}),"\n",(0,s.jsx)(t.p,{children:"When creating the SSF provider you will need to select a signing key. This is the key that the Security Event Tokens (SET) is signed with."}),"\n",(0,s.jsx)(t.p,{children:"Optionally, you can specify a event retention time period: this value determines how long events are stored for. If an event could not be sent correctly, and retries occur, the event's expiration is also increased by this duration."}),"\n",(0,s.jsx)(t.admonition,{type:"info",children:(0,s.jsxs)(t.p,{children:["Be aware that the SET events are different events than those displayed in the authentik Admin interface under ",(0,s.jsx)(t.strong,{children:"Events"}),"."]})})]})}function l(e={}){const{wrapper:t}={...(0,n.R)(),...e.components};return t?(0,s.jsx)(t,{...e,children:(0,s.jsx)(c,{...e})}):c(e)}}}]);