"use strict";(self.webpackChunk_goauthentik_website_docs=self.webpackChunk_goauthentik_website_docs||[]).push([[27582],{98444:(e,s,r)=>{r.r(s),r.d(s,{assets:()=>p,contentTitle:()=>a,default:()=>u,frontMatter:()=>i,metadata:()=>o,toc:()=>c});const o=JSON.parse('{"id":"users-sources/sources/property-mappings/index","title":"Source property mappings","description":"Source property mappings allow you to modify or gather extra information from sources.","source":"@site/docs/users-sources/sources/property-mappings/index.md","sourceDirName":"users-sources/sources/property-mappings","slug":"/users-sources/sources/property-mappings/","permalink":"/docs/users-sources/sources/property-mappings/","draft":false,"unlisted":false,"editUrl":"https://github.com/goauthentik/authentik/edit/main/website/docs/users-sources/sources/property-mappings/index.md","tags":[],"version":"current","frontMatter":{"title":"Source property mappings"},"sidebar":"docs","previous":{"title":"SCIM Source","permalink":"/docs/users-sources/sources/protocols/scim/"},"next":{"title":"Sources expression property mappings","permalink":"/docs/users-sources/sources/property-mappings/expressions"}}');var t=r(74848),n=r(28453);const i={title:"Source property mappings"},a=void 0,p={},c=[{value:"Create a custom source property mapping",id:"create-a-custom-source-property-mapping",level:2},{value:"How it works",id:"how-it-works",level:2},{value:"Expression semantics",id:"expression-semantics",level:3},{value:"Object construction process",id:"object-construction-process",level:3},{value:"Group synchronization",id:"group-synchronization",level:3}];function l(e){const s={a:"a",code:"code",h2:"h2",h3:"h3",li:"li",ol:"ol",p:"p",pre:"pre",strong:"strong",ul:"ul",...(0,n.R)(),...e.components};return(0,t.jsxs)(t.Fragment,{children:[(0,t.jsx)(s.p,{children:"Source property mappings allow you to modify or gather extra information from sources."}),"\n",(0,t.jsx)(s.p,{children:"This page is an overview of how property mappings work. For information about specific protocol, please refer to each protocol page:"}),"\n",(0,t.jsxs)(s.ul,{children:["\n",(0,t.jsx)(s.li,{children:(0,t.jsx)(s.a,{href:"../protocols/kerberos/#kerberos-source-property-mappings",children:"Kerberos"})}),"\n",(0,t.jsx)(s.li,{children:(0,t.jsx)(s.a,{href:"/docs/users-sources/sources/protocols/ldap/#ldap-source-property-mappings",children:"LDAP"})}),"\n",(0,t.jsx)(s.li,{children:(0,t.jsx)(s.a,{href:"/docs/users-sources/sources/protocols/oauth/#oauth-source-property-mappings",children:"OAuth"})}),"\n",(0,t.jsx)(s.li,{children:(0,t.jsx)(s.a,{href:"/docs/users-sources/sources/protocols/saml/#saml-source-property-mappings",children:"SAML"})}),"\n",(0,t.jsx)(s.li,{children:(0,t.jsx)(s.a,{href:"/docs/users-sources/sources/protocols/scim/#scim-source-property-mappings",children:"SCIM"})}),"\n"]}),"\n",(0,t.jsx)(s.h2,{id:"create-a-custom-source-property-mapping",children:"Create a custom source property mapping"}),"\n",(0,t.jsx)(s.p,{children:"If the default source mappings are not enough, or if you need to get additional data from the source, you can create your own custom source property mappings."}),"\n",(0,t.jsx)(s.p,{children:"Here are the steps:"}),"\n",(0,t.jsxs)(s.ol,{children:["\n",(0,t.jsxs)(s.li,{children:["In authentik, open the Admin interface, and then navigate to ",(0,t.jsx)(s.strong,{children:"Customization -> Property Mappings"}),"."]}),"\n",(0,t.jsxs)(s.li,{children:["Click ",(0,t.jsx)(s.strong,{children:"Create"}),", select the property mapping type for your source, and then click ",(0,t.jsx)(s.strong,{children:"Next"}),"."]}),"\n",(0,t.jsxs)(s.li,{children:["Type a unique and meaningful ",(0,t.jsx)(s.strong,{children:"Name"}),", such as ",(0,t.jsx)(s.code,{children:"ldap-displayName-mapping:name"}),"."]}),"\n",(0,t.jsxs)(s.li,{children:["In the ",(0,t.jsx)(s.strong,{children:"Expression"})," field enter Python expressions to retrieve the value from the source. See ",(0,t.jsx)(s.a,{href:"#expression-semantics",children:"Expression Semantics"})," below for details."]}),"\n",(0,t.jsxs)(s.li,{children:["In the source configuration, select the newly created property mapping as a ",(0,t.jsx)(s.strong,{children:"User property mapping"})," if it applies to users, or ",(0,t.jsx)(s.strong,{children:"Group property mapping"})," if it applies to groups."]}),"\n"]}),"\n",(0,t.jsx)(s.h2,{id:"how-it-works",children:"How it works"}),"\n",(0,t.jsx)(s.h3,{id:"expression-semantics",children:"Expression semantics"}),"\n",(0,t.jsxs)(s.p,{children:["Each source provides the Python expression with additional data. You can import parts of that data into authentik users and groups. Assuming the source provides us with a ",(0,t.jsx)(s.code,{children:"data"})," Python dictionary, you can write the following:"]}),"\n",(0,t.jsx)(s.pre,{children:(0,t.jsx)(s.code,{className:"language-python",children:'return {\n    "name": data.get("displayName"),\n}\n'})}),"\n",(0,t.jsxs)(s.p,{children:["You can see that the expression returns a Python dictionary. The dictionary keys must match ",(0,t.jsx)(s.a,{href:"/docs/users-sources/user/user_ref#object-properties",children:"User properties"})," or ",(0,t.jsx)(s.a,{href:"/docs/users-sources/groups/group_ref#object-properties",children:"Group properties"}),". Note that for users, ",(0,t.jsx)(s.code,{children:"ak_groups"})," and ",(0,t.jsx)(s.code,{children:"group_attributes"})," cannot be set."]}),"\n",(0,t.jsxs)(s.p,{children:["See each source documentation for a reference of the available data. See the authentik ",(0,t.jsx)(s.a,{href:"/docs/users-sources/sources/property-mappings/expressions",children:"expressions documentation"})," for available data and functions."]}),"\n",(0,t.jsxs)(s.p,{children:["Note that the ",(0,t.jsx)(s.a,{href:"/docs/users-sources/sources/property-mappings/expressions#list_flattenvalue-listany--any---optionalany",children:(0,t.jsx)(s.code,{children:"list_flatten"})})," method is applied for all top-level properties, but not for attributes:"]}),"\n",(0,t.jsx)(s.pre,{children:(0,t.jsx)(s.code,{className:"language-python",children:'return {\n    "username": data.get("username"), # list_flatten is automatically applied to top-level attributes\n    "attributes": {\n        "phone": list_flatten(data.get("phoneNumber")), # but not for attributes!\n    },\n}\n'})}),"\n",(0,t.jsx)(s.h3,{id:"object-construction-process",children:"Object construction process"}),"\n",(0,t.jsx)(s.p,{children:"A user or group object is constructed as follows:"}),"\n",(0,t.jsxs)(s.ol,{children:["\n",(0,t.jsx)(s.li,{children:"The source provides initial properties based on commonly used data."}),"\n",(0,t.jsxs)(s.li,{children:["Each property mapping associated with the source is run and results are merged into the previous properties.","\n",(0,t.jsxs)(s.ul,{children:["\n",(0,t.jsx)(s.li,{children:"If a property mapping throws an error, the process is aborted. If that happens inside a synchronization process, the object is skipped. If it happens during an enrollment or authentication flow, the flow is cancelled."}),"\n",(0,t.jsxs)(s.li,{children:["If a property mapping sets one attribute to ",(0,t.jsx)(s.code,{children:"None"}),", that attribute is then discarded."]}),"\n"]}),"\n"]}),"\n",(0,t.jsxs)(s.li,{children:["If the ",(0,t.jsx)(s.code,{children:"username"})," field is not set for user objects, or the ",(0,t.jsx)(s.code,{children:"name"})," field is not set for group objects, the process is aborted."]}),"\n",(0,t.jsxs)(s.li,{children:["The object is created or updated. The ",(0,t.jsx)(s.code,{children:"attributes"})," property is merged with existing data if the object already exists."]}),"\n"]}),"\n",(0,t.jsx)(s.h3,{id:"group-synchronization",children:"Group synchronization"}),"\n",(0,t.jsx)(s.p,{children:"LDAP and SCIM sources have built-in mechanisms to get groups. This section does not apply to them."}),"\n",(0,t.jsx)(s.p,{children:"You can write a custom property mapping to set the user's groups:"}),"\n",(0,t.jsx)(s.pre,{children:(0,t.jsx)(s.code,{className:"language-python",children:'return {\n    "groups": data.get("groups", []),\n}\n'})}),"\n",(0,t.jsxs)(s.p,{children:["The ",(0,t.jsx)(s.code,{children:"groups"})," attribute is a special attribute that must contain group identifiers. By default, those identifiers are also used as the group name by default, those identifiers are also used as the group name. Each of those identifiers is then given to group property mappings as the ",(0,t.jsx)(s.code,{children:"group_id"})," variable, if extra processing needs to happen."]})]})}function u(e={}){const{wrapper:s}={...(0,n.R)(),...e.components};return s?(0,t.jsx)(s,{...e,children:(0,t.jsx)(l,{...e})}):l(e)}}}]);