"use strict";(self.webpackChunk_goauthentik_website_docs=self.webpackChunk_goauthentik_website_docs||[]).push([[19430],{18526:(e,s,n)=>{n.r(s),n.d(s,{assets:()=>c,contentTitle:()=>r,default:()=>h,frontMatter:()=>o,metadata:()=>i,toc:()=>l});const i=JSON.parse('{"id":"customize/blueprints/v1/models","title":"Models","description":"Some models behave differently and allow for access to different API fields when created via blueprint.","source":"@site/docs/customize/blueprints/v1/models.md","sourceDirName":"customize/blueprints/v1","slug":"/customize/blueprints/v1/models","permalink":"/docs/customize/blueprints/v1/models","draft":false,"unlisted":false,"editUrl":"https://github.com/goauthentik/authentik/edit/main/website/docs/customize/blueprints/v1/models.md","tags":[],"version":"current","frontMatter":{},"sidebar":"docs","previous":{"title":"Example","permalink":"/docs/customize/blueprints/v1/example"},"next":{"title":"Meta models","permalink":"/docs/customize/blueprints/v1/meta"}}');var t=n(74848),a=n(28453);const o={},r="Models",c={},l=[{value:"<code>authentik_core.token</code>",id:"authentik_coretoken",level:2},{value:'<code>key</code> <span class="badge badge--version">authentik 2023.4+</span>',id:"key-authentik-20234",level:3},{value:"<code>authentik_core.user</code>",id:"authentik_coreuser",level:2},{value:'<code>password</code> <span class="badge badge--version">authentik 2023.6+</span>',id:"password-authentik-20236",level:3},{value:'<code>permissions</code> <span class="badge badge--version">authentik 2024.8+</span>',id:"permissions-authentik-20248",level:3},{value:"<code>authentik_core.application</code>",id:"authentik_coreapplication",level:2},{value:'<code>icon</code> <span class="badge badge--version">authentik 2023.5+</span>',id:"icon-authentik-20235",level:3},{value:"<code>authentik_sources_oauth.oauthsource</code>, <code>authentik_sources_saml.samlsource</code>, <code>authentik_sources_plex.plexsource</code>",id:"authentik_sources_oauthoauthsource-authentik_sources_samlsamlsource-authentik_sources_plexplexsource",level:2},{value:'<code>icon</code> <span class="badge badge--version">authentik 2023.5+</span>',id:"icon-authentik-20235-1",level:3},{value:"<code>authentik_flows.flow</code>",id:"authentik_flowsflow",level:2},{value:'<code>icon</code> <span class="badge badge--version">authentik 2023.5+</span>',id:"icon-authentik-20235-2",level:3},{value:"<code>authentik_rbac.role</code>",id:"authentik_rbacrole",level:2},{value:'<code>permissions</code> <span class="badge badge--version">authentik 2024.8+</span>',id:"permissions-authentik-20248-1",level:3}];function d(e){const s={code:"code",h1:"h1",h2:"h2",h3:"h3",header:"header",p:"p",pre:"pre",...(0,a.R)(),...e.components};return(0,t.jsxs)(t.Fragment,{children:[(0,t.jsx)(s.header,{children:(0,t.jsx)(s.h1,{id:"models",children:"Models"})}),"\n",(0,t.jsx)(s.p,{children:"Some models behave differently and allow for access to different API fields when created via blueprint."}),"\n",(0,t.jsx)(s.h2,{id:"authentik_coretoken",children:(0,t.jsx)(s.code,{children:"authentik_core.token"})}),"\n",(0,t.jsxs)(s.h3,{id:"key-authentik-20234",children:[(0,t.jsx)(s.code,{children:"key"})," ",(0,t.jsx)("span",{class:"badge badge--version",children:"authentik 2023.4+"})]}),"\n",(0,t.jsx)(s.p,{children:"Via the standard API, a token's key cannot be changed, it can only be rotated. This is to ensure a high entropy in it's key, and to prevent insecure data from being used. However, when provisioning tokens via a blueprint, it may be required to set a token to an existing value."}),"\n",(0,t.jsxs)(s.p,{children:["With blueprints, the field ",(0,t.jsx)(s.code,{children:"key"})," can be set, to set the token's key to any value."]}),"\n",(0,t.jsx)(s.p,{children:"For example:"}),"\n",(0,t.jsx)(s.pre,{children:(0,t.jsx)(s.code,{className:"language-yaml",children:"# [...]\n- model: authentik_core.token\n  state: present\n  identifiers:\n      identifier: my-token\n  attrs:\n      key: this-should-be-a-long-value\n      user: !KeyOf my-user\n      intent: api\n"})}),"\n",(0,t.jsx)(s.h2,{id:"authentik_coreuser",children:(0,t.jsx)(s.code,{children:"authentik_core.user"})}),"\n",(0,t.jsxs)(s.h3,{id:"password-authentik-20236",children:[(0,t.jsx)(s.code,{children:"password"})," ",(0,t.jsx)("span",{class:"badge badge--version",children:"authentik 2023.6+"})]}),"\n",(0,t.jsxs)(s.p,{children:["Via the standard API, a user's password can only be set via the separate ",(0,t.jsx)(s.code,{children:"/api/v3/core/users/<id>/set_password/"})," endpoint. In blueprints, the password of a user can be set using the ",(0,t.jsx)(s.code,{children:"password"})," field."]}),"\n",(0,t.jsx)(s.p,{children:"Keep in mind that if an LDAP\xa0Source is configured and the user maps to an LDAP user, this password change will be propagated to the LDAP server."}),"\n",(0,t.jsx)(s.p,{children:"For example:"}),"\n",(0,t.jsx)(s.pre,{children:(0,t.jsx)(s.code,{className:"language-yaml",children:"# [...]\n- model: authentik_core.user\n  state: present\n  identifiers:\n      username: test-user\n  attrs:\n      name: test user\n      password: this-should-be-a-long-value\n"})}),"\n",(0,t.jsxs)(s.h3,{id:"permissions-authentik-20248",children:[(0,t.jsx)(s.code,{children:"permissions"})," ",(0,t.jsx)("span",{class:"badge badge--version",children:"authentik 2024.8+"})]}),"\n",(0,t.jsxs)(s.p,{children:["The ",(0,t.jsx)(s.code,{children:"permissions"})," field can be used to set global permissions for a user. A full list of possible permissions is included in the JSON schema for blueprints."]}),"\n",(0,t.jsx)(s.p,{children:"For example:"}),"\n",(0,t.jsx)(s.pre,{children:(0,t.jsx)(s.code,{className:"language-yaml",children:"# [...]\n- model: authentik_core.user\n  identifiers:\n      username: test-user\n  attrs:\n      permissions:\n          - authentik_blueprints.view_blueprintinstance\n"})}),"\n",(0,t.jsx)(s.h2,{id:"authentik_coreapplication",children:(0,t.jsx)(s.code,{children:"authentik_core.application"})}),"\n",(0,t.jsxs)(s.h3,{id:"icon-authentik-20235",children:[(0,t.jsx)(s.code,{children:"icon"})," ",(0,t.jsx)("span",{class:"badge badge--version",children:"authentik 2023.5+"})]}),"\n",(0,t.jsxs)(s.p,{children:["Application icons can be directly set to URLs with the ",(0,t.jsx)(s.code,{children:"icon"})," field."]}),"\n",(0,t.jsx)(s.p,{children:"For example:"}),"\n",(0,t.jsx)(s.pre,{children:(0,t.jsx)(s.code,{className:"language-yaml",children:"# [...]\n- model: authentik_core.application\n  identifiers:\n      slug: my-app\n  attrs:\n      name: My App\n      icon: https://goauthentik.io/img/icon.png\n"})}),"\n",(0,t.jsxs)(s.h2,{id:"authentik_sources_oauthoauthsource-authentik_sources_samlsamlsource-authentik_sources_plexplexsource",children:[(0,t.jsx)(s.code,{children:"authentik_sources_oauth.oauthsource"}),", ",(0,t.jsx)(s.code,{children:"authentik_sources_saml.samlsource"}),", ",(0,t.jsx)(s.code,{children:"authentik_sources_plex.plexsource"})]}),"\n",(0,t.jsxs)(s.h3,{id:"icon-authentik-20235-1",children:[(0,t.jsx)(s.code,{children:"icon"})," ",(0,t.jsx)("span",{class:"badge badge--version",children:"authentik 2023.5+"})]}),"\n",(0,t.jsxs)(s.p,{children:["Source icons can be directly set to URLs with the ",(0,t.jsx)(s.code,{children:"icon"})," field."]}),"\n",(0,t.jsx)(s.p,{children:"For example:"}),"\n",(0,t.jsx)(s.pre,{children:(0,t.jsx)(s.code,{className:"language-yaml",children:"# [...]\n- model: authentik_sources_oauth.oauthsource\n  identifiers:\n      slug: my-source\n  attrs:\n      name: My source\n      icon: https://goauthentik.io/img/icon.png\n"})}),"\n",(0,t.jsx)(s.h2,{id:"authentik_flowsflow",children:(0,t.jsx)(s.code,{children:"authentik_flows.flow"})}),"\n",(0,t.jsxs)(s.h3,{id:"icon-authentik-20235-2",children:[(0,t.jsx)(s.code,{children:"icon"})," ",(0,t.jsx)("span",{class:"badge badge--version",children:"authentik 2023.5+"})]}),"\n",(0,t.jsxs)(s.p,{children:["Flow backgrounds can be directly set to URLs with the ",(0,t.jsx)(s.code,{children:"background"})," field."]}),"\n",(0,t.jsx)(s.p,{children:"For example:"}),"\n",(0,t.jsx)(s.pre,{children:(0,t.jsx)(s.code,{className:"language-yaml",children:"# [...]\n- model: authentik_flows.flow\n  identifiers:\n      slug: my-flow\n  attrs:\n      name: my-flow\n      title: My flow\n      designation: authentication\n      background: https://goauthentik.io/img/icon.png\n"})}),"\n",(0,t.jsx)(s.h2,{id:"authentik_rbacrole",children:(0,t.jsx)(s.code,{children:"authentik_rbac.role"})}),"\n",(0,t.jsxs)(s.h3,{id:"permissions-authentik-20248-1",children:[(0,t.jsx)(s.code,{children:"permissions"})," ",(0,t.jsx)("span",{class:"badge badge--version",children:"authentik 2024.8+"})]}),"\n",(0,t.jsxs)(s.p,{children:["The ",(0,t.jsx)(s.code,{children:"permissions"})," field can be used to set global permissions for a role. A full list of possible permissions is included in the JSON schema for blueprints."]}),"\n",(0,t.jsx)(s.p,{children:"For example:"}),"\n",(0,t.jsx)(s.pre,{children:(0,t.jsx)(s.code,{className:"language-yaml",children:"# [...]\n- model: authentik_rbac.role\n  identifiers:\n      name: test-role\n  attrs:\n      permissions:\n          - authentik_blueprints.view_blueprintinstance\n"})})]})}function h(e={}){const{wrapper:s}={...(0,a.R)(),...e.components};return s?(0,t.jsx)(s,{...e,children:(0,t.jsx)(d,{...e})}):d(e)}}}]);