"use strict";(self.webpackChunk_goauthentik_website_docs=self.webpackChunk_goauthentik_website_docs||[]).push([[386],{99445:(e,s,t)=>{t.r(s),t.d(s,{assets:()=>c,contentTitle:()=>a,default:()=>h,frontMatter:()=>r,metadata:()=>i,toc:()=>d});const i=JSON.parse('{"id":"sys-mgmt/ops/storage-s3","title":"S3 storage setup","description":"Preparation","source":"@site/docs/sys-mgmt/ops/storage-s3.md","sourceDirName":"sys-mgmt/ops","slug":"/sys-mgmt/ops/storage-s3","permalink":"/docs/sys-mgmt/ops/storage-s3","draft":false,"unlisted":false,"editUrl":"https://github.com/goauthentik/authentik/edit/main/website/docs/sys-mgmt/ops/storage-s3.md","tags":[],"version":"current","frontMatter":{"title":"S3 storage setup"},"sidebar":"docs","previous":{"title":"Monitoring","permalink":"/docs/sys-mgmt/ops/monitoring"},"next":{"title":"GeoIP","permalink":"/docs/sys-mgmt/ops/geoip"}}');var n=t(74848),o=t(28453);const r={title:"S3 storage setup"},a=void 0,c={},d=[{value:"Preparation",id:"preparation",level:3},{value:"S3 configuration",id:"s3-configuration",level:3},{value:"Bucket creation",id:"bucket-creation",level:4},{value:"CORS policy",id:"cors-policy",level:4},{value:"Configuring authentik",id:"configuring-authentik",level:3},{value:"Migrating between storage backends",id:"migrating-between-storage-backends",level:3},{value:"From file to s3",id:"from-file-to-s3",level:4},{value:"From s3 to file",id:"from-s3-to-file",level:4}];function l(e){const s={a:"a",code:"code",h3:"h3",h4:"h4",p:"p",pre:"pre",...(0,o.R)(),...e.components};return(0,n.jsxs)(n.Fragment,{children:[(0,n.jsx)(s.h3,{id:"preparation",children:"Preparation"}),"\n",(0,n.jsxs)(s.p,{children:["First, create a user on your S3 storage provider and get access credentials for S3, hereafter referred as ",(0,n.jsx)(s.code,{children:"access_key"})," and ",(0,n.jsx)(s.code,{children:"secret_key"}),"."]}),"\n",(0,n.jsxs)(s.p,{children:["You will also need to know which endpoint authentik is going to use to access the S3 API, hereafter referred as ",(0,n.jsx)(s.code,{children:"https://s3.provider"}),"."]}),"\n",(0,n.jsxs)(s.p,{children:["The bucket in which authentik is going to store files is going to be called ",(0,n.jsx)(s.code,{children:"authentik-media"}),". You may need to change this name depending on your S3 provider limitations. Also, we are suffixing the bucket name with ",(0,n.jsx)(s.code,{children:"-media"})," as authentik currently only stores media files, but may use other buckets in the future."]}),"\n",(0,n.jsxs)(s.p,{children:["The domain used to access authentik is going to be referred to as ",(0,n.jsx)(s.code,{children:"authentik.company"}),"."]}),"\n",(0,n.jsx)(s.p,{children:"You will also need the AWS\xa0CLI."}),"\n",(0,n.jsx)(s.h3,{id:"s3-configuration",children:"S3 configuration"}),"\n",(0,n.jsx)(s.h4,{id:"bucket-creation",children:"Bucket creation"}),"\n",(0,n.jsx)(s.p,{children:"Create the bucket in which authentik is going to store files:"}),"\n",(0,n.jsx)(s.pre,{children:(0,n.jsx)(s.code,{className:"language-bash",children:"AWS_ACCESS_KEY_ID=access_key AWS_SECRET_ACCESS_KEY=secret_key aws s3api --endpoint-url=https://s3.provider create-bucket --bucket=authentik-media --acl=private\n"})}),"\n",(0,n.jsxs)(s.p,{children:["If using AWS S3, you can omit the ",(0,n.jsx)(s.code,{children:"--endpoint-url"})," option, but may need to specify the ",(0,n.jsx)(s.code,{children:"--region"})," option. If using Google Cloud Storage, refer to its documentation on how to create buckets."]}),"\n",(0,n.jsx)(s.p,{children:"The bucket ACL is set to private, although that is not strictly necessary, as an ACL associated with each object stored in the bucket will be private as well."}),"\n",(0,n.jsx)(s.h4,{id:"cors-policy",children:"CORS policy"}),"\n",(0,n.jsx)(s.p,{children:"Next, associate a CORS policy to the bucket to allow the authentik web interface to show images stored in the bucket."}),"\n",(0,n.jsxs)(s.p,{children:["First, save the following file locally as ",(0,n.jsx)(s.code,{children:"cors.json"}),":"]}),"\n",(0,n.jsx)(s.pre,{children:(0,n.jsx)(s.code,{className:"language-json",children:'{\n    "CORSRules": [\n        {\n            "AllowedOrigins": ["authentik.company"],\n            "AllowedHeaders": ["Authorization"],\n            "AllowedMethods": ["GET"],\n            "MaxAgeSeconds": 3000\n        }\n    ]\n}\n'})}),"\n",(0,n.jsxs)(s.p,{children:["If authentik is accessed from multiple domains, you can add them to the ",(0,n.jsx)(s.code,{children:"AllowedOrigins"})," list."]}),"\n",(0,n.jsx)(s.p,{children:"Apply that policy to the bucket:"}),"\n",(0,n.jsx)(s.pre,{children:(0,n.jsx)(s.code,{className:"language-bash",children:"AWS_ACCESS_KEY_ID=access_key AWS_SECRET_ACCESS_KEY=secret_key aws s3api --endpoint-url=https://s3.provider put-bucket-cors --bucket=authentik-media --cors-configuration=file://cors.json\n"})}),"\n",(0,n.jsx)(s.h3,{id:"configuring-authentik",children:"Configuring authentik"}),"\n",(0,n.jsxs)(s.p,{children:["Add the following to your ",(0,n.jsx)(s.code,{children:".env"})," file:"]}),"\n",(0,n.jsx)(s.pre,{children:(0,n.jsx)(s.code,{className:"language-env",children:"AUTHENTIK_STORAGE__MEDIA__BACKEND=s3\nAUTHENTIK_STORAGE__MEDIA__S3__ACCESS_KEY=access_key\nAUTHENTIK_STORAGE__MEDIA__S3__SECRET_KEY=secret_key\nAUTHENTIK_STORAGE__MEDIA__S3__BUCKET_NAME=authentik-media\n"})}),"\n",(0,n.jsx)(s.p,{children:"If you are using AWS S3 as your S3 provider, add the following:"}),"\n",(0,n.jsx)(s.pre,{children:(0,n.jsx)(s.code,{className:"language-env",children:"AUTHENTIK_STORAGE__MEDIA__S3__REGION=us-east-1  # Use the region of the bucket\n"})}),"\n",(0,n.jsx)(s.p,{children:"If you are not using AWS S3 as your S3 provider, add the following:"}),"\n",(0,n.jsx)(s.pre,{children:(0,n.jsx)(s.code,{className:"language-env",children:"AUTHENTIK_STORAGE__MEDIA__S3__ENDPOINT=https://s3.provider\nAUTHENTIK_STORAGE__MEDIA__S3__CUSTOM_DOMAIN=s3.provider/authentik-media\n"})}),"\n",(0,n.jsxs)(s.p,{children:["The ",(0,n.jsx)(s.code,{children:"ENDPOINT"})," setting specifies how authentik talks to the S3 provider."]}),"\n",(0,n.jsxs)(s.p,{children:["The ",(0,n.jsx)(s.code,{children:"CUSTOM_DOMAIN"})," setting specifies how URLs are constructed to be shown on the web interface. For example, an object stored at ",(0,n.jsx)(s.code,{children:"application-icons/application.png"})," with a ",(0,n.jsx)(s.code,{children:"CUSTOM__DOMAIN"})," setting of ",(0,n.jsx)(s.code,{children:"s3.provider/authentik-media"})," will result in a URL of ",(0,n.jsx)(s.code,{children:"https://s3.provider/authentik-media/application-icons/application.png"}),". You can also use subdomains for your buckets depending on what your S3 provider offers: ",(0,n.jsx)(s.code,{children:"authentik-media.s3.provider"}),". Whether HTTPS is used is controlled by ",(0,n.jsx)(s.code,{children:"AUTHENTIK_STORAGE__MEDIA__S3__SECURE_URLS"}),", which defaults to true."]}),"\n",(0,n.jsxs)(s.p,{children:["For more control over settings, refer to the ",(0,n.jsx)(s.a,{href:"/docs/install-config/configuration/#media-storage-settings",children:"configuration reference"})]}),"\n",(0,n.jsx)(s.h3,{id:"migrating-between-storage-backends",children:"Migrating between storage backends"}),"\n",(0,n.jsxs)(s.p,{children:["The following section assumes that the local storage path is ",(0,n.jsx)(s.code,{children:"/media"})," and the bucket name is ",(0,n.jsx)(s.code,{children:"authentik-media"}),". It also assumes you have a working ",(0,n.jsx)(s.code,{children:"aws"})," CLI that can interact with the bucket."]}),"\n",(0,n.jsx)(s.h4,{id:"from-file-to-s3",children:"From file to s3"}),"\n",(0,n.jsx)(s.p,{children:"Follow the setup steps above, and then migrate the files from your local directory to s3:"}),"\n",(0,n.jsx)(s.pre,{children:(0,n.jsx)(s.code,{className:"language-bash",children:"aws s3 sync /media s3://authentik-media/media\n"})}),"\n",(0,n.jsx)(s.h4,{id:"from-s3-to-file",children:"From s3 to file"}),"\n",(0,n.jsx)(s.pre,{children:(0,n.jsx)(s.code,{className:"language-bash",children:"aws s3 sync s3://authentik-media/media /media\n"})})]})}function h(e={}){const{wrapper:s}={...(0,o.R)(),...e.components};return s?(0,n.jsx)(s,{...e,children:(0,n.jsx)(l,{...e})}):l(e)}}}]);