"use strict";(self.webpackChunk_goauthentik_website_docs=self.webpackChunk_goauthentik_website_docs||[]).push([[74992],{36517:(e,t,n)=>{n.r(t),n.d(t,{assets:()=>r,contentTitle:()=>o,default:()=>l,frontMatter:()=>c,metadata:()=>i,toc:()=>d});const i=JSON.parse('{"id":"add-secure-apps/providers/oauth2/client_credentials","title":"client_credentials","description":"Machine-to-machine authentication","source":"@site/docs/add-secure-apps/providers/oauth2/client_credentials.md","sourceDirName":"add-secure-apps/providers/oauth2","slug":"/add-secure-apps/providers/oauth2/client_credentials","permalink":"/docs/add-secure-apps/providers/oauth2/client_credentials","draft":false,"unlisted":false,"editUrl":"https://github.com/goauthentik/authentik/edit/main/website/docs/add-secure-apps/providers/oauth2/client_credentials.md","tags":[],"version":"current","frontMatter":{},"sidebar":"docs","previous":{"title":"Create an OAuth2 provider","permalink":"/docs/add-secure-apps/providers/oauth2/create-oauth2-provider"},"next":{"title":"Device code flow","permalink":"/docs/add-secure-apps/providers/oauth2/device_code"}}');var s=n(74848),a=n(28453);const c={},o=void 0,r={},d=[{value:"Machine-to-machine authentication",id:"machine-to-machine-authentication",level:2},{value:"Static authentication",id:"static-authentication",level:3},{value:"JWT-authentication",id:"jwt-authentication",level:3},{value:'Externally issued JWTs <span class="badge badge--version">authentik 2022.4+</span>',id:"externally-issued-jwts-authentik-20224",level:4},{value:'authentik-issued JWTs <span class="badge badge--version">authentik 2024.12+</span>',id:"authentik-issued-jwts-authentik-202412",level:4}];function h(e){const t={a:"a",code:"code",em:"em",h2:"h2",h3:"h3",h4:"h4",p:"p",pre:"pre",...(0,a.R)(),...e.components};return(0,s.jsxs)(s.Fragment,{children:[(0,s.jsx)(t.h2,{id:"machine-to-machine-authentication",children:"Machine-to-machine authentication"}),"\n",(0,s.jsx)(t.p,{children:"Client credentials can be used for machine-to-machine communication authentication. Clients can authenticate themselves using service-accounts; standard client_id + client_secret is not sufficient. This behavior is due to providers only being able to have a single secret at any given time."}),"\n",(0,s.jsxs)(t.p,{children:["Note that authentik does treat a grant type of ",(0,s.jsx)(t.code,{children:"password"})," the same as ",(0,s.jsx)(t.code,{children:"client_credentials"})," to support applications which rely on a password grant."]}),"\n",(0,s.jsx)(t.h3,{id:"static-authentication",children:"Static authentication"}),"\n",(0,s.jsxs)(t.p,{children:["Hence identification is based on service-accounts, and authentication is based on App-password tokens. These objects can be created in a single step using the ",(0,s.jsx)(t.em,{children:"Create Service account"})," function."]}),"\n",(0,s.jsx)(t.p,{children:"An example request can look like this:"}),"\n",(0,s.jsx)(t.pre,{children:(0,s.jsx)(t.code,{className:"language-http",children:"POST /application/o/token/ HTTP/1.1\nHost: authentik.company\nContent-Type: application/x-www-form-urlencoded\n\ngrant_type=client_credentials&\nclient_id=application_client_id&\nusername=my-service-account&\npassword=my-token&\nscope=profile\n"})}),"\n",(0,s.jsxs)(t.p,{children:["This will return a JSON response with an ",(0,s.jsx)(t.code,{children:"access_token"}),", which is a signed JWT token. This token can be sent along requests to other hosts, which can then validate the JWT based on the signing key configured in authentik."]}),"\n",(0,s.jsxs)(t.p,{children:["Starting with authentik 2024.4, it is also possible to encode the username and token of the user to authenticate with, separated with a colon, into a base64 string and pass it as ",(0,s.jsx)(t.code,{children:"client_secret"})," value."]}),"\n",(0,s.jsxs)(t.p,{children:["In addition to that, with authentik 2024.4 it is also possible to pass the configured ",(0,s.jsx)(t.code,{children:"client_secret"})," value, which will automatically generate a service account user for which the JWT token will be issued."]}),"\n",(0,s.jsx)(t.h3,{id:"jwt-authentication",children:"JWT-authentication"}),"\n",(0,s.jsxs)(t.h4,{id:"externally-issued-jwts-authentik-20224",children:["Externally issued JWTs ",(0,s.jsx)("span",{class:"badge badge--version",children:"authentik 2022.4+"})]}),"\n",(0,s.jsx)(t.p,{children:"You can authenticate and get a token using an existing JWT. For readability we will refer to the JWT issued by the external issuer/platform as input JWT, and the resulting JWT from authentik as the output JWT."}),"\n",(0,s.jsx)(t.p,{children:"To configure this, define a JWKS URL/raw JWKS data in OAuth Sources. If a JWKS URL is specified, authentik will fetch the data and store it in the source, and then select the source in the OAuth2 Provider that will be authenticated against."}),"\n",(0,s.jsx)(t.p,{children:"With this configuration, any JWT issued by the configured sources' certificates can be used to authenticate:"}),"\n",(0,s.jsx)(t.pre,{children:(0,s.jsx)(t.code,{className:"language-http",children:"POST /application/o/token/ HTTP/1.1\nHost: authentik.company\nContent-Type: application/x-www-form-urlencoded\n\ngrant_type=client_credentials&\nclient_assertion_type=urn:ietf:params:oauth:client-assertion-type:jwt-bearer&\nclient_assertion=$inputJWT&\nclient_id=application_client_id\n"})}),"\n",(0,s.jsxs)(t.p,{children:["Alternatively, you can set the ",(0,s.jsx)(t.code,{children:"client_secret"})," parameter to ",(0,s.jsx)(t.code,{children:"$inputJWT"}),", for applications that can set the password from a file but not other parameters."]}),"\n",(0,s.jsxs)(t.p,{children:["Input JWTs are checked to verify that they are signed by any of the selected ",(0,s.jsx)(t.em,{children:"Federated OIDC Sources"}),", and that their ",(0,s.jsx)(t.code,{children:"exp"})," attribute is not set as now or in the past."]}),"\n",(0,s.jsxs)(t.p,{children:["To dynamically limit access based on the claims of the tokens, you can use ",(0,s.jsx)(t.em,{children:(0,s.jsx)(t.a,{href:"/docs/customize/policies/expression",children:"Expression policies"})}),":"]}),"\n",(0,s.jsx)(t.pre,{children:(0,s.jsx)(t.code,{className:"language-python",children:'return request.context["oauth_jwt"]["iss"] == "https://my.issuer"\n'})}),"\n",(0,s.jsxs)(t.h4,{id:"authentik-issued-jwts-authentik-202412",children:["authentik-issued JWTs ",(0,s.jsx)("span",{class:"badge badge--version",children:"authentik 2024.12+"})]}),"\n",(0,s.jsx)(t.p,{children:"To allow federation between providers, modify the provider settings of the application (whose token will be used for authentication) to select the provider of the application to which you want to federate."}),"\n",(0,s.jsx)(t.p,{children:"With this configuration, any JWT issued by the configured providers can be used to authenticate:"}),"\n",(0,s.jsx)(t.pre,{children:(0,s.jsx)(t.code,{children:"POST /application/o/token/ HTTP/1.1\nHost: authentik.company\nContent-Type: application/x-www-form-urlencoded\n\ngrant_type=client_credentials&\nclient_assertion_type=urn:ietf:params:oauth:client-assertion-type:jwt-bearer&\nclient_assertion=$inputJWT&\nclient_id=application_client_id\n"})}),"\n",(0,s.jsxs)(t.p,{children:["Alternatively, you can set the ",(0,s.jsx)(t.code,{children:"client_secret"})," parameter to the ",(0,s.jsx)(t.code,{children:"$inputJWT"}),", for applications which can set the password from a file but not other parameters."]}),"\n",(0,s.jsxs)(t.p,{children:["Input JWTs must be valid access tokens issued by any of the configured ",(0,s.jsx)(t.em,{children:"Federated OIDC Providers"}),", they must not have been revoked and must not have expired."]}),"\n",(0,s.jsxs)(t.p,{children:["To dynamically limit access based on the claims of the tokens, you can use ",(0,s.jsx)(t.em,{children:(0,s.jsx)(t.a,{href:"/docs/customize/policies/expression",children:"Expression policies"})}),":"]}),"\n",(0,s.jsx)(t.pre,{children:(0,s.jsx)(t.code,{className:"language-python",children:'return request.context["oauth_jwt"]["iss"] == "https://my.issuer"\n'})})]})}function l(e={}){const{wrapper:t}={...(0,a.R)(),...e.components};return t?(0,s.jsx)(t,{...e,children:(0,s.jsx)(h,{...e})}):h(e)}}}]);