"use strict";(self.webpackChunk_goauthentik_website_docs=self.webpackChunk_goauthentik_website_docs||[]).push([[57228],{38642:(e,t,n)=>{n.r(t),n.d(t,{assets:()=>a,contentTitle:()=>d,default:()=>u,frontMatter:()=>r,metadata:()=>o,toc:()=>c});const o=JSON.parse('{"id":"developer-docs/setup/debugging","title":"Debugging authentik","description":"This page describes how to debug different components of an authentik instance, running either in production or in a development setup. To learn more about the structure of authentik, refer to our architecture documentation.","source":"@site/docs/developer-docs/setup/debugging.md","sourceDirName":"developer-docs/setup","slug":"/developer-docs/setup/debugging","permalink":"/docs/developer-docs/setup/debugging","draft":false,"unlisted":false,"editUrl":"https://github.com/goauthentik/authentik/edit/main/website/docs/developer-docs/setup/debugging.md","tags":[],"version":"current","frontMatter":{"title":"Debugging authentik"},"sidebar":"docs","previous":{"title":"Website development environment","permalink":"/docs/developer-docs/setup/website-dev-environment"},"next":{"title":"API","permalink":"/docs/developer-docs/api/"}}');var s=n(74848),i=n(28453);const r={title:"Debugging authentik"},d=void 0,a={},c=[{value:"authentik Server &amp; Worker (Python)",id:"authentik-server--worker-python",level:2},{value:"Debugging in containers",id:"debugging-in-containers",level:4},{value:"authentik Server / Outposts (Golang)",id:"authentik-server--outposts-golang",level:2}];function h(e){const t={a:"a",admonition:"admonition",code:"code",em:"em",h2:"h2",h4:"h4",img:"img",p:"p",pre:"pre",...(0,i.R)(),...e.components};return(0,s.jsxs)(s.Fragment,{children:[(0,s.jsxs)(t.p,{children:["This page describes how to debug different components of an authentik instance, running either in production or in a development setup. To learn more about the structure of authentik, refer to our ",(0,s.jsx)(t.a,{href:"../../core/architecture",children:"architecture documentation"}),"."]}),"\n",(0,s.jsx)(t.h2,{id:"authentik-server--worker-python",children:"authentik Server & Worker (Python)"}),"\n",(0,s.jsxs)(t.p,{children:["The majority of the authentik codebase is in Python, running in Gunicorn for the server and Celery for the worker. These instructions show how this code can be debugged/inspected. The local debugging setup requires a setup as described in ",(0,s.jsx)(t.a,{href:"/docs/developer-docs/setup/full-dev-environment",children:"Full development environment"})]}),"\n",(0,s.jsxs)(t.p,{children:["Note that authentik uses ",(0,s.jsx)(t.a,{href:"https://github.com/microsoft/debugpy",children:"debugpy"}),', which relies on the "Debug Adapter Protocol" (DAP). These instructions demonstrate debugging using ',(0,s.jsx)(t.a,{href:"https://code.visualstudio.com/",children:"Visual Studio Code"}),", however they should be adaptable to other editors that support DAP."]}),"\n",(0,s.jsxs)(t.p,{children:["To enable the debugging server, set the environment variable ",(0,s.jsx)(t.code,{children:"AUTHENTIK_DEBUGGER"})," to ",(0,s.jsx)(t.code,{children:"true"}),". This will launch the debugging server (by default on port ",(0,s.jsx)(t.em,{children:"9901"}),")."]}),"\n",(0,s.jsx)(t.p,{children:'With this setup in place, you can set Breakpoints in VS Code. To connect to the debugging server, run the command `> Debug: Start Debugging" in VS Code.'}),"\n",(0,s.jsx)(t.p,{children:(0,s.jsx)(t.img,{src:n(36274).A+"",width:"2672",height:"1527"})}),"\n",(0,s.jsx)(t.admonition,{type:"info",children:(0,s.jsxs)(t.p,{children:["Note that due to the Python debugger for VS Code, when a Python file in authentik is saved and the Django process restarts, you must manually reconnect the Debug session. Automatic re-connection is not supported for the Python debugger (see ",(0,s.jsx)(t.a,{href:"https://github.com/microsoft/vscode-python/issues/19998",children:"here"})," and ",(0,s.jsx)(t.a,{href:"https://github.com/microsoft/vscode-python/issues/1182",children:"here"}),")."]})}),"\n",(0,s.jsx)(t.h4,{id:"debugging-in-containers",children:"Debugging in containers"}),"\n",(0,s.jsx)(t.p,{children:"When debugging an authentik instance running in containers, there are some additional steps that need to be taken in addition to the steps above."}),"\n",(0,s.jsxs)(t.p,{children:["A local clone of the authentik repository is required to be able to set breakpoints in the code. The locally checked out repository must be on the same version/commit as the authentik version running in the containers. To checkout version 2024.12.3 for example, you can run ",(0,s.jsx)(t.code,{children:"git checkout version/2024.12.3"}),"."]}),"\n",(0,s.jsxs)(t.p,{children:["The debug port needs to be accessible on the local machine. By default, this is port 9901. Additionally, the container being debugged must be started as ",(0,s.jsx)(t.code,{children:"root"}),", because additional dependencies need to be installed on startup."]}),"\n",(0,s.jsxs)(t.p,{children:["When running in Docker Compose, a file ",(0,s.jsx)(t.code,{children:"docker-compose.override.yml"})," can be created next to the authentik docker-compose.yml file to expose the port, change the user, and enable debug mode."]}),"\n",(0,s.jsx)(t.pre,{children:(0,s.jsx)(t.code,{className:"language-yaml",children:'services:\n    # Replace `server` with `worker` to debug the worker container.\n    server:\n        user: root\n        healthcheck:\n            disable: true\n        environment:\n            AUTHENTIK_DEBUGGER: "true"\n            AUTHENTIK_LOG_LEVEL: "debug"\n        ports:\n            - 9901:9901\n'})}),"\n",(0,s.jsxs)(t.p,{children:["After re-creating the containers with ",(0,s.jsx)(t.code,{children:"AUTHENTIK_DEBUGGER"})," set to ",(0,s.jsx)(t.code,{children:"true"})," and the port mapped, the steps are identical to the steps above."]}),"\n",(0,s.jsxs)(t.p,{children:["If the authentik instance is running on a remote server, the ",(0,s.jsx)(t.code,{children:".vscode/launch.json"})," file needs to be adjusted to point to the IP of the remote server. Alternatively, it is also possible to forward the debug port via an SSH tunnel, using ",(0,s.jsx)(t.code,{children:"-L 9901:127.0.0.1:9901"}),"."]}),"\n",(0,s.jsx)(t.h2,{id:"authentik-server--outposts-golang",children:"authentik Server / Outposts (Golang)"}),"\n",(0,s.jsxs)(t.p,{children:["Outposts, as well as some auxiliary code of the authentik server, are written in Go. These components can be debugged using standard Golang tooling, such as ",(0,s.jsx)(t.a,{href:"https://github.com/go-delve/delve",children:"Delve"}),"."]})]})}function u(e={}){const{wrapper:t}={...(0,i.R)(),...e.components};return t?(0,s.jsx)(t,{...e,children:(0,s.jsx)(h,{...e})}):h(e)}},36274:(e,t,n)=>{n.d(t,{A:()=>o});const o=n.p+"assets/images/debug_vscode-699c1bc7dfc572fa77b4caae9791be20.png"}}]);