"use strict";(self.webpackChunk_goauthentik_website_docs=self.webpackChunk_goauthentik_website_docs||[]).push([[10672],{52721:(e,s,t)=>{t.r(s),t.d(s,{assets:()=>c,contentTitle:()=>i,default:()=>l,frontMatter:()=>n,metadata:()=>r,toc:()=>u});const r=JSON.parse('{"id":"add-secure-apps/flows-stages/stages/source/index","title":"Source stage","description":"Enterprise","source":"@site/docs/add-secure-apps/flows-stages/stages/source/index.md","sourceDirName":"add-secure-apps/flows-stages/stages/source","slug":"/add-secure-apps/flows-stages/stages/source/","permalink":"/docs/add-secure-apps/flows-stages/stages/source/","draft":false,"unlisted":false,"editUrl":"https://github.com/goauthentik/authentik/edit/main/website/docs/add-secure-apps/flows-stages/stages/source/index.md","tags":[],"version":"current","frontMatter":{"title":"Source stage"},"sidebar":"docs","previous":{"title":"Redirect stage","permalink":"/docs/add-secure-apps/flows-stages/stages/redirect/"},"next":{"title":"User delete stage","permalink":"/docs/add-secure-apps/flows-stages/stages/user_delete"}}');var o=t(74848),a=t(28453);const n={title:"Source stage"},i=void 0,c={},u=[{value:"Considerations",id:"considerations",level:3},{value:"Example use case",id:"example-use-case",level:3},{value:"Options",id:"options",level:3},{value:"Source",id:"source",level:4},{value:"Resume timeout",id:"resume-timeout",level:4}];function d(e){const s={a:"a",em:"em",h3:"h3",h4:"h4",hr:"hr",mermaid:"mermaid",p:"p",strong:"strong",...(0,a.R)(),...e.components};return(0,o.jsxs)(o.Fragment,{children:[(0,o.jsx)("span",{class:"badge badge--primary",children:"Enterprise"}),"\n",(0,o.jsx)("span",{class:"badge badge--version",children:"authentik 2024.4+"}),"\n",(0,o.jsx)(s.hr,{}),"\n",(0,o.jsxs)(s.p,{children:["The source stage injects an ",(0,o.jsx)(s.a,{href:"/docs/users-sources/sources/protocols/oauth/",children:"OAuth"})," or ",(0,o.jsx)(s.a,{href:"/docs/users-sources/sources/protocols/saml/",children:"SAML"})," Source into the flow execution. This allows for additional user verification, or to dynamically access different sources for different user identifiers (username, email address, etc)."]}),"\n",(0,o.jsx)(s.mermaid,{value:"sequenceDiagram\n    participant u as User\n    participant ak as authentik\n    participant eidp as External IDP\n\n    u->>ak: User initiates flow\n    ak->>u: User reaches Source Stage\n\n    u->>eidp: User is redirected to external IDP\n    eidp->>ak: User has authenticated with external IDP\n\n    alt User is connected to external IDP (auth)\n        ak->>u: Source's authentication flow is started\n        u->>ak: User finishes source's authentication flow\n    else User has not been connected to external IDP (enroll)\n        ak->>u: Source's enrollment flow is started\n        u->>ak: User finishes source's enrollment flow\n    end\n\n    ak->>u: Execution of the previous flow is resumed"}),"\n",(0,o.jsx)(s.h3,{id:"considerations",children:"Considerations"}),"\n",(0,o.jsxs)(s.p,{children:["It is very important that the configured source's authentication and enrollment flows (when set; they can be left unselected to prevent authentication or enrollment with the source) do ",(0,o.jsx)(s.strong,{children:"not"})," have a ",(0,o.jsx)(s.a,{href:"/docs/add-secure-apps/flows-stages/stages/user_login/",children:"User login stage"})," bound to them."]}),"\n",(0,o.jsxs)(s.p,{children:["This is because the Source stage works by appending a ",(0,o.jsx)(s.a,{href:"/docs/terminology#dynamic-in-memory-stage",children:"dynamic in-memory"})," stage to the source's flow, so having a ",(0,o.jsx)(s.a,{href:"/docs/add-secure-apps/flows-stages/stages/user_login/",children:"User login stage"})," bound will cause the source's flow to not resume the original flow it was started from, and instead directly authenticating the pending user."]}),"\n",(0,o.jsx)(s.h3,{id:"example-use-case",children:"Example use case"}),"\n",(0,o.jsx)(s.p,{children:"This stage can be used to leverage an external OAuth/SAML identity provider."}),"\n",(0,o.jsx)(s.p,{children:"For example, you can authenticate users by routing them through a custom device-health solution."}),"\n",(0,o.jsxs)(s.p,{children:["Another use case is to route users to authenticate with your legacy (Okta, etc) IdP and then use the returned identity and attributes within authentik as part of an authorization flow, for example as part of an IdP migration. For authentication/enrollment this is also possible with an ",(0,o.jsx)(s.a,{href:"/docs/users-sources/sources/protocols/oauth/",children:"OAuth"}),"/",(0,o.jsx)(s.a,{href:"/docs/users-sources/sources/protocols/saml/",children:"SAML"})," source by itself."]}),"\n",(0,o.jsx)(s.h3,{id:"options",children:"Options"}),"\n",(0,o.jsx)(s.h4,{id:"source",children:"Source"}),"\n",(0,o.jsxs)(s.p,{children:["The source the user is redirected to. Must be a web-based source, such as ",(0,o.jsx)(s.a,{href:"/docs/users-sources/sources/protocols/oauth/",children:"OAuth"})," or ",(0,o.jsx)(s.a,{href:"/docs/users-sources/sources/protocols/saml/",children:"SAML"}),". Sources like ",(0,o.jsx)(s.a,{href:"/docs/users-sources/sources/protocols/ldap/",children:"LDAP"})," are ",(0,o.jsx)(s.em,{children:"not"})," compatible."]}),"\n",(0,o.jsx)(s.h4,{id:"resume-timeout",children:"Resume timeout"}),"\n",(0,o.jsx)(s.p,{children:"Because the execution of the current flow is suspended before the user is redirected to the configured source, this option configures how long the suspended flow is saved. If this timeout is exceeded, upon return from the configured source, the suspended flow will restart from the beginning."})]})}function l(e={}){const{wrapper:s}={...(0,a.R)(),...e.components};return s?(0,o.jsx)(s,{...e,children:(0,o.jsx)(d,{...e})}):d(e)}}}]);