"use strict";(self.webpackChunk_goauthentik_website_docs=self.webpackChunk_goauthentik_website_docs||[]).push([[4287],{64351:(e,n,t)=>{t.r(n),t.d(n,{assets:()=>a,contentTitle:()=>d,default:()=>h,frontMatter:()=>r,metadata:()=>i,toc:()=>c});const i=JSON.parse('{"id":"developer-docs/docs/writing-documentation","title":"Writing documentation","description":"Writing documentation for authentik is a great way for both new and experienced users to improve and contribute to the project. We appreciate contributions to our documentation; everything from fixing a typo to adding additional content to writing a completely new topic.","source":"@site/docs/developer-docs/docs/writing-documentation.md","sourceDirName":"developer-docs/docs","slug":"/developer-docs/docs/writing-documentation","permalink":"/docs/developer-docs/docs/writing-documentation","draft":false,"unlisted":false,"editUrl":"https://github.com/goauthentik/authentik/edit/main/website/docs/developer-docs/docs/writing-documentation.md","tags":[],"version":"current","frontMatter":{"title":"Writing documentation"},"sidebar":"docs","previous":{"title":"API Clients","permalink":"/docs/developer-docs/api/clients"},"next":{"title":"Style Guide","permalink":"/docs/developer-docs/docs/style-guide"}}');var o=t(74848),s=t(28453);const r={title:"Writing documentation"},d=void 0,a={},c=[{value:"Set up your local build",id:"set-up-your-local-build",level:2},{value:"Documentation for Integrations",id:"documentation-for-integrations",level:2}];function l(e){const n={a:"a",admonition:"admonition",code:"code",h2:"h2",li:"li",p:"p",strong:"strong",ul:"ul",...(0,s.R)(),...e.components};return(0,o.jsxs)(o.Fragment,{children:[(0,o.jsx)(n.p,{children:"Writing documentation for authentik is a great way for both new and experienced users to improve and contribute to the project. We appreciate contributions to our documentation; everything from fixing a typo to adding additional content to writing a completely new topic."}),"\n",(0,o.jsx)(n.p,{children:"Adhering to the following guidelines will help us get your PRs merged much easier and faster, with fewer edits needed."}),"\n",(0,o.jsxs)(n.ul,{children:["\n",(0,o.jsxs)(n.li,{children:["\n",(0,o.jsxs)(n.p,{children:["Ideally, when you are making contributions to the documentation, you should fork and clone our repo, then ",(0,o.jsx)(n.a,{href:"#set-up-your-local-build",children:"build it locally"}),", so that you can test the docs and run the required linting and spell checkers before pushing your PR. While you can do much of the writing and editing within the GitHub UI, you cannot run the required linters from the GitHub UI."]}),"\n"]}),"\n",(0,o.jsxs)(n.li,{children:["\n",(0,o.jsxs)(n.p,{children:["Please refer to our ",(0,o.jsx)(n.a,{href:"/docs/developer-docs/docs/style-guide",children:"Style Guide"})," for authentik documentation. Here you will learn important guidelines about not capitalizing authentik, how we format our titles and headers, and much more."]}),"\n"]}),"\n",(0,o.jsxs)(n.li,{children:["\n",(0,o.jsxs)(n.p,{children:["Remember to use our ",(0,o.jsx)(n.a,{href:"/docs/developer-docs/docs/templates/",children:"docs templates"})," when possible; they are already set up to follow our style guidelines, they make it a lot easier for you (no blank page frights!), and keeps the documentation structure and headings consistent."]}),"\n"]}),"\n",(0,o.jsxs)(n.li,{children:["\n",(0,o.jsxs)(n.p,{children:["To test how the documentation renders you can build locally and then use the Netlify Deploy Preview, especially when using Docusaurus-specific features. You can also run the ",(0,o.jsx)(n.code,{children:"make website-watch"})," command on your local build, to see the rendered pages as you make changes."]}),"\n"]}),"\n",(0,o.jsxs)(n.li,{children:["\n",(0,o.jsxs)(n.p,{children:["Be sure to run the ",(0,o.jsx)(n.code,{children:"make website"})," command on your local branch, before pushing the PR to the authentik repo. This command does important linting, and the build check in our repo will fail if the linting has not been done."]}),"\n"]}),"\n",(0,o.jsxs)(n.li,{children:["\n",(0,o.jsxs)(n.p,{children:["For new entries, make sure to add any new pages to the appropriate ",(0,o.jsx)(n.code,{children:"sidebar.js"})," file. Otherwise, the new page will not appear in the table of contents to the left."]}),"\n"]}),"\n"]}),"\n",(0,o.jsx)(n.h2,{id:"set-up-your-local-build",children:"Set up your local build"}),"\n",(0,o.jsx)(n.p,{children:"Requirements:"}),"\n",(0,o.jsxs)(n.ul,{children:["\n",(0,o.jsx)(n.li,{children:"Node.js 20 (or greater, we use Node.js 22)"}),"\n"]}),"\n",(0,o.jsxs)(n.p,{children:["The docs and the code are in the same Github repo, at ",(0,o.jsx)(n.a,{href:"https://github.com/goauthentik/authentik",children:"https://github.com/goauthentik/authentik"}),", so if you have cloned the repo, you already have the docs."]}),"\n",(0,o.jsxs)(n.p,{children:["You can do local builds of the documentation to test your changes or review your new content, and to run the required ",(0,o.jsx)(n.code,{children:"make website"})," command (which runs ",(0,o.jsx)(n.code,{children:"prettier"})," and other linters) before pushing your PR."]}),"\n",(0,o.jsxs)(n.p,{children:["The documentation site is situated in the ",(0,o.jsx)(n.code,{children:"/website"})," folder of the repo."]}),"\n",(0,o.jsx)(n.p,{children:"The site is built using npm, below are some useful make commands:"}),"\n",(0,o.jsxs)(n.ul,{children:["\n",(0,o.jsxs)(n.li,{children:["\n",(0,o.jsxs)(n.p,{children:[(0,o.jsx)(n.strong,{children:"Installation"}),": ",(0,o.jsx)(n.code,{children:"make website-install"})]}),"\n",(0,o.jsx)(n.p,{children:"This command is required before running any of the following commands, and after upgrading any dependencies."}),"\n"]}),"\n",(0,o.jsxs)(n.li,{children:["\n",(0,o.jsxs)(n.p,{children:[(0,o.jsx)(n.strong,{children:"Formatting"}),": ",(0,o.jsx)(n.code,{children:"make website"}),", ",(0,o.jsx)(n.code,{children:"make website-lint-fix"}),", or ",(0,o.jsx)(n.code,{children:"npm run prettier"})]}),"\n",(0,o.jsx)(n.p,{children:"Run the appropriate formatting command for your set up before committing, to ensure consistent syntax, clean formatting, and verify links. Note that if the formatting command is not run, the build will fail with an error about linting."}),"\n"]}),"\n",(0,o.jsxs)(n.li,{children:["\n",(0,o.jsxs)(n.p,{children:[(0,o.jsx)(n.strong,{children:"Live editing"}),": ",(0,o.jsx)(n.code,{children:"make website-watch"})]}),"\n",(0,o.jsx)(n.p,{children:"For real-time viewing of changes, as you make them."}),"\n"]}),"\n"]}),"\n",(0,o.jsx)(n.admonition,{type:"info",children:(0,o.jsx)(n.p,{children:"Be sure to run a formatting command before committing changes."})}),"\n",(0,o.jsx)(n.h2,{id:"documentation-for-integrations",children:"Documentation for Integrations"}),"\n",(0,o.jsxs)(n.p,{children:["In addition to following the ",(0,o.jsx)(n.a,{href:"/docs/developer-docs/docs/style-guide",children:"Style Guide"})," please review the following guidelines."]}),"\n",(0,o.jsxs)(n.p,{children:["For new integration documentation, please use the Integrations template in our ",(0,o.jsx)(n.a,{href:"https://github.com/goauthentik/authentik",children:"Github repo"})," at ",(0,o.jsx)(n.code,{children:"/website/integrations/template/service.md"}),"."]}),"\n",(0,o.jsxs)(n.ul,{children:["\n",(0,o.jsxs)(n.li,{children:["\n",(0,o.jsxs)(n.p,{children:["Make sure to add the service to a fitting category in ",(0,o.jsx)(n.code,{children:"/website/sidebarsIntegrations.js"}),". If this is not done the service will not appear in the table of contents to the left."]}),"\n"]}),"\n",(0,o.jsxs)(n.li,{children:["\n",(0,o.jsxs)(n.p,{children:["For placeholder domains, use ",(0,o.jsx)(n.code,{children:"authentik.company"})," and ",(0,o.jsx)(n.code,{children:"app-name.company"}),", where ",(0,o.jsx)(n.code,{children:"app-name"})," is the name of the application that you are writing documentation for."]}),"\n"]}),"\n",(0,o.jsxs)(n.li,{children:["\n",(0,o.jsx)(n.p,{children:"Try to order the documentation sections in an order that makes it easiest for the user to configure."}),"\n"]}),"\n"]})]})}function h(e={}){const{wrapper:n}={...(0,s.R)(),...e.components};return n?(0,o.jsx)(n,{...e,children:(0,o.jsx)(l,{...e})}):l(e)}}}]);