"use strict";(self.webpackChunk_goauthentik_website_docs=self.webpackChunk_goauthentik_website_docs||[]).push([[71406],{56268:(e,t,i)=>{i.r(t),i.d(t,{assets:()=>o,contentTitle:()=>a,default:()=>h,frontMatter:()=>c,metadata:()=>n,toc:()=>l});const n=JSON.parse('{"id":"sys-mgmt/certificates","title":"Certificates","description":"Certificates in authentik are used for the following use cases:","source":"@site/docs/sys-mgmt/certificates.md","sourceDirName":"sys-mgmt","slug":"/sys-mgmt/certificates","permalink":"/docs/sys-mgmt/certificates","draft":false,"unlisted":false,"editUrl":"https://github.com/goauthentik/authentik/edit/main/website/docs/sys-mgmt/certificates.md","tags":[],"version":"current","frontMatter":{"title":"Certificates"},"sidebar":"docs","previous":{"title":"Transports","permalink":"/docs/sys-mgmt/events/transports"},"next":{"title":"System Settings","permalink":"/docs/sys-mgmt/settings"}}');var s=i(74848),r=i(28453);const c={title:"Certificates"},a=void 0,o={},l=[{value:"Default certificate",id:"default-certificate",level:2},{value:"External certificates",id:"external-certificates",level:2},{value:"Manual imports",id:"manual-imports",level:4},{value:"Web certificates",id:"web-certificates",level:2},{value:"Let&#39;s Encrypt",id:"lets-encrypt",level:4}];function d(e){const t={a:"a",code:"code",em:"em",h2:"h2",h4:"h4",li:"li",p:"p",pre:"pre",ul:"ul",...(0,r.R)(),...e.components};return(0,s.jsxs)(s.Fragment,{children:[(0,s.jsx)(t.p,{children:"Certificates in authentik are used for the following use cases:"}),"\n",(0,s.jsxs)(t.ul,{children:["\n",(0,s.jsx)(t.li,{children:"Signing and verifying SAML Requests and Responses"}),"\n",(0,s.jsx)(t.li,{children:"Signing JSON Web Tokens for OAuth and OIDC"}),"\n",(0,s.jsx)(t.li,{children:"Connecting to remote docker hosts using the Docker integration"}),"\n",(0,s.jsx)(t.li,{children:"Verifying LDAP Servers' certificates"}),"\n",(0,s.jsx)(t.li,{children:"Encrypting outposts' endpoints"}),"\n"]}),"\n",(0,s.jsx)(t.h2,{id:"default-certificate",children:"Default certificate"}),"\n",(0,s.jsxs)(t.p,{children:["Every authentik install generates a self-signed certificate on the first start. The certificate is called ",(0,s.jsx)(t.em,{children:"authentik Self-signed Certificate"})," and is valid for 1 year."]}),"\n",(0,s.jsxs)(t.p,{children:["This certificate is generated to be used as a default for all OAuth2/OIDC providers, as these don't require the certificate to be configured on both sides (the signature of a JWT is validated using the ",(0,s.jsx)(t.a,{href:"https://auth0.com/docs/security/tokens/json-web-tokens/json-web-key-sets",children:"JWKS"})," URL)."]}),"\n",(0,s.jsx)(t.p,{children:"This certificate can also be used for SAML Providers/Sources, but keep in mind that the certificate is only valid for a year. Some SAML applications require the certificate to be valid, so they might need to be rotated regularly."}),"\n",(0,s.jsx)(t.p,{children:"For SAML use-cases, you can generate a Certificate that's valid for longer than 1 year, at your own risk."}),"\n",(0,s.jsx)(t.h2,{id:"external-certificates",children:"External certificates"}),"\n",(0,s.jsx)(t.p,{children:"To use externally managed certificates, for example generated with certbot or HashiCorp Vault, you can use the discovery feature."}),"\n",(0,s.jsxs)(t.p,{children:["The Docker Compose installation maps a ",(0,s.jsx)(t.code,{children:"certs"})," directory to ",(0,s.jsx)(t.code,{children:"/certs"}),". You can simply use this as an output directory for certbot."]}),"\n",(0,s.jsxs)(t.p,{children:["For Kubernetes, you can map custom secrets/volumes under ",(0,s.jsx)(t.code,{children:"/certs"}),"."]}),"\n",(0,s.jsx)(t.p,{children:"You can also bind mount single files into the folder, as long as they fall under this naming schema."}),"\n",(0,s.jsxs)(t.ul,{children:["\n",(0,s.jsxs)(t.li,{children:["\n",(0,s.jsx)(t.p,{children:"Files in the root directory will be imported based on their filename."}),"\n",(0,s.jsxs)(t.p,{children:[(0,s.jsx)(t.code,{children:"/foo.pem"})," Will be imported as the keypair ",(0,s.jsx)(t.code,{children:"foo"}),". Based on its content, the file is either imported as a certificate or a private key:"]}),"\n",(0,s.jsxs)(t.ul,{children:["\n",(0,s.jsxs)(t.li,{children:["\n",(0,s.jsxs)(t.p,{children:["Files containing ",(0,s.jsx)(t.code,{children:"PRIVATE KEY"})," will imported as private keys."]}),"\n"]}),"\n",(0,s.jsxs)(t.li,{children:["\n",(0,s.jsx)(t.p,{children:"Otherwise the file will be imported as a certificate."}),"\n"]}),"\n"]}),"\n"]}),"\n",(0,s.jsxs)(t.li,{children:["\n",(0,s.jsxs)(t.p,{children:["If the file is called ",(0,s.jsx)(t.code,{children:"fullchain.pem"})," or ",(0,s.jsx)(t.code,{children:"privkey.pem"})," (the output naming of certbot), it will get the name of the parent folder."]}),"\n"]}),"\n",(0,s.jsxs)(t.li,{children:["\n",(0,s.jsx)(t.p,{children:"Files can be in any arbitrary file structure, and can have any extension."}),"\n"]}),"\n",(0,s.jsxs)(t.li,{children:["\n",(0,s.jsxs)(t.p,{children:["If the path contains ",(0,s.jsx)(t.code,{children:"archive"}),", the files will be ignored (to better support certbot setups)."]}),"\n"]}),"\n"]}),"\n",(0,s.jsx)(t.pre,{children:(0,s.jsx)(t.code,{className:"language-shell",children:"certs/\n\u251c\u2500\u2500 baz\n\u2502\xa0\xa0 \u2514\u2500\u2500 bar.baz\n\u2502\xa0\xa0     \u251c\u2500\u2500 fullchain.pem\n\u2502\xa0\xa0     \u2514\u2500\u2500 privkey.pem\n\u251c\u2500\u2500 foo.bar\n\u2502\xa0\xa0 \u251c\u2500\u2500 fullchain.pem\n\u2502\xa0\xa0 \u2514\u2500\u2500 privkey.pem\n\u251c\u2500\u2500 foo.key\n\u2514\u2500\u2500 foo.pem\n"})}),"\n",(0,s.jsx)(t.p,{children:"Files are checked every 5 minutes and will trigger an Outpost refresh if a file has changed."}),"\n",(0,s.jsx)(t.h4,{id:"manual-imports",children:"Manual imports"}),"\n",(0,s.jsx)(t.p,{children:"Starting with authentik 2022.9, you can also import certificates with any folder structure directly. To do this, run the following command within the worker container:"}),"\n",(0,s.jsx)(t.pre,{children:(0,s.jsx)(t.code,{className:"language-shell",children:"ak import_certificate --certificate /certs/mycert.pem --private-key /certs/something.pem --name test\n# --private-key can be omitted to only import a certificate, i.e. to trust other connections\n# ak import_certificate --certificate /certs/othercert.pem --name test2\n"})}),"\n",(0,s.jsx)(t.p,{children:"This will import the certificate into authentik under the given name. This command is safe to run as a cron job; authentik will only re-import the certificate if it changes."}),"\n",(0,s.jsx)(t.h2,{id:"web-certificates",children:"Web certificates"}),"\n",(0,s.jsx)(t.p,{children:"Starting with authentik 2021.12.4, you can configure the certificate authentik uses for its core webserver. For most deployments this will not be relevant and reverse proxies are used, but this can be used to create a very compact and self-contained authentik install."}),"\n",(0,s.jsx)(t.h4,{id:"lets-encrypt",children:"Let's Encrypt"}),"\n",(0,s.jsxs)(t.p,{children:["To use Let's Encrypt certificates with this setup, using certbot, you can use this compose override (create or edit a file called ",(0,s.jsx)(t.code,{children:"docker-compose.override.yml"})," in the same folder as the authentik docker-compose file)"]}),"\n",(0,s.jsx)(t.pre,{children:(0,s.jsx)(t.code,{className:"language-yaml",children:"services:\n    certbot:\n        image: certbot/dns-route53:v1.22.0\n        volumes:\n            - ./certs/:/etc/letsencrypt\n        # Variables depending on DNS Plugin\n        environment:\n            AWS_ACCESS_KEY_ID: ...\n        command:\n            - certonly\n            - --non-interactive\n            - --agree-tos\n            - -m your.email@company\n            - -d authentik.company\n            # Again, match with your provider\n            - --dns-route53\n"})}),"\n",(0,s.jsxs)(t.p,{children:["Afterward, run ",(0,s.jsx)(t.code,{children:"docker compose up -d"}),", which will start certbot and generate your certificate. Within a few minutes, you'll see the certificate in your authentik interface. (If the certificate does not appear, restart the worker container. This is caused by incompatible permissions set by certbot)."]}),"\n",(0,s.jsxs)(t.p,{children:["Navigate to ",(0,s.jsx)(t.em,{children:"System -> Brands"}),", edit any brand and select the certificate of your choice."]}),"\n",(0,s.jsx)(t.p,{children:"Keep in mind this certbot container will only run once, but there are a variety of ways to schedule regular renewals."})]})}function h(e={}){const{wrapper:t}={...(0,r.R)(),...e.components};return t?(0,s.jsx)(t,{...e,children:(0,s.jsx)(d,{...e})}):d(e)}}}]);