"use strict";(self.webpackChunk_goauthentik_website_docs=self.webpackChunk_goauthentik_website_docs||[]).push([[18977],{84776:(e,r,t)=>{t.r(r),t.d(r,{assets:()=>d,contentTitle:()=>o,default:()=>c,frontMatter:()=>a,metadata:()=>n,toc:()=>u});const n=JSON.parse('{"id":"add-secure-apps/providers/entra/index","title":"Microsoft Entra ID provider","description":"Enterprise","source":"@site/docs/add-secure-apps/providers/entra/index.md","sourceDirName":"add-secure-apps/providers/entra","slug":"/add-secure-apps/providers/entra/","permalink":"/docs/add-secure-apps/providers/entra/","draft":false,"unlisted":false,"editUrl":"https://github.com/goauthentik/authentik/edit/main/website/docs/add-secure-apps/providers/entra/index.md","tags":[],"version":"current","frontMatter":{"title":"Microsoft Entra ID provider"},"sidebar":"docs","previous":{"title":"Create an LDAP provider","permalink":"/docs/add-secure-apps/providers/ldap/generic_setup"},"next":{"title":"Configure Entra ID","permalink":"/docs/add-secure-apps/providers/entra/setup-entra"}}');var s=t(74848),i=t(28453);const a={title:"Microsoft Entra ID provider"},o=void 0,d={},u=[{value:"About using Entra ID with authentik",id:"about-using-entra-id-with-authentik",level:2},{value:"Discovery",id:"discovery",level:3},{value:"Synchronization",id:"synchronization",level:3},{value:"Customization for data mapping",id:"customization-for-data-mapping",level:3}];function h(e){const r={a:"a",em:"em",h2:"h2",h3:"h3",hr:"hr",li:"li",p:"p",strong:"strong",ul:"ul",...(0,i.R)(),...e.components};return(0,s.jsxs)(s.Fragment,{children:[(0,s.jsx)("span",{class:"badge badge--primary",children:"Enterprise"}),"\n",(0,s.jsx)(r.hr,{}),"\n",(0,s.jsx)(r.p,{children:"With the Microsoft Entra ID provider, authentik serves as the single source of truth for all users and groups. Configuring Entra ID as a provider allows for auto-discovery of user and group accounts, on-going synchronization of user data such as email address, name, and status, and integrated data mapping of field names and values."}),"\n",(0,s.jsxs)(r.ul,{children:["\n",(0,s.jsxs)(r.li,{children:["For instructions to configure your Entra ID tenant to integrate with authentik, refer to ",(0,s.jsx)(r.a,{href:"/docs/add-secure-apps/providers/entra/setup-entra",children:"Configure Entra ID"}),"."]}),"\n",(0,s.jsxs)(r.li,{children:["For instructions to add Entra ID as a provider in authentik, refer to ",(0,s.jsx)(r.a,{href:"/docs/add-secure-apps/providers/entra/add-entra-provider",children:"Create a Entra ID provider"}),"."]}),"\n"]}),"\n",(0,s.jsx)(r.h2,{id:"about-using-entra-id-with-authentik",children:"About using Entra ID with authentik"}),"\n",(0,s.jsx)(r.p,{children:"The following sections discuss how Entra ID operates with authentik."}),"\n",(0,s.jsx)(r.h3,{id:"discovery",children:"Discovery"}),"\n",(0,s.jsxs)(r.p,{children:["When first creating and configuring the provider, authentik will run a discovery process and query your Entra ID for all users and groups, and attempt to match them with their respective counterparts in authentik. This discovery takes into consideration any ",(0,s.jsx)(r.strong,{children:"User filtering"})," options configured in the provider, such as only linking to authentik users in a specific group or excluding service accounts."]}),"\n",(0,s.jsx)(r.p,{children:"This discovery happens every time before a full sync is started."}),"\n",(0,s.jsx)(r.h3,{id:"synchronization",children:"Synchronization"}),"\n",(0,s.jsx)(r.p,{children:"There are two types of synchronization: a direct sync and a full sync."}),"\n",(0,s.jsxs)(r.p,{children:["A ",(0,s.jsx)(r.em,{children:"direct sync"})," happens when a user or group is created, updated or deleted in authentik, or when a user is added to or removed from a group. When one of these events happens, the direct sync automatically forwards those changes to Entra ID."]}),"\n",(0,s.jsxs)(r.p,{children:["The ",(0,s.jsx)(r.em,{children:"full sync"})," happens when the provider is initially created and when it is saved. The full sync goes through all users and groups matching the ",(0,s.jsx)(r.strong,{children:"User filtering"})," options set and will create/update them in Entra ID. After the initial sync, authentik will run a full sync every four hours to ensure the consistency of users and groups."]}),"\n",(0,s.jsx)(r.p,{children:"During either sync, if a user or group was created in authentik and a matching user/group exists in Entra ID, authentik will automatically link them together. Furthermore, users present in authentik but not in Entra ID will be created and and linked."}),"\n",(0,s.jsx)(r.p,{children:"When a property mapping has an invalid expression, it will cause the sync to stop to prevent errors from being spammed. To handle any kind of network interruptions, authentik will detect transient request failures and retry any sync tasks."}),"\n",(0,s.jsx)(r.h3,{id:"customization-for-data-mapping",children:"Customization for data mapping"}),"\n",(0,s.jsx)(r.p,{children:"There are a couple of considerations in regard to how authentik data is mapped to Entra ID user/group data by default."}),"\n",(0,s.jsxs)(r.ul,{children:["\n",(0,s.jsx)(r.li,{children:"For users, authentik only saves the full display name, not separate first and family names."}),"\n",(0,s.jsx)(r.li,{children:"By default, authentik synchs a user\u2019s email, a user\u2019s name, and their active status between Entra ID and authentik. For groups, the name is synced."}),"\n"]}),"\n",(0,s.jsx)(r.p,{children:"Refer to Microsoft documentation for further details."}),"\n",(0,s.jsxs)(r.ul,{children:["\n",(0,s.jsx)(r.li,{children:(0,s.jsx)(r.a,{href:"https://learn.microsoft.com/en-us/graph/api/user-post-users?view=graph-rest-1.0&tabs=http#request-body",children:"https://learn.microsoft.com/en-us/graph/api/user-post-users?view=graph-rest-1.0&tabs=http#request-body"})}),"\n",(0,s.jsx)(r.li,{children:(0,s.jsx)(r.a,{href:"https://learn.microsoft.com/en-us/graph/api/group-post-groups?view=graph-rest-1.0&tabs=http#request-body",children:"https://learn.microsoft.com/en-us/graph/api/group-post-groups?view=graph-rest-1.0&tabs=http#request-body"})}),"\n"]})]})}function c(e={}){const{wrapper:r}={...(0,i.R)(),...e.components};return r?(0,s.jsx)(r,{...e,children:(0,s.jsx)(h,{...e})}):h(e)}}}]);