"use strict";(self.webpackChunk_goauthentik_website_docs=self.webpackChunk_goauthentik_website_docs||[]).push([[19996],{95503:(e,s,n)=>{n.r(s),n.d(s,{assets:()=>d,contentTitle:()=>c,default:()=>p,frontMatter:()=>l,metadata:()=>i,toc:()=>h});const i=JSON.parse('{"id":"customize/policies/expression","title":"Expression Policies","description":"Expression policies are perhaps the most flexible way to define specific implementations of flows and stages. With Expression polices, you can provide Python code to enforce custom checks and validation.","source":"@site/docs/customize/policies/expression.mdx","sourceDirName":"customize/policies","slug":"/customize/policies/expression","permalink":"/docs/customize/policies/expression","draft":false,"unlisted":false,"editUrl":"https://github.com/goauthentik/authentik/edit/main/website/docs/customize/policies/expression.mdx","tags":[],"version":"current","frontMatter":{"title":"Expression Policies"},"sidebar":"docs","previous":{"title":"Working with policies","permalink":"/docs/customize/policies/working_with_policies"},"next":{"title":"Ensure unique email addresses","permalink":"/docs/customize/policies/expression/unique_email"}}');var r=n(74848),t=n(28453),o=n(70482),a=n(3575);const l={title:"Expression Policies"},c=void 0,d={},h=[{value:"Available Functions",id:"available-functions",level:2},{value:"<code>ak_message(message: str)</code>",id:"ak_messagemessage-str",level:3},...o.RM,{value:"Variables",id:"variables",level:2},...a.RM];function u(e){const s={a:"a",admonition:"admonition",code:"code",em:"em",h2:"h2",h3:"h3",li:"li",p:"p",pre:"pre",strong:"strong",ul:"ul",...(0,t.R)(),...e.components};return(0,r.jsxs)(r.Fragment,{children:[(0,r.jsx)(s.p,{children:"Expression policies are perhaps the most flexible way to define specific implementations of flows and stages. With Expression polices, you can provide Python code to enforce custom checks and validation."}),"\n",(0,r.jsx)(s.p,{children:"The passing of the policy is determined by the return value of the code."}),"\n",(0,r.jsx)(s.p,{children:"To pass a policy, use:"}),"\n",(0,r.jsx)(s.pre,{children:(0,r.jsx)(s.code,{className:"language-python",children:"return True\n"})}),"\n",(0,r.jsx)(s.p,{children:"To fail a policy use:"}),"\n",(0,r.jsx)(s.pre,{children:(0,r.jsx)(s.code,{className:"language-python",children:"return False\n"})}),"\n",(0,r.jsxs)(s.p,{children:[(0,r.jsx)(s.strong,{children:"Example"}),":\nHere's a simple policy that you could bind to a MFA validation stage if you want to specify that only certain users should be prompted for MFA validation:"]}),"\n",(0,r.jsx)(s.pre,{children:(0,r.jsx)(s.code,{children:'if request.context["pending_user"].username == "marie":\n   return True\nreturn False\n'})}),"\n",(0,r.jsxs)(s.p,{children:["If the return is ",(0,r.jsx)(s.code,{children:"True"})," that means Yes, use this stage (i.e. the user will get the MFA prompt). A return of ",(0,r.jsx)(s.code,{children:"False"})," means remove this stage from the plan."]}),"\n",(0,r.jsx)(s.h2,{id:"available-functions",children:"Available Functions"}),"\n",(0,r.jsx)(s.h3,{id:"ak_messagemessage-str",children:(0,r.jsx)(s.code,{children:"ak_message(message: str)"})}),"\n",(0,r.jsx)(s.p,{children:"Add a message, visible by the end user. This can be used to show the reason why they were denied."}),"\n",(0,r.jsx)(s.p,{children:"Example:"}),"\n",(0,r.jsx)(s.pre,{children:(0,r.jsx)(s.code,{className:"language-python",children:'ak_message("Access denied")\nreturn False\n'})}),"\n","\n",(0,r.jsx)(o.Ay,{}),"\n",(0,r.jsx)(s.h2,{id:"variables",children:"Variables"}),"\n","\n",(0,r.jsx)(a.Ay,{}),"\n",(0,r.jsxs)(s.ul,{children:["\n",(0,r.jsxs)(s.li,{children:["\n",(0,r.jsxs)(s.p,{children:[(0,r.jsx)(s.code,{children:"request"}),": A PolicyRequest object, which has the following properties:"]}),"\n",(0,r.jsxs)(s.ul,{children:["\n",(0,r.jsxs)(s.li,{children:["\n",(0,r.jsxs)(s.p,{children:[(0,r.jsx)(s.code,{children:"request.user"}),": The current user, against which the policy is applied. See ",(0,r.jsx)(s.a,{href:"/docs/users-sources/user/",children:"User"})]}),"\n",(0,r.jsxs)(s.admonition,{type:"caution",children:[(0,r.jsxs)(s.p,{children:["When a policy is executed in the context of a flow, this will be set to the user initiaing request, and will only be changed by a ",(0,r.jsx)(s.code,{children:"user_login"})," stage. For that reason, using this value in authentication flow policies may not return the expected user. Use ",(0,r.jsx)(s.code,{children:"context['pending_user']"})," instead; User Identification and other stages update this value during flow execution."]}),(0,r.jsxs)(s.p,{children:["If the user is not authenticated, this will be set to a user called ",(0,r.jsx)(s.em,{children:"AnonymousUser"}),", which is an instance of ",(0,r.jsx)(s.a,{href:"https://docs.djangoproject.com/en/4.1/ref/contrib/auth/#django.contrib.auth.models.User",children:"authentik.core.models.User"})," (authentik uses django-guardian for per-object permissions, ",(0,r.jsx)(s.a,{href:"https://django-guardian.readthedocs.io/en/stable/",children:"see"}),")."]})]}),"\n"]}),"\n",(0,r.jsxs)(s.li,{children:["\n",(0,r.jsxs)(s.p,{children:[(0,r.jsx)(s.code,{children:"request.http_request"}),": The Django HTTP Request. See ",(0,r.jsx)(s.a,{href:"https://docs.djangoproject.com/en/4.1/ref/request-response/#httprequest-objects",children:"Django documentation"}),"."]}),"\n"]}),"\n",(0,r.jsxs)(s.li,{children:["\n",(0,r.jsxs)(s.p,{children:[(0,r.jsx)(s.code,{children:"request.obj"}),": A Django Model instance. This is only set if the policy is ran against an object."]}),"\n"]}),"\n",(0,r.jsxs)(s.li,{children:["\n",(0,r.jsxs)(s.p,{children:[(0,r.jsx)(s.code,{children:"request.context"}),": A dictionary with dynamic data. This depends on the origin of the execution."]}),"\n"]}),"\n"]}),"\n"]}),"\n",(0,r.jsxs)(s.li,{children:["\n",(0,r.jsxs)(s.p,{children:[(0,r.jsx)(s.code,{children:"geoip"}),": GeoIP dictionary. The following fields are available:"]}),"\n",(0,r.jsx)(s.admonition,{type:"info",children:(0,r.jsxs)(s.p,{children:["For basic country matching, consider using a ",(0,r.jsx)(s.a,{href:"/docs/customize/policies/#geoip-policy",children:"GeoIP policy"}),"."]})}),"\n",(0,r.jsxs)(s.ul,{children:["\n",(0,r.jsxs)(s.li,{children:[(0,r.jsx)(s.code,{children:"continent"}),": a two character continent code like ",(0,r.jsx)(s.code,{children:"NA"})," (North America) or ",(0,r.jsx)(s.code,{children:"OC"})," (Oceania)."]}),"\n",(0,r.jsxs)(s.li,{children:[(0,r.jsx)(s.code,{children:"country"}),":\xa0the two character ",(0,r.jsx)(s.a,{href:"https://en.wikipedia.org/wiki/ISO_3166-1",children:"ISO 3166-1"})," alpha code for the country."]}),"\n",(0,r.jsxs)(s.li,{children:[(0,r.jsx)(s.code,{children:"lat"}),": the approximate latitude of the location associated with the IP address."]}),"\n",(0,r.jsxs)(s.li,{children:[(0,r.jsx)(s.code,{children:"long"}),": the approximate longitude of the location associated with the IP address."]}),"\n",(0,r.jsxs)(s.li,{children:[(0,r.jsx)(s.code,{children:"city"}),": the name of the city. May be empty."]}),"\n"]}),"\n",(0,r.jsx)(s.pre,{children:(0,r.jsx)(s.code,{className:"language-python",children:'return context["geoip"]["continent"] == "EU"\n'})}),"\n"]}),"\n",(0,r.jsxs)(s.li,{children:["\n",(0,r.jsxs)(s.p,{children:[(0,r.jsx)(s.code,{children:"asn"}),": ASN dictionary. The following fields are available:"]}),"\n",(0,r.jsx)(s.admonition,{type:"info",children:(0,r.jsxs)(s.p,{children:["For basic ASN matching, consider using a ",(0,r.jsx)(s.a,{href:"/docs/customize/policies/#geoip-policy",children:"GeoIP policy"}),"."]})}),"\n",(0,r.jsxs)(s.ul,{children:["\n",(0,r.jsxs)(s.li,{children:[(0,r.jsx)(s.code,{children:"asn"}),": the autonomous system number associated with the IP address."]}),"\n",(0,r.jsxs)(s.li,{children:[(0,r.jsx)(s.code,{children:"as_org"}),": the organization associated with the registered autonomous system number for the IP address."]}),"\n",(0,r.jsxs)(s.li,{children:[(0,r.jsx)(s.code,{children:"network"}),": the network associated with the record. In particular, this is the largest network where all of the fields except ",(0,r.jsx)(s.code,{children:"ip_address"})," have the same value."]}),"\n"]}),"\n",(0,r.jsx)(s.pre,{children:(0,r.jsx)(s.code,{className:"language-python",children:'return context["asn"]["asn"] == 64496\n'})}),"\n"]}),"\n",(0,r.jsxs)(s.li,{children:["\n",(0,r.jsxs)(s.p,{children:[(0,r.jsx)(s.code,{children:"ak_is_sso_flow"}),": Boolean which is true if request was initiated by authenticating through an external provider."]}),"\n"]}),"\n",(0,r.jsxs)(s.li,{children:["\n",(0,r.jsxs)(s.p,{children:[(0,r.jsx)(s.code,{children:"ak_client_ip"}),": Client's IP Address or 255.255.255.255 if no IP Address could be extracted. Can be ",(0,r.jsx)(s.a,{href:"#comparing-ip-addresses",children:"compared"}),", for example"]}),"\n",(0,r.jsx)(s.pre,{children:(0,r.jsx)(s.code,{className:"language-python",children:"return ak_client_ip in ip_network('10.0.0.0/24')\n# or\nreturn ak_client_ip.is_private\n"})}),"\n",(0,r.jsxs)(s.p,{children:["See also ",(0,r.jsx)(s.a,{href:"https://docs.python.org/3/library/ipaddress.html#ipaddress.ip_address",children:"Python documentation"})]}),"\n"]}),"\n"]}),"\n",(0,r.jsxs)(s.p,{children:["Additionally, when the policy is executed from a flow, every variable from the flow's current context is accessible under the ",(0,r.jsx)(s.code,{children:"context"})," object."]}),"\n",(0,r.jsx)(s.p,{children:"This includes the following:"}),"\n",(0,r.jsxs)(s.ul,{children:["\n",(0,r.jsxs)(s.li,{children:["\n",(0,r.jsxs)(s.p,{children:[(0,r.jsx)(s.code,{children:"context['flow_plan']"}),": The actual flow plan itself, can be used to inject stages."]}),"\n",(0,r.jsxs)(s.ul,{children:["\n",(0,r.jsxs)(s.li,{children:[(0,r.jsx)(s.code,{children:"context['flow_plan'].context"}),": The context of the currently active flow, which differs from the policy context. Some fields of flow plan context are passed to the root context, and updated from it, like 'prompt_data', but not every variable"]}),"\n",(0,r.jsxs)(s.li,{children:[(0,r.jsx)(s.code,{children:"context['flow_plan'].context['redirect']"}),": The URL the user should be redirected to after the flow execution succeeds. (Optional)"]}),"\n"]}),"\n"]}),"\n",(0,r.jsxs)(s.li,{children:["\n",(0,r.jsxs)(s.p,{children:[(0,r.jsx)(s.code,{children:"context['prompt_data']"}),": Data which has been saved from a prompt stage or an external source. (Optional)"]}),"\n"]}),"\n",(0,r.jsxs)(s.li,{children:["\n",(0,r.jsxs)(s.p,{children:[(0,r.jsx)(s.code,{children:"context['application']"}),": The application the user is in the process of authorizing. (Optional)"]}),"\n"]}),"\n",(0,r.jsxs)(s.li,{children:["\n",(0,r.jsxs)(s.p,{children:[(0,r.jsx)(s.code,{children:"context['source']"}),": The source the user is authenticating/enrolling with. (Optional)"]}),"\n"]}),"\n",(0,r.jsxs)(s.li,{children:["\n",(0,r.jsxs)(s.p,{children:[(0,r.jsx)(s.code,{children:"context['pending_user']"}),": The currently pending user, see ",(0,r.jsx)(s.a,{href:"/docs/users-sources/user/user_ref",children:"User"})]}),"\n"]}),"\n",(0,r.jsxs)(s.li,{children:["\n",(0,r.jsxs)(s.p,{children:[(0,r.jsx)(s.code,{children:"context['is_restored']"}),": Contains the flow token when the flow plan was restored from a link, for example the user clicked a link to a flow which was sent by an email stage. (Optional)"]}),"\n"]}),"\n",(0,r.jsxs)(s.li,{children:["\n",(0,r.jsxs)(s.p,{children:[(0,r.jsx)(s.code,{children:"context['auth_method']"}),": Authentication method (this value is set by password stages) (Optional)"]}),"\n",(0,r.jsxs)(s.p,{children:["Depending on method, ",(0,r.jsx)(s.code,{children:"context['auth_method_args']"})," is also set."]}),"\n",(0,r.jsx)(s.p,{children:"Can be any of:"}),"\n",(0,r.jsxs)(s.ul,{children:["\n",(0,r.jsxs)(s.li,{children:["\n",(0,r.jsxs)(s.p,{children:[(0,r.jsx)(s.code,{children:"password"}),": Standard password login"]}),"\n"]}),"\n",(0,r.jsxs)(s.li,{children:["\n",(0,r.jsxs)(s.p,{children:[(0,r.jsx)(s.code,{children:"auth_mfa"}),": MFA login (this method is only set if no password was used)"]}),"\n",(0,r.jsxs)(s.p,{children:["Sets ",(0,r.jsx)(s.code,{children:"context['auth_method_args']"})," to"]}),"\n",(0,r.jsx)(s.pre,{children:(0,r.jsx)(s.code,{className:"language-json",children:'{\n    "mfa_devices": [\n        {\n            "pk": 1,\n            "app": "otp_static",\n            "name": "Static Token",\n            "model_name": "staticdevice"\n        }\n    ]\n}\n'})}),"\n"]}),"\n",(0,r.jsxs)(s.li,{children:["\n",(0,r.jsxs)(s.p,{children:[(0,r.jsx)(s.code,{children:"auth_webauthn_pwl"}),": Password-less WebAuthn login"]}),"\n"]}),"\n",(0,r.jsxs)(s.li,{children:["\n",(0,r.jsxs)(s.p,{children:[(0,r.jsx)(s.code,{children:"jwt"}),": OAuth Machine-to-machine login via external JWT"]}),"\n"]}),"\n",(0,r.jsxs)(s.li,{children:["\n",(0,r.jsxs)(s.p,{children:[(0,r.jsx)(s.code,{children:"app_password"}),": App password (token)"]}),"\n",(0,r.jsxs)(s.p,{children:["Sets ",(0,r.jsx)(s.code,{children:"context['auth_method_args']"})," to"]}),"\n",(0,r.jsx)(s.pre,{children:(0,r.jsx)(s.code,{className:"language-json",children:'{\n    "token": {\n        "pk": "f6d639aac81940f38dcfdc6e0fe2a786",\n        "app": "authentik_core",\n        "name": "test (expires=2021-08-23 15:45:54.725880+00:00)",\n        "model_name": "token"\n    }\n}\n'})}),"\n"]}),"\n",(0,r.jsxs)(s.li,{children:["\n",(0,r.jsxs)(s.p,{children:[(0,r.jsx)(s.code,{children:"ldap"}),": LDAP bind authentication"]}),"\n",(0,r.jsxs)(s.p,{children:["Sets ",(0,r.jsx)(s.code,{children:"context['auth_method_args']"})," to"]}),"\n",(0,r.jsx)(s.pre,{children:(0,r.jsx)(s.code,{className:"language-json",children:'{\n    "source": {} // Information about the source used\n}\n'})}),"\n"]}),"\n"]}),"\n"]}),"\n"]})]})}function p(e={}){const{wrapper:s}={...(0,t.R)(),...e.components};return s?(0,r.jsx)(s,{...e,children:(0,r.jsx)(u,{...e})}):u(e)}},70482:(e,s,n)=>{n.d(s,{Ay:()=>a,RM:()=>t});var i=n(74848),r=n(28453);const t=[{value:"<code>regex_match(value: Any, regex: str) -&gt; bool</code>",id:"regex_matchvalue-any-regex-str---bool",level:3},{value:"<code>regex_replace(value: Any, regex: str, repl: str) -&gt; str</code>",id:"regex_replacevalue-any-regex-str-repl-str---str",level:3},{value:"<code>list_flatten(value: list[Any] | Any) -&gt; Optional[Any]</code>",id:"list_flattenvalue-listany--any---optionalany",level:3},{value:'<code>ak_call_policy(name: str, **kwargs) -&gt; PolicyResult</code> <span class="badge badge--version">authentik 2021.12+</span>',id:"ak_call_policyname-str-kwargs---policyresult-authentik-202112",level:3},{value:"<code>ak_is_group_member(user: User, **group_filters) -&gt; bool</code>",id:"ak_is_group_memberuser-user-group_filters---bool",level:3},{value:"<code>ak_user_by(**filters) -&gt; Optional[User]</code>",id:"ak_user_byfilters---optionaluser",level:3},{value:'<code>ak_user_has_authenticator(user: User, device_type: Optional[str] = None) -&gt; bool</code> <span class="badge badge--version">authentik 2022.9+</span>',id:"ak_user_has_authenticatoruser-user-device_type-optionalstr--none---bool-authentik-20229",level:3},{value:'<code>ak_create_event(action: str, **kwargs) -&gt; None</code> <span class="badge badge--version">authentik 2022.9+</span>',id:"ak_create_eventaction-str-kwargs---none-authentik-20229",level:3},{value:'<code>ak_create_jwt(user: User, provider: OAuth2Provider | str, scopes: list[str], validity = &quot;seconds=60&quot;) -&gt; str | None</code> <span class="badge badge--version">authentik 2025.2+</span>',id:"ak_create_jwtuser-user-provider-oauth2provider--str-scopes-liststr-validity--seconds60---str--none-authentik-20252",level:3},{value:"Comparing IP Addresses",id:"comparing-ip-addresses",level:2},{value:'DNS resolution and reverse DNS lookups <span class="badge badge--version">authentik 2023.3+</span>',id:"dns-resolution-and-reverse-dns-lookups-authentik-20233",level:2}];function o(e){const s={a:"a",admonition:"admonition",code:"code",em:"em",h2:"h2",h3:"h3",li:"li",p:"p",pre:"pre",ul:"ul",...(0,r.R)(),...e.components};return(0,i.jsxs)(i.Fragment,{children:[(0,i.jsx)(s.h3,{id:"regex_matchvalue-any-regex-str---bool",children:(0,i.jsx)(s.code,{children:"regex_match(value: Any, regex: str) -> bool"})}),"\n",(0,i.jsxs)(s.p,{children:["Check if ",(0,i.jsx)(s.code,{children:"value"})," matches Regular Expression ",(0,i.jsx)(s.code,{children:"regex"}),"."]}),"\n",(0,i.jsx)(s.p,{children:"Example:"}),"\n",(0,i.jsx)(s.pre,{children:(0,i.jsx)(s.code,{className:"language-python",children:"return regex_match(request.user.username, '.*admin.*')\n"})}),"\n",(0,i.jsx)(s.h3,{id:"regex_replacevalue-any-regex-str-repl-str---str",children:(0,i.jsx)(s.code,{children:"regex_replace(value: Any, regex: str, repl: str) -> str"})}),"\n",(0,i.jsxs)(s.p,{children:["Replace anything matching ",(0,i.jsx)(s.code,{children:"regex"})," within ",(0,i.jsx)(s.code,{children:"value"})," with ",(0,i.jsx)(s.code,{children:"repl"})," and return it."]}),"\n",(0,i.jsx)(s.p,{children:"Example:"}),"\n",(0,i.jsx)(s.pre,{children:(0,i.jsx)(s.code,{className:"language-python",children:"user_email_local = regex_replace(request.user.email, '(.+)@.+', '')\n"})}),"\n",(0,i.jsx)(s.h3,{id:"list_flattenvalue-listany--any---optionalany",children:(0,i.jsx)(s.code,{children:"list_flatten(value: list[Any] | Any) -> Optional[Any]"})}),"\n",(0,i.jsx)(s.p,{children:"Flatten a list by either returning its first element, None if the list is empty, or the passed in object if its not a list."}),"\n",(0,i.jsx)(s.p,{children:"Example:"}),"\n",(0,i.jsx)(s.pre,{children:(0,i.jsx)(s.code,{className:"language-python",children:'user = list_flatten(["foo"])\n# user = "foo"\n'})}),"\n",(0,i.jsxs)(s.h3,{id:"ak_call_policyname-str-kwargs---policyresult-authentik-202112",children:[(0,i.jsx)(s.code,{children:"ak_call_policy(name: str, **kwargs) -> PolicyResult"})," ",(0,i.jsx)("span",{class:"badge badge--version",children:"authentik 2021.12+"})]}),"\n",(0,i.jsxs)(s.p,{children:["Call another policy with the name ",(0,i.jsx)(s.em,{children:"name"}),". Current request is passed to policy. Key-word arguments\ncan be used to modify the request's context."]}),"\n",(0,i.jsx)(s.p,{children:"Example:"}),"\n",(0,i.jsx)(s.pre,{children:(0,i.jsx)(s.code,{className:"language-python",children:'result = ak_call_policy("test-policy")\n# result is a PolicyResult object, so you can access `.passing` and `.messages`.\n# Starting with authentik 2023.4 you can also access `.raw_result`, which is the raw value returned from the called policy\n# `result.passing` will always be a boolean if the policy is passing or not.\nreturn result.passing\n\nresult = ak_call_policy("test-policy-2", foo="bar")\n# Inside the `test-policy-2` you can then use `request.context["foo"]`\nreturn result.passing\n'})}),"\n",(0,i.jsx)(s.h3,{id:"ak_is_group_memberuser-user-group_filters---bool",children:(0,i.jsx)(s.code,{children:"ak_is_group_member(user: User, **group_filters) -> bool"})}),"\n",(0,i.jsxs)(s.p,{children:["Check if ",(0,i.jsx)(s.code,{children:"user"})," is member of a group matching ",(0,i.jsx)(s.code,{children:"**group_filters"}),"."]}),"\n",(0,i.jsx)(s.p,{children:"Example:"}),"\n",(0,i.jsx)(s.pre,{children:(0,i.jsx)(s.code,{className:"language-python",children:'return ak_is_group_member(request.user, name="test_group")\n'})}),"\n",(0,i.jsx)(s.h3,{id:"ak_user_byfilters---optionaluser",children:(0,i.jsx)(s.code,{children:"ak_user_by(**filters) -> Optional[User]"})}),"\n",(0,i.jsxs)(s.p,{children:["Fetch a user matching ",(0,i.jsx)(s.code,{children:"**filters"}),"."]}),"\n",(0,i.jsxs)(s.p,{children:['Returns "None" if no user was found, otherwise returns the ',(0,i.jsx)(s.a,{href:"/docs/users-sources/user",children:"User"})," object."]}),"\n",(0,i.jsx)(s.p,{children:"Example:"}),"\n",(0,i.jsx)(s.pre,{children:(0,i.jsx)(s.code,{className:"language-python",children:'other_user = ak_user_by(username="other_user")\n'})}),"\n",(0,i.jsxs)(s.h3,{id:"ak_user_has_authenticatoruser-user-device_type-optionalstr--none---bool-authentik-20229",children:[(0,i.jsx)(s.code,{children:"ak_user_has_authenticator(user: User, device_type: Optional[str] = None) -> bool"})," ",(0,i.jsx)("span",{class:"badge badge--version",children:"authentik 2022.9+"})]}),"\n",(0,i.jsx)(s.p,{children:"Check if a user has any authenticator devices. Only fully validated devices are counted."}),"\n",(0,i.jsx)(s.p,{children:"Optionally, you can filter a specific device type. The following options are valid:"}),"\n",(0,i.jsxs)(s.ul,{children:["\n",(0,i.jsx)(s.li,{children:(0,i.jsx)(s.code,{children:"totp"})}),"\n",(0,i.jsx)(s.li,{children:(0,i.jsx)(s.code,{children:"duo"})}),"\n",(0,i.jsx)(s.li,{children:(0,i.jsx)(s.code,{children:"static"})}),"\n",(0,i.jsx)(s.li,{children:(0,i.jsx)(s.code,{children:"webauthn"})}),"\n"]}),"\n",(0,i.jsx)(s.p,{children:"Example:"}),"\n",(0,i.jsx)(s.pre,{children:(0,i.jsx)(s.code,{className:"language-python",children:"return ak_user_has_authenticator(request.user)\n"})}),"\n",(0,i.jsxs)(s.h3,{id:"ak_create_eventaction-str-kwargs---none-authentik-20229",children:[(0,i.jsx)(s.code,{children:"ak_create_event(action: str, **kwargs) -> None"})," ",(0,i.jsx)("span",{class:"badge badge--version",children:"authentik 2022.9+"})]}),"\n",(0,i.jsxs)(s.p,{children:["Create a new event with the action set to ",(0,i.jsx)(s.code,{children:"action"}),". Any additional key-word parameters will be saved in the event context. Additionally, ",(0,i.jsx)(s.code,{children:"context"})," will be set to the context in which this function is called."]}),"\n",(0,i.jsx)(s.p,{children:"Before saving, any data-structure which are not representable in JSON are flattened, and credentials are removed."}),"\n",(0,i.jsx)(s.p,{children:"The event is saved automatically"}),"\n",(0,i.jsx)(s.p,{children:"Example:"}),"\n",(0,i.jsx)(s.pre,{children:(0,i.jsx)(s.code,{className:"language-python",children:'ak_create_event("my_custom_event", foo=request.user)\n'})}),"\n",(0,i.jsxs)(s.h3,{id:"ak_create_jwtuser-user-provider-oauth2provider--str-scopes-liststr-validity--seconds60---str--none-authentik-20252",children:[(0,i.jsx)(s.code,{children:'ak_create_jwt(user: User, provider: OAuth2Provider | str, scopes: list[str], validity = "seconds=60") -> str | None'})," ",(0,i.jsx)("span",{class:"badge badge--version",children:"authentik 2025.2+"})]}),"\n",(0,i.jsxs)(s.p,{children:["Create a new JWT signed by the given ",(0,i.jsx)(s.code,{children:"provider"})," for ",(0,i.jsx)(s.code,{children:"user"}),"."]}),"\n",(0,i.jsxs)(s.p,{children:["The ",(0,i.jsx)(s.code,{children:"provider"})," parameter can either be an instance of ",(0,i.jsx)(s.code,{children:"OAuth2Provider"})," or a the name of a provider instance as a string. Scopes is an array of all scopes that the JWT should have."]}),"\n",(0,i.jsxs)(s.p,{children:["The JWT is valid for 60 seconds by default, this can be customized using the ",(0,i.jsx)(s.code,{children:"validity"})," parameter. The syntax of the parameter is ",(0,i.jsx)(s.code,{children:"hours=1,minutes=2,seconds=3"}),". The following keys are allowed:"]}),"\n",(0,i.jsxs)(s.ul,{children:["\n",(0,i.jsx)(s.li,{children:"Microseconds"}),"\n",(0,i.jsx)(s.li,{children:"Milliseconds"}),"\n",(0,i.jsx)(s.li,{children:"Seconds"}),"\n",(0,i.jsx)(s.li,{children:"Minutes"}),"\n",(0,i.jsx)(s.li,{children:"Hours"}),"\n",(0,i.jsx)(s.li,{children:"Days"}),"\n",(0,i.jsx)(s.li,{children:"Weeks"}),"\n"]}),"\n",(0,i.jsx)(s.p,{children:"All values accept floating-point values."}),"\n",(0,i.jsx)(s.p,{children:"Example:"}),"\n",(0,i.jsx)(s.pre,{children:(0,i.jsx)(s.code,{className:"language-python",children:'jwt = ak_create_jwt(request.user, "my-oauth2-provider-name", ["openid", "profile", "email"])\n'})}),"\n",(0,i.jsx)(s.h2,{id:"comparing-ip-addresses",children:"Comparing IP Addresses"}),"\n",(0,i.jsxs)(s.p,{children:["To compare IP Addresses or check if an IP Address is within a given subnet, you can use the functions ",(0,i.jsx)(s.code,{children:"ip_address('192.0.2.1')"})," and ",(0,i.jsx)(s.code,{children:"ip_network('192.0.2.0/24')"}),". With these objects you can do ",(0,i.jsx)(s.a,{href:"https://docs.python.org/3/library/ipaddress.html#operators",children:"arithmetic operations"}),"."]}),"\n",(0,i.jsx)(s.p,{children:"You can also check if an IP Address is within a subnet by writing the following:"}),"\n",(0,i.jsx)(s.pre,{children:(0,i.jsx)(s.code,{className:"language-python",children:"ip_address('192.0.2.1') in ip_network('192.0.2.0/24')\n# evaluates to True\n"})}),"\n",(0,i.jsxs)(s.h2,{id:"dns-resolution-and-reverse-dns-lookups-authentik-20233",children:["DNS resolution and reverse DNS lookups ",(0,i.jsx)("span",{class:"badge badge--version",children:"authentik 2023.3+"})]}),"\n",(0,i.jsxs)(s.p,{children:["To resolve a hostname to a list of IP addresses, use the functions ",(0,i.jsx)(s.code,{children:"resolve_dns(hostname)"})," and ",(0,i.jsx)(s.code,{children:"resolve_dns(hostname, ip_version)"}),"."]}),"\n",(0,i.jsx)(s.pre,{children:(0,i.jsx)(s.code,{className:"language-python",children:'resolve_dns("google.com")  # return a list of all IPv4 and IPv6 addresses\nresolve_dns("google.com", 4)  # return a list of only IP4 addresses\nresolve_dns("google.com", 6)  # return a list of only IP6 addresses\n'})}),"\n",(0,i.jsx)(s.p,{children:"You can also do reverse DNS lookups."}),"\n",(0,i.jsx)(s.admonition,{type:"note",children:(0,i.jsxs)(s.p,{children:["Reverse DNS lookups may not return the expected host if the IP address is part of a shared hosting environment.\nSee: ",(0,i.jsx)(s.a,{href:"https://stackoverflow.com/a/19867936",children:"https://stackoverflow.com/a/19867936"})]})}),"\n",(0,i.jsxs)(s.p,{children:["To perform a reverse DNS lookup use ",(0,i.jsx)(s.code,{children:'reverse_dns("192.0.2.0")'}),". If no DNS records are found the original IP address is returned."]}),"\n",(0,i.jsx)(s.admonition,{type:"info",children:(0,i.jsx)(s.p,{children:"DNS resolving results are cached in memory. The last 32 unique queries are cached for up to 3 minutes."})})]})}function a(e={}){const{wrapper:s}={...(0,r.R)(),...e.components};return s?(0,i.jsx)(s,{...e,children:(0,i.jsx)(o,{...e})}):o(e)}},3575:(e,s,n)=>{n.d(s,{Ay:()=>a,RM:()=>t});var i=n(74848),r=n(28453);const t=[];function o(e){const s={a:"a",code:"code",li:"li",p:"p",pre:"pre",ul:"ul",...(0,r.R)(),...e.components};return(0,i.jsxs)(s.ul,{children:["\n",(0,i.jsxs)(s.li,{children:["\n",(0,i.jsxs)(s.p,{children:[(0,i.jsx)(s.code,{children:"ak_logger"}),": structlog BoundLogger. See (",(0,i.jsx)(s.a,{href:"https://www.structlog.org/en/stable/api.html#structlog.BoundLogger",children:"structlog documentation"}),")"]}),"\n",(0,i.jsx)(s.p,{children:"Example:"}),"\n",(0,i.jsx)(s.pre,{children:(0,i.jsx)(s.code,{className:"language-python",children:'ak_logger.debug("This is a test message")\nak_logger.warning("This will be logged with a warning level")\nak_logger.info("Passing structured data", request=request)\n'})}),"\n"]}),"\n",(0,i.jsxs)(s.li,{children:["\n",(0,i.jsxs)(s.p,{children:[(0,i.jsx)(s.code,{children:"requests"}),": requests Session object. See (",(0,i.jsx)(s.a,{href:"https://requests.readthedocs.io/en/master/user/advanced/",children:"request documentation"}),")"]}),"\n"]}),"\n"]})}function a(e={}){const{wrapper:s}={...(0,r.R)(),...e.components};return s?(0,i.jsx)(s,{...e,children:(0,i.jsx)(o,{...e})}):o(e)}}}]);