"use strict";(self.webpackChunk_goauthentik_website_docs=self.webpackChunk_goauthentik_website_docs||[]).push([[23971],{59286:(e,t,n)=>{n.r(t),n.d(t,{assets:()=>c,contentTitle:()=>d,default:()=>p,frontMatter:()=>l,metadata:()=>r,toc:()=>u});const r=JSON.parse('{"id":"install-config/upgrade","title":"Upgrade authentik","description":"Upgrading to the latest version of authentik, whether a new major release or a patch, involves running a few commands to pull down the latest images and then restarting the servers and databases.","source":"@site/docs/install-config/upgrade.mdx","sourceDirName":"install-config","slug":"/install-config/upgrade","permalink":"/docs/install-config/upgrade","draft":false,"unlisted":false,"editUrl":"https://github.com/goauthentik/authentik/edit/main/website/docs/install-config/upgrade.mdx","tags":[],"version":"current","frontMatter":{"title":"Upgrade authentik"},"sidebar":"docs","previous":{"title":"Configuration","permalink":"/docs/install-config/configuration/"},"next":{"title":"Beta versions","permalink":"/docs/install-config/beta"}}');var o=n(74848),s=n(28453),a=n(64911),i=n(79329);const l={title:"Upgrade authentik"},d=void 0,c={},u=[{value:"Important considerations",id:"important-considerations",level:2},{value:"Upgrade authentik",id:"upgrade-authentik",level:2},{value:"1. Retrieve latest <code>docker-compose.yml</code> file",id:"1-retrieve-latest-docker-composeyml-file",level:4},{value:"Verify your upgrade",id:"verify-your-upgrade",level:2},{value:"Troubleshooting your upgrade",id:"troubleshooting-your-upgrade",level:2}];function h(e){const t={a:"a",admonition:"admonition",code:"code",h2:"h2",h4:"h4",img:"img",li:"li",ol:"ol",p:"p",pre:"pre",strong:"strong",ul:"ul",...(0,s.R)(),...e.components};return(0,o.jsxs)(o.Fragment,{children:[(0,o.jsx)(t.p,{children:"Upgrading to the latest version of authentik, whether a new major release or a patch, involves running a few commands to pull down the latest images and then restarting the servers and databases."}),"\n",(0,o.jsx)(t.h2,{id:"important-considerations",children:"Important considerations"}),"\n",(0,o.jsx)(t.admonition,{type:"danger",children:(0,o.jsx)(t.p,{children:"authentik does not support downgrading. Make sure to back up your database in case you need to revert an upgrade."})}),"\n",(0,o.jsxs)(t.ul,{children:["\n",(0,o.jsxs)(t.li,{children:["\n",(0,o.jsxs)(t.p,{children:["Be sure to carefully read the ",(0,o.jsx)(t.a,{href:"../releases/",children:"Release Notes"})," for the specific version to which you plan to upgrade. The release might have special requirements or actions or contain breaking changes."]}),"\n"]}),"\n",(0,o.jsxs)(t.li,{children:["\n",(0,o.jsxs)(t.p,{children:["Make a backup of your PostgreSQL database before upgrading. You can dump your existing database to get a backup file. For more information about dumping and backing up your database, refer to ",(0,o.jsx)(t.a,{href:"/docs/troubleshooting/postgres/upgrade_docker",children:"Upgrade PostgreSQL on Docker Compose"})," or ",(0,o.jsx)(t.a,{href:"/docs/troubleshooting/postgres/upgrade_kubernetes",children:"Upgrade PostgreSQL on Kubernetes"}),"."]}),"\n"]}),"\n",(0,o.jsxs)(t.li,{children:["\n",(0,o.jsx)(t.p,{children:"You need to upgrade in sequence of the major releases; do not skip directly from an older major version to the most recent version. For example, if you are currently running 2023.10.3, you will need to first upgrade to 2024.2.x, then 2024.4.x, and then 2024.6.x, in sequence."}),"\n"]}),"\n",(0,o.jsxs)(t.li,{children:["\n",(0,o.jsx)(t.p,{children:"The version of the authentik instance and any outposts must be the same. We recommended that you always upgrade any outposts at the same time you upgrade your authentik instance."}),"\n"]}),"\n"]}),"\n",(0,o.jsx)(t.h2,{id:"upgrade-authentik",children:"Upgrade authentik"}),"\n","\n",(0,o.jsxs)(a.A,{groupId:"platform",children:[(0,o.jsxs)(i.default,{value:"docker-compose",label:"Docker Compose",default:!0,children:[(0,o.jsx)(t.p,{children:"In your terminal, navigate to your installation directory and follow these steps:"}),(0,o.jsxs)(t.h4,{id:"1-retrieve-latest-docker-composeyml-file",children:["1. Retrieve latest ",(0,o.jsx)(t.code,{children:"docker-compose.yml"})," file"]}),(0,o.jsxs)(t.p,{children:["Download the ",(0,o.jsx)(t.code,{children:"docker-compose.yml"})," file using either ",(0,o.jsx)(t.code,{children:"wget -O docker-compose.yml https://goauthentik.io/docker-compose.yml"})," or ",(0,o.jsx)(t.code,{children:"curl -O https://goauthentik.io/docker-compose.yml"})," or a similar process."]}),(0,o.jsx)(t.p,{children:(0,o.jsx)(t.strong,{children:"2. Run upgrade commands"})}),(0,o.jsx)(t.pre,{children:(0,o.jsx)(t.code,{className:"language-shell",children:"docker compose pull\ndocker compose up -d\n"})})]}),(0,o.jsxs)(i.default,{value:"kubernetes",label:"Kubernetes",children:[(0,o.jsx)(t.p,{children:"In your terminal, navigate to your installation directory and run the following commands:"}),(0,o.jsx)(t.pre,{children:(0,o.jsx)(t.code,{children:"helm repo update\nhelm upgrade --install authentik authentik/authentik -f values.yaml\n"})})]}),(0,o.jsxs)(i.default,{value:"aws-cloudformation-ecs",label:"AWS Cloudformation ECS",children:[(0,o.jsxs)(t.p,{children:["Navigate to your authentik AWS Cloudformation stack. Click on the ",(0,o.jsx)(t.strong,{children:"Changesets"})," tab and ",(0,o.jsx)(t.strong,{children:"Create changeset"}),"."]}),(0,o.jsxs)(t.p,{children:["Select ",(0,o.jsx)(t.strong,{children:"Use existing template"})," and follow the prompts to upgrade."]}),(0,o.jsxs)(t.p,{children:["To upgrade to a specific version, select ",(0,o.jsx)(t.strong,{children:"Replace existing template"})," and use the following URL: ",(0,o.jsx)(t.code,{children:"https://authentik-cloudformation-templates.s3.amazonaws.com/authentik.ecs.VERSION.yaml"})," replacing ",(0,o.jsx)(t.code,{children:"VERSION"})," with the version you want to upgrade to. You can use ",(0,o.jsx)(t.code,{children:"latest"})," to upgrade to the latest version."]})]})]}),"\n",(0,o.jsx)(t.h2,{id:"verify-your-upgrade",children:"Verify your upgrade"}),"\n",(0,o.jsxs)(t.p,{children:["You can view the current version of your authentik instance by logging in to the Admin interface, and then navigating to ",(0,o.jsx)(t.strong,{children:"Dashboards -> Overview"}),"."]}),"\n",(0,o.jsx)(t.p,{children:(0,o.jsx)(t.img,{src:n(30009).A+"",width:"871",height:"444"})}),"\n",(0,o.jsx)(t.h2,{id:"troubleshooting-your-upgrade",children:"Troubleshooting your upgrade"}),"\n",(0,o.jsx)(t.p,{children:"If you run the upgrade commands but your version on the Dashboard doesn\u2019t change, follow this steps:"}),"\n",(0,o.jsxs)(t.ol,{children:["\n",(0,o.jsxs)(t.li,{children:["Look at the server logs and search for an entry of ",(0,o.jsx)(t.code,{children:"migration inconsistency"}),"."]}),"\n",(0,o.jsx)(t.li,{children:"If you see this entry, revert to your database backup."}),"\n",(0,o.jsx)(t.li,{children:"Now, upgrade to each subsequent higher version. That is, upgrade in sequence, do not skip directly to the most recent version."}),"\n"]})]})}function p(e={}){const{wrapper:t}={...(0,s.R)(),...e.components};return t?(0,o.jsx)(t,{...e,children:(0,o.jsx)(h,{...e})}):h(e)}},64911:(e,t,n)=>{n.d(t,{A:()=>p});var r=n(96540),o=n(34164),s=n(65627),a=n(77448),i=n(9136);const l={tabList:"tabList__CuJ",tabItem:"tabItem_LNqP"};var d=n(74848);function c(e){let{className:t,block:n,selectedValue:r,selectValue:a,tabValues:i}=e;const c=[],{blockElementScrollPositionUntilNextRender:u}=(0,s.a_)(),h=e=>{const t=e.currentTarget,n=c.indexOf(t),o=i[n].value;o!==r&&(u(t),a(o))},p=e=>{let t=null;switch(e.key){case"Enter":h(e);break;case"ArrowRight":{const n=c.indexOf(e.currentTarget)+1;t=c[n]??c[0];break}case"ArrowLeft":{const n=c.indexOf(e.currentTarget)-1;t=c[n]??c[c.length-1];break}}t?.focus()};return(0,d.jsx)("ul",{role:"tablist","aria-orientation":"horizontal",className:(0,o.A)("tabs",{"tabs--block":n},t),children:i.map((e=>{let{value:t,label:n,attributes:s}=e;return(0,d.jsx)("li",{role:"tab",tabIndex:r===t?0:-1,"aria-selected":r===t,ref:e=>{c.push(e)},onKeyDown:p,onClick:h,...s,className:(0,o.A)("tabs__item",l.tabItem,s?.className,{"tabs__item--active":r===t}),children:n??t},t)}))})}function u(e){let{lazy:t,children:n,selectedValue:s}=e;const a=(Array.isArray(n)?n:[n]).filter(Boolean);if(t){const e=a.find((e=>e.props.value===s));return e?(0,r.cloneElement)(e,{className:(0,o.A)("margin-top--md",e.props.className)}):null}return(0,d.jsx)("div",{className:"margin-top--md",children:a.map(((e,t)=>(0,r.cloneElement)(e,{key:t,hidden:e.props.value!==s})))})}function h(e){const t=(0,a.u)(e);return(0,d.jsxs)("div",{className:(0,o.A)("tabs-container",l.tabList),children:[(0,d.jsx)(c,{...t,...e}),(0,d.jsx)(u,{...t,...e})]})}function p(e){const t=(0,i.default)();return(0,d.jsx)(h,{...e,children:(0,a.v)(e.children)},String(t))}},30009:(e,t,n)=>{n.d(t,{A:()=>r});const r=n.p+"assets/images/version1-f73baf34355eeb07cb55687c0137cae9.png"}}]);