"use strict";(self.webpackChunk_goauthentik_website_docs=self.webpackChunk_goauthentik_website_docs||[]).push([[97739],{50500:(e,i,n)=>{n.r(i),n.d(i,{assets:()=>c,contentTitle:()=>a,default:()=>h,frontMatter:()=>r,metadata:()=>t,toc:()=>l});const t=JSON.parse('{"id":"services/minio/index","title":"Integrate with MinIO","description":"Support level: authentik","source":"@site/integrations/services/minio/index.md","sourceDirName":"services/minio","slug":"/services/minio/","permalink":"/integrations/services/minio/","draft":false,"unlisted":false,"editUrl":"https://github.com/goauthentik/authentik/edit/main/website/integrations/services/minio/index.md","tags":[],"version":"current","frontMatter":{"title":"Integrate with MinIO","sidebar_label":"MinIO"},"sidebar":"integrations","previous":{"title":"MeshCentral","permalink":"/integrations/services/meshcentral/"},"next":{"title":"NetBox","permalink":"/integrations/services/netbox/"}}');var s=n(74848),o=n(28453);const r={title:"Integrate with MinIO",sidebar_label:"MinIO"},a="Integrate with MinIO",c={},l=[{value:"What is MinIO",id:"what-is-minio",level:2},{value:"Preparation",id:"preparation",level:2},{value:"Mapping to MinIO policies",id:"mapping-to-minio-policies",level:3},{value:"Creating application and provider",id:"creating-application-and-provider",level:3},{value:"MinIO configuration",id:"minio-configuration",level:2},{value:"Web Interface",id:"web-interface",level:3},{value:"Command Line",id:"command-line",level:3}];function d(e){const i={a:"a",admonition:"admonition",blockquote:"blockquote",code:"code",h1:"h1",h2:"h2",h3:"h3",header:"header",li:"li",p:"p",pre:"pre",strong:"strong",ul:"ul",...(0,o.R)(),...e.components};return(0,s.jsxs)(s.Fragment,{children:[(0,s.jsx)(i.header,{children:(0,s.jsx)(i.h1,{id:"integrate-with-minio",children:"Integrate with MinIO"})}),"\n",(0,s.jsx)("span",{class:"badge badge--primary",children:"Support level: authentik"}),"\n",(0,s.jsx)(i.h2,{id:"what-is-minio",children:"What is MinIO"}),"\n",(0,s.jsxs)(i.blockquote,{children:["\n",(0,s.jsx)(i.p,{children:"MinIO is an Amazon S3 compatible object storage suite capable of handling structured and unstructured data including log files, artifacts, backups, container images, photos and videos. The current maximum supported object size is 5TB."}),"\n",(0,s.jsxs)(i.p,{children:["-- ",(0,s.jsx)(i.a,{href:"https://en.wikipedia.org/wiki/MinIO",children:"https://en.wikipedia.org/wiki/MinIO"})]}),"\n"]}),"\n",(0,s.jsx)(i.h2,{id:"preparation",children:"Preparation"}),"\n",(0,s.jsx)(i.p,{children:"The following placeholders are used in this guide:"}),"\n",(0,s.jsxs)(i.ul,{children:["\n",(0,s.jsxs)(i.li,{children:[(0,s.jsx)(i.code,{children:"minio.company"})," is the FQDN of the MinIO installation."]}),"\n",(0,s.jsxs)(i.li,{children:[(0,s.jsx)(i.code,{children:"authentik.company"})," is the FQDN of the authentik installation."]}),"\n"]}),"\n",(0,s.jsx)(i.admonition,{type:"note",children:(0,s.jsx)(i.p,{children:"This documentation lists only the settings that you need to change from their default values. Be aware that any changes other than those explicitly mentioned in this guide could cause issues accessing your application."})}),"\n",(0,s.jsx)(i.h3,{id:"mapping-to-minio-policies",children:"Mapping to MinIO policies"}),"\n",(0,s.jsxs)(i.p,{children:["The primary way to manage access in MinIO is via ",(0,s.jsx)(i.a,{href:"https://min.io/docs/minio/linux/administration/identity-access-management/policy-based-access-control.html#minio-policy",children:"policies"}),". We need to configure authentik to return a list of which MinIO policies should be applied to a user."]}),"\n",(0,s.jsxs)(i.p,{children:["Create a Scope Mapping: in the authentik Admin interface, navigate to ",(0,s.jsx)(i.strong,{children:"Customization -> Property Mappings"}),", click ",(0,s.jsx)(i.strong,{children:"Create"}),", and then select ",(0,s.jsx)(i.strong,{children:"Scope Mapping"}),'. Give the property mapping a name like "OIDC-Scope-minio". Set the scope name to ',(0,s.jsx)(i.code,{children:"minio"})," and the ",(0,s.jsx)(i.strong,{children:"Expression"})," to the following:"]}),"\n",(0,s.jsx)(i.pre,{children:(0,s.jsx)(i.code,{className:"language-python",children:'return {\n    "policy": "readwrite",\n}\n'})}),"\n",(0,s.jsxs)(i.p,{children:["This mapping applies the default MinIO ",(0,s.jsx)(i.code,{children:"readwrite"})," policy to all users. If you want to create a more granular mapping based on authentik groups, use an expression like this:"]}),"\n",(0,s.jsx)(i.pre,{children:(0,s.jsx)(i.code,{className:"language-python",children:'if ak_is_group_member(request.user, name="Minio admins"):\n  return {\n      "policy": "consoleAdmin",\n}\nelif ak_is_group_member(request.user, name="Minio users"):\n  return {\n      "policy": ["readonly", "my-custom-policy"]\n}\nreturn None\n'})}),"\n",(0,s.jsxs)(i.p,{children:["Note that you can assign multiple policies to a user by returning a list, and returning ",(0,s.jsx)(i.code,{children:"None"})," will map no policies to the user, resulting in no access to the MinIO instance. For more information on writing expressions, see ",(0,s.jsx)(i.a,{href:"/docs/add-secure-apps/providers/property-mappings/expression",children:"Expressions"})," and ",(0,s.jsx)(i.a,{href:"/docs/users-sources/user/user_ref#object-properties",children:"User"})," docs."]}),"\n",(0,s.jsx)(i.h3,{id:"creating-application-and-provider",children:"Creating application and provider"}),"\n",(0,s.jsx)(i.p,{children:"Create an application in authentik. Create an OAuth2/OpenID provider with the following parameters:"}),"\n",(0,s.jsxs)(i.ul,{children:["\n",(0,s.jsxs)(i.li,{children:["Client Type: ",(0,s.jsx)(i.code,{children:"Confidential"})]}),"\n",(0,s.jsx)(i.li,{children:"Scopes: OpenID, Email, Profile, and the scope you created above"}),"\n",(0,s.jsx)(i.li,{children:"Signing Key: Select any available key"}),"\n",(0,s.jsxs)(i.li,{children:["Redirect URIs: ",(0,s.jsx)(i.code,{children:"https://minio.company/oauth_callback"})]}),"\n"]}),"\n",(0,s.jsxs)(i.p,{children:["Set the scope of the MinIO scope mapping that you created in the provider (previous step) in the ",(0,s.jsx)(i.strong,{children:"Advanced"})," area under ",(0,s.jsx)(i.strong,{children:"Protocol Settings -> Scopes"}),"."]}),"\n",(0,s.jsx)(i.p,{children:"Note the Client ID and Client Secret values. Create an application, using the provider you've created above. Note the slug of the application you've created."}),"\n",(0,s.jsx)(i.h2,{id:"minio-configuration",children:"MinIO configuration"}),"\n",(0,s.jsx)(i.p,{children:"You can set up OpenID in two different ways: via the web interface or the command line."}),"\n",(0,s.jsx)(i.h3,{id:"web-interface",children:"Web Interface"}),"\n",(0,s.jsxs)(i.p,{children:["From the sidebar of the main page, go to ",(0,s.jsx)(i.strong,{children:"Identity -> OpenID"}),", click ",(0,s.jsx)(i.strong,{children:"Create"}),", and then define the configuration as follows:"]}),"\n",(0,s.jsxs)(i.ul,{children:["\n",(0,s.jsx)(i.li,{children:"Name: MinIO"}),"\n",(0,s.jsxs)(i.li,{children:["Config URL: ",(0,s.jsx)(i.code,{children:"https://authentik.company/application/o/<minio slug>/.well-known/openid-configuration"})]}),"\n",(0,s.jsx)(i.li,{children:"Client ID: Your client ID from the previous step"}),"\n",(0,s.jsx)(i.li,{children:"Client Secret: Your client secret from the previous step"}),"\n",(0,s.jsxs)(i.li,{children:["Scopes: ",(0,s.jsx)(i.code,{children:"openid, email, profile, minio"})]}),"\n",(0,s.jsxs)(i.li,{children:["Redirect URI: ",(0,s.jsx)(i.code,{children:"https://minio.company/oauth_callback"})]}),"\n"]}),"\n",(0,s.jsxs)(i.p,{children:["Finally, click ",(0,s.jsx)(i.strong,{children:"Save"})," and follow the instructions in the popup to restart your instance."]}),"\n",(0,s.jsx)(i.h3,{id:"command-line",children:"Command Line"}),"\n",(0,s.jsxs)(i.p,{children:["You must install the MinIO binaries from ",(0,s.jsx)(i.a,{href:"https://min.io/docs/minio/linux/reference/minio-mc.html",children:"here"}),". You then need to create an alias for your instance using: ",(0,s.jsx)(i.code,{children:"mc alias set myminio https://minio.company <access key> <secret key>"}),". You can follow ",(0,s.jsx)(i.a,{href:"https://stackoverflow.com/a/77645374",children:"this StackOverflow answer"})," to create a secret key and access key."]}),"\n",(0,s.jsx)(i.p,{children:"After that is done, run the following command to configure the OpenID provider:"}),"\n",(0,s.jsx)(i.pre,{children:(0,s.jsx)(i.code,{children:'~ mc admin config set myminio identity_openid \\\n  config_url="https://authentik.company/application/o/<minio slug>/.well-known/openid-configuration" \\\n  client_id="<client id>" \\\n  client_secret="<client secret>" \\\n  scopes="openid,profile,email,minio"\n'})}),"\n",(0,s.jsxs)(i.p,{children:["The ",(0,s.jsx)(i.a,{href:"https://min.io/docs/minio/linux/reference/minio-mc-admin/mc-admin-config.html#openid-identity-management",children:"upstream MinIO docs on OIDC"})," indicate that the ",(0,s.jsx)(i.code,{children:"client_secret"})," (and thus confidential client type) are optional depending on provider. Experimentally with a single-node MinIO instance, the client secret was required and worked without further issue."]})]})}function h(e={}){const{wrapper:i}={...(0,o.R)(),...e.components};return i?(0,s.jsx)(i,{...e,children:(0,s.jsx)(d,{...e})}):d(e)}}}]);