"use strict";(self.webpackChunk_goauthentik_website_docs=self.webpackChunk_goauthentik_website_docs||[]).push([[23366],{44668:(e,n,s)=>{s.r(n),s.d(n,{assets:()=>a,contentTitle:()=>c,default:()=>_,frontMatter:()=>l,metadata:()=>i,toc:()=>h});const i=JSON.parse('{"id":"install-config/configuration/configuration","title":"Configuration","description":"This page details all the authentik configuration options that you can set via environment variables.","source":"@site/docs/install-config/configuration/configuration.mdx","sourceDirName":"install-config/configuration","slug":"/install-config/configuration/","permalink":"/docs/install-config/configuration/","draft":false,"unlisted":false,"editUrl":"https://github.com/goauthentik/authentik/edit/main/website/docs/install-config/configuration/configuration.mdx","tags":[],"version":"current","frontMatter":{"title":"Configuration"},"sidebar":"docs","previous":{"title":"AWS installation","permalink":"/docs/install-config/install/aws"},"next":{"title":"Upgrade authentik","permalink":"/docs/install-config/upgrade"}}');var t=s(74848),o=s(28453),r=s(64911),d=s(79329);const l={title:"Configuration"},c=void 0,a={},h=[{value:"About authentik configurations",id:"about-authentik-configurations",level:2},{value:"Set your environment variables",id:"set-your-environment-variables",level:2},{value:"Verify your configuration settings",id:"verify-your-configuration-settings",level:2},{value:"PostgreSQL Settings",id:"postgresql-settings",level:2},{value:"Read replicas",id:"read-replicas",level:3},{value:"Using a PostgreSQL connection pooler (PgBouncer or PgPool)",id:"using-a-postgresql-connection-pooler-pgbouncer-or-pgpool",level:3},{value:"Redis Settings",id:"redis-settings",level:2},{value:"Result Backend Settings",id:"result-backend-settings",level:2},{value:"Cache Settings",id:"cache-settings",level:2},{value:"Channel Layer Settings (inter-instance communication)",id:"channel-layer-settings-inter-instance-communication",level:2},{value:"Broker Settings",id:"broker-settings",level:2},{value:"Listen Settings",id:"listen-settings",level:2},{value:"Media Storage Settings",id:"media-storage-settings",level:2},{value:"authentik Settings",id:"authentik-settings",level:2},{value:"<code>AUTHENTIK_SECRET_KEY</code>",id:"authentik_secret_key",level:3},{value:"<code>AUTHENTIK_LOG_LEVEL</code>",id:"authentik_log_level",level:3},{value:"<code>AUTHENTIK_COOKIE_DOMAIN</code>",id:"authentik_cookie_domain",level:3},{value:"<code>AUTHENTIK_EVENTS__CONTEXT_PROCESSORS__GEOIP</code>",id:"authentik_events__context_processors__geoip",level:3},{value:"<code>AUTHENTIK_EVENTS__CONTEXT_PROCESSORS__ASN</code>",id:"authentik_events__context_processors__asn",level:3},{value:"<code>AUTHENTIK_DISABLE_UPDATE_CHECK</code>",id:"authentik_disable_update_check",level:3},{value:"<code>AUTHENTIK_ERROR_REPORTING</code>",id:"authentik_error_reporting",level:3},{value:"<code>AUTHENTIK_EMAIL</code>",id:"authentik_email",level:3},{value:"<code>AUTHENTIK_OUTPOSTS</code>",id:"authentik_outposts",level:3},{value:'<code>AUTHENTIK_LDAP__TASK_TIMEOUT_HOURS</code> <span class="badge badge--version">authentik 2023.1+</span>',id:"authentik_ldap__task_timeout_hours-authentik-20231",level:3},{value:'<code>AUTHENTIK_LDAP__PAGE_SIZE</code> <span class="badge badge--version">authentik 2023.6.1+</span>',id:"authentik_ldap__page_size-authentik-202361",level:3},{value:'<code>AUTHENTIK_LDAP__TLS__CIPHERS</code> <span class="badge badge--version">authentik 2022.7+</span>',id:"authentik_ldap__tls__ciphers-authentik-20227",level:3},{value:'<code>AUTHENTIK_REPUTATION__EXPIRY</code> <span class="badge badge--version">authentik 2023.8.2+</span>',id:"authentik_reputation__expiry-authentik-202382",level:3},{value:'<code>AUTHENTIK_SESSION_STORAGE</code> <span class="badge badge--version">authentik 2024.4+</span>',id:"authentik_session_storage-authentik-20244",level:3},{value:'<code>AUTHENTIK_WEB__WORKERS</code> <span class="badge badge--version">authentik 2022.9+</span>',id:"authentik_web__workers-authentik-20229",level:3},{value:'<code>AUTHENTIK_WEB__THREADS</code> <span class="badge badge--version">authentik 2022.9+</span>',id:"authentik_web__threads-authentik-20229",level:3},{value:'<code>AUTHENTIK_WORKER__CONCURRENCY</code> <span class="badge badge--version">authentik 2023.9+</span>',id:"authentik_worker__concurrency-authentik-20239",level:3},{value:"<code>AUTHENTIK_WEB__PATH</code>",id:"authentik_web__path",level:3},{value:'System settings <span class="badge badge--version">authentik 2024.2+</span>',id:"system-settings-authentik-20242",level:2},{value:"Custom python settings",id:"custom-python-settings",level:2}];function u(e){const n={a:"a",admonition:"admonition",code:"code",em:"em",h2:"h2",h3:"h3",li:"li",p:"p",pre:"pre",strong:"strong",ul:"ul",...(0,o.R)(),...e.components};return(0,t.jsxs)(t.Fragment,{children:[(0,t.jsx)(n.p,{children:"This page details all the authentik configuration options that you can set via environment variables."}),"\n",(0,t.jsx)(n.h2,{id:"about-authentik-configurations",children:"About authentik configurations"}),"\n",(0,t.jsx)(n.admonition,{type:"info",children:(0,t.jsx)(n.p,{children:"The double-underscores are intentional, as all these settings are translated to YAML internally, and a double-underscore indicates the next level (a subsetting)."})}),"\n",(0,t.jsx)(n.p,{children:"All of these variables can be set to values, but you can also use a URI-like format to load values from other places:"}),"\n",(0,t.jsxs)(n.ul,{children:["\n",(0,t.jsxs)(n.li,{children:[(0,t.jsx)(n.code,{children:"env://<name>"})," Loads the value from the environment variable ",(0,t.jsx)(n.code,{children:"<name>"}),". Fallback can be optionally set like ",(0,t.jsx)(n.code,{children:"env://<name>?<default>"})]}),"\n",(0,t.jsxs)(n.li,{children:[(0,t.jsx)(n.code,{children:"file://<name>"})," Loads the value from the file ",(0,t.jsx)(n.code,{children:"<name>"}),". Fallback can be optionally set like ",(0,t.jsx)(n.code,{children:"file://<name>?<default>"})]}),"\n"]}),"\n",(0,t.jsx)(n.h2,{id:"set-your-environment-variables",children:"Set your environment variables"}),"\n","\n",(0,t.jsxs)(r.A,{groupId:"platform",children:[(0,t.jsxs)(d.default,{value:"docker-compose",label:"Docker Compose",default:!0,children:[(0,t.jsxs)(n.p,{children:["If you are using Docker Compose, edit your ",(0,t.jsx)("code",{children:".env"})," file to append any keys that you want to add, and then run the following command to apply them:"]}),(0,t.jsx)(n.pre,{children:(0,t.jsx)(n.code,{children:"docker compose up -d\n"})})]}),(0,t.jsxs)(d.default,{value:"kubernetes",label:"Kubernetes",children:[(0,t.jsxs)(n.p,{children:["If you are running in Kubernetes, edit your ",(0,t.jsx)("code",{children:"values.yaml"})," file to append any keys that you want to add, and then run the following commands to apply:"]}),(0,t.jsx)(n.pre,{children:(0,t.jsx)(n.code,{children:"helm repo update\nhelm upgrade --install authentik authentik/authentik -f values.yaml\n"})})]})]}),"\n",(0,t.jsx)(n.h2,{id:"verify-your-configuration-settings",children:"Verify your configuration settings"}),"\n",(0,t.jsx)(n.p,{children:"To check if your config has been applied correctly, you can run the following command to output the full config:"}),"\n",(0,t.jsxs)(r.A,{groupId:"platform",children:[(0,t.jsx)(d.default,{value:"docker-compose",label:"Docker Compose",default:!0,children:(0,t.jsx)(n.pre,{children:(0,t.jsx)(n.code,{children:"docker compose run --rm worker dump_config\n"})})}),(0,t.jsx)(d.default,{value:"kubernetes",label:"Kubernetes",children:(0,t.jsx)(n.pre,{children:(0,t.jsx)(n.code,{children:"kubectl exec -it deployment/authentik-worker -c worker -- ak dump_config\n"})})})]}),"\n",(0,t.jsx)(n.h2,{id:"postgresql-settings",children:"PostgreSQL Settings"}),"\n",(0,t.jsxs)(n.ul,{children:["\n",(0,t.jsxs)(n.li,{children:[(0,t.jsx)(n.code,{children:"AUTHENTIK_POSTGRESQL__HOST"}),": Hostname of your PostgreSQL Server"]}),"\n",(0,t.jsxs)(n.li,{children:[(0,t.jsx)(n.code,{children:"AUTHENTIK_POSTGRESQL__NAME"}),": Database name"]}),"\n",(0,t.jsxs)(n.li,{children:[(0,t.jsx)(n.code,{children:"AUTHENTIK_POSTGRESQL__USER"}),": Database user"]}),"\n",(0,t.jsxs)(n.li,{children:[(0,t.jsx)(n.code,{children:"AUTHENTIK_POSTGRESQL__PORT"}),": Database port, defaults to 5432"]}),"\n",(0,t.jsxs)(n.li,{children:[(0,t.jsx)(n.code,{children:"AUTHENTIK_POSTGRESQL__PASSWORD"}),": Database password, defaults to the environment variable ",(0,t.jsx)(n.code,{children:"POSTGRES_PASSWORD"})]}),"\n",(0,t.jsxs)(n.li,{children:[(0,t.jsx)(n.code,{children:"AUTHENTIK_POSTGRESQL__USE_PGBOUNCER"}),": Adjust configuration to support connection to PgBouncer. Deprecated, see below"]}),"\n",(0,t.jsxs)(n.li,{children:[(0,t.jsx)(n.code,{children:"AUTHENTIK_POSTGRESQL__USE_PGPOOL"}),": Adjust configuration to support connection to Pgpool. Deprecated, see below"]}),"\n",(0,t.jsxs)(n.li,{children:[(0,t.jsx)(n.code,{children:"AUTHENTIK_POSTGRESQL__SSLMODE"}),": Strictness of ssl verification. Defaults to ",(0,t.jsx)(n.code,{children:'"verify-ca"'})]}),"\n",(0,t.jsxs)(n.li,{children:[(0,t.jsx)(n.code,{children:"AUTHENTIK_POSTGRESQL__SSLROOTCERT"}),": CA root for server ssl verification"]}),"\n",(0,t.jsxs)(n.li,{children:[(0,t.jsx)(n.code,{children:"AUTHENTIK_POSTGRESQL__SSLCERT"}),": Path to x509 client certificate to authenticate to server"]}),"\n",(0,t.jsxs)(n.li,{children:[(0,t.jsx)(n.code,{children:"AUTHENTIK_POSTGRESQL__SSLKEY"}),": Path to private key of ",(0,t.jsx)(n.code,{children:"SSLCERT"})," certificate"]}),"\n",(0,t.jsxs)(n.li,{children:[(0,t.jsx)(n.code,{children:"AUTHENTIK_POSTGRESQL__CONN_MAX_AGE"}),": Database connection lifetime. Defaults to ",(0,t.jsx)(n.code,{children:"0"})," (no persistent connections). Can be set to ",(0,t.jsx)(n.code,{children:"null"})," for unlimited persistent connections. See ",(0,t.jsx)(n.a,{href:"https://docs.djangoproject.com/en/stable/ref/settings/#conn-max-age",children:"Django's documentation"})," for more details."]}),"\n",(0,t.jsxs)(n.li,{children:[(0,t.jsx)(n.code,{children:"AUTHENTIK_POSTGRESQL__CONN_HEALTH_CHECKS"}),": Existing persistent database connections will be health checked before they are reused if set to ",(0,t.jsx)(n.code,{children:"true"}),". Defaults to ",(0,t.jsx)(n.code,{children:"false"}),". See ",(0,t.jsx)(n.a,{href:"https://docs.djangoproject.com/en/stable/ref/settings/#conn-health-checks",children:"Django's documentation"})," for more details."]}),"\n",(0,t.jsxs)(n.li,{children:[(0,t.jsx)(n.code,{children:"AUTHENTIK_POSTGRESQL__DISABLE_SERVER_SIDE_CURSORS"}),": Disable server side cursors when set to ",(0,t.jsx)(n.code,{children:"true"}),". Defaults to ",(0,t.jsx)(n.code,{children:"false"}),". See ",(0,t.jsx)(n.a,{href:"https://docs.djangoproject.com/en/stable/ref/settings/#disable-server-side-cursors",children:"Django's documentation"})," for more details."]}),"\n"]}),"\n",(0,t.jsxs)(n.p,{children:["The PostgreSQL settings ",(0,t.jsx)(n.code,{children:"HOST"}),", ",(0,t.jsx)(n.code,{children:"PORT"}),", ",(0,t.jsx)(n.code,{children:"USER"}),", and ",(0,t.jsx)(n.code,{children:"PASSWORD"})," support hot-reloading. Adding and removing read replicas doesn't support hot-reloading."]}),"\n",(0,t.jsxs)(n.ul,{children:["\n",(0,t.jsxs)(n.li,{children:["\n",(0,t.jsxs)(n.p,{children:[(0,t.jsx)(n.code,{children:"AUTHENTIK_POSTGRESQL__DEFAULT_SCHEMA"})," ",(0,t.jsx)("span",{class:"badge badge--version",children:"authentik 2024.12+"})]}),"\n",(0,t.jsxs)(n.p,{children:["The name of the schema used by default in the database. Defaults to ",(0,t.jsx)(n.code,{children:"public"}),"."]}),"\n",(0,t.jsx)(n.p,{children:"It is only supported to change this value before the initial start of authentik."}),"\n",(0,t.jsxs)(n.p,{children:["When setting this value to any non-standard value, the schema must already exist in the database, and the user authentik connects with must have access to it. Additionally the ",(0,t.jsx)(n.code,{children:"search_path"})," of the authentik database must be set to include this schema."]}),"\n"]}),"\n"]}),"\n",(0,t.jsx)(n.h3,{id:"read-replicas",children:"Read replicas"}),"\n",(0,t.jsxs)(n.p,{children:["You can configure additional read replica databases that are used only for read operations. To configure authentik to use replicas, add the settings below to your ",(0,t.jsx)(n.a,{href:"/docs/install-config/configuration/#set-your-environment-variables",children:"configuration file"}),". If you have multiple replicas, add additional settings for each replica, replacing the default ",(0,t.jsx)(n.code,{children:"0"})," with a unique value for each additional replica."]}),"\n",(0,t.jsx)(n.p,{children:"If read replicas are configured, the main database is not used for reads. If you'd like the main database to be included for reads, add it as a read replica."}),"\n",(0,t.jsx)(n.p,{children:"The same PostgreSQL settings as described above are used for each read replica."}),"\n",(0,t.jsxs)(n.ul,{children:["\n",(0,t.jsx)(n.li,{children:(0,t.jsx)(n.code,{children:"AUTHENTIK_POSTGRESQL__READ_REPLICAS__0__HOST"})}),"\n",(0,t.jsx)(n.li,{children:(0,t.jsx)(n.code,{children:"AUTHENTIK_POSTGRESQL__READ_REPLICAS__0__NAME"})}),"\n",(0,t.jsx)(n.li,{children:(0,t.jsx)(n.code,{children:"AUTHENTIK_POSTGRESQL__READ_REPLICAS__0__USER"})}),"\n",(0,t.jsx)(n.li,{children:(0,t.jsx)(n.code,{children:"AUTHENTIK_POSTGRESQL__READ_REPLICAS__0__PORT"})}),"\n",(0,t.jsx)(n.li,{children:(0,t.jsx)(n.code,{children:"AUTHENTIK_POSTGRESQL__READ_REPLICAS__0__PASSWORD"})}),"\n",(0,t.jsx)(n.li,{children:(0,t.jsx)(n.code,{children:"AUTHENTIK_POSTGRESQL__READ_REPLICAS__0__SSLMODE"})}),"\n",(0,t.jsx)(n.li,{children:(0,t.jsx)(n.code,{children:"AUTHENTIK_POSTGRESQL__READ_REPLICAS__0__SSLROOTCERT"})}),"\n",(0,t.jsx)(n.li,{children:(0,t.jsx)(n.code,{children:"AUTHENTIK_POSTGRESQL__READ_REPLICAS__0__SSLCERT"})}),"\n",(0,t.jsx)(n.li,{children:(0,t.jsx)(n.code,{children:"AUTHENTIK_POSTGRESQL__READ_REPLICAS__0__SSLKEY"})}),"\n",(0,t.jsx)(n.li,{children:(0,t.jsx)(n.code,{children:"AUTHENTIK_POSTGRESQL__READ_REPLICAS__0__CONN_MAX_AGE"})}),"\n",(0,t.jsx)(n.li,{children:(0,t.jsx)(n.code,{children:"AUTHENTIK_POSTGRESQL__READ_REPLICAS__0__CONN_HEALTH_CHECKS"})}),"\n",(0,t.jsx)(n.li,{children:(0,t.jsx)(n.code,{children:"AUTHENTIK_POSTGRESQL__READ_REPLICAS__0__DISABLE_SERVER_SIDE_CURSORS"})}),"\n"]}),"\n",(0,t.jsx)(n.h3,{id:"using-a-postgresql-connection-pooler-pgbouncer-or-pgpool",children:"Using a PostgreSQL connection pooler (PgBouncer or PgPool)"}),"\n",(0,t.jsx)(n.p,{children:"When your PostgreSQL database(s) are running behind a connection pooler, like PgBouncer or PgPool, two settings need to be overridden:"}),"\n",(0,t.jsxs)(n.ul,{children:["\n",(0,t.jsxs)(n.li,{children:["\n",(0,t.jsx)(n.p,{children:(0,t.jsx)(n.code,{children:"AUTHENTIK_POSTGRESQL__CONN_MAX_AGE"})}),"\n",(0,t.jsxs)(n.p,{children:["A connection pooler running in session pool mode (PgBouncer default) can be incompatible with unlimited persistent connections enabled by setting this to ",(0,t.jsx)(n.code,{children:"null"}),": If the connection from the connection pooler to the database server is dropped, the connection pooler will wait for the client to disconnect before releasing the connection; however this will ",(0,t.jsx)(n.strong,{children:"never"})," happen as authentik is configured to keep the connection to the connection pooler forever."]}),"\n",(0,t.jsxs)(n.p,{children:["To address this incompatibility, either configure the connection pooler to run in transaction pool mode, or update this setting to a value lower than any timeouts that may cause the connection to the database to be dropped (up to ",(0,t.jsx)(n.code,{children:"0"}),")."]}),"\n"]}),"\n",(0,t.jsxs)(n.li,{children:["\n",(0,t.jsx)(n.p,{children:(0,t.jsx)(n.code,{children:"AUTHENTIK_POSTGRESQL__DISABLE_SERVER_SIDE_CURSORS"})}),"\n",(0,t.jsxs)(n.p,{children:["Using a connection pooler in transaction pool mode (e.g. PgPool, or PgBouncer in transaction or statement pool mode) requires disabling server-side cursors, so this setting must be set to ",(0,t.jsx)(n.code,{children:"false"}),"."]}),"\n"]}),"\n"]}),"\n",(0,t.jsxs)(n.p,{children:["Additionally, you can set ",(0,t.jsx)(n.code,{children:"AUTHENTIK_POSTGRESQL__CONN_HEALTH_CHECKS"})," to perform health checks on persistent database connections before they are reused."]}),"\n",(0,t.jsx)(n.h2,{id:"redis-settings",children:"Redis Settings"}),"\n",(0,t.jsxs)(n.ul,{children:["\n",(0,t.jsxs)(n.li,{children:[(0,t.jsx)(n.code,{children:"AUTHENTIK_REDIS__HOST"}),": Redis server host when not using configuration URL"]}),"\n",(0,t.jsxs)(n.li,{children:[(0,t.jsx)(n.code,{children:"AUTHENTIK_REDIS__PORT"}),": Redis server port when not using configuration URL"]}),"\n",(0,t.jsxs)(n.li,{children:[(0,t.jsx)(n.code,{children:"AUTHENTIK_REDIS__DB"}),": Redis server database when not using configuration URL"]}),"\n",(0,t.jsxs)(n.li,{children:[(0,t.jsx)(n.code,{children:"AUTHENTIK_REDIS__USERNAME"}),": Redis server username when not using configuration URL"]}),"\n",(0,t.jsxs)(n.li,{children:[(0,t.jsx)(n.code,{children:"AUTHENTIK_REDIS__PASSWORD"}),": Redis server password when not using configuration URL"]}),"\n",(0,t.jsxs)(n.li,{children:[(0,t.jsx)(n.code,{children:"AUTHENTIK_REDIS__TLS"}),": Redis server connection using TLS when not using configuration URL"]}),"\n",(0,t.jsxs)(n.li,{children:[(0,t.jsx)(n.code,{children:"AUTHENTIK_REDIS__TLS_REQS"}),": Redis server TLS connection requirements when not using configuration URL. Defaults to ",(0,t.jsx)(n.code,{children:'"none"'}),". Allowed values are ",(0,t.jsx)(n.code,{children:'"none"'})," and ",(0,t.jsx)(n.code,{children:'"required"'}),"."]}),"\n",(0,t.jsxs)(n.li,{children:[(0,t.jsx)(n.code,{children:"AUTHENTIK_REDIS__TLS_CA_CERT"}),": Path to the Redis server TLS CA root when not using configuration URL. Defaults to ",(0,t.jsx)(n.code,{children:"null"}),"."]}),"\n"]}),"\n",(0,t.jsx)(n.h2,{id:"result-backend-settings",children:"Result Backend Settings"}),"\n",(0,t.jsxs)(n.ul,{children:["\n",(0,t.jsxs)(n.li,{children:[(0,t.jsx)(n.code,{children:"AUTHENTIK_RESULT_BACKEND__URL"}),": Result backend configuration URL, uses ",(0,t.jsx)(n.a,{href:"#redis-settings",children:"the Redis Settings"})," by default"]}),"\n"]}),"\n",(0,t.jsx)(n.h2,{id:"cache-settings",children:"Cache Settings"}),"\n",(0,t.jsxs)(n.ul,{children:["\n",(0,t.jsxs)(n.li,{children:["\n",(0,t.jsxs)(n.p,{children:[(0,t.jsx)(n.code,{children:"AUTHENTIK_CACHE__URL"}),": Cache configuration URL, uses ",(0,t.jsx)(n.a,{href:"#redis-settings",children:"the Redis Settings"})," by default"]}),"\n"]}),"\n",(0,t.jsxs)(n.li,{children:["\n",(0,t.jsxs)(n.p,{children:[(0,t.jsx)(n.code,{children:"AUTHENTIK_CACHE__TIMEOUT"}),": Timeout for cached data until it expires in seconds, defaults to 300"]}),"\n"]}),"\n",(0,t.jsxs)(n.li,{children:["\n",(0,t.jsxs)(n.p,{children:[(0,t.jsx)(n.code,{children:"AUTHENTIK_CACHE__TIMEOUT_FLOWS"}),": Timeout for cached flow plans until they expire in seconds, defaults to 300"]}),"\n"]}),"\n",(0,t.jsxs)(n.li,{children:["\n",(0,t.jsxs)(n.p,{children:[(0,t.jsx)(n.code,{children:"AUTHENTIK_CACHE__TIMEOUT_POLICIES"}),": Timeout for cached policies until they expire in seconds, defaults to 300"]}),"\n"]}),"\n",(0,t.jsxs)(n.li,{children:["\n",(0,t.jsxs)(n.p,{children:[(0,t.jsx)(n.code,{children:"AUTHENTIK_CACHE__TIMEOUT_REPUTATION"}),": Timeout for cached reputation until they expire in seconds, defaults to 300"]}),"\n",(0,t.jsx)(n.admonition,{type:"info",children:(0,t.jsxs)(n.p,{children:[(0,t.jsx)(n.code,{children:"AUTHENTIK_CACHE__TIMEOUT_REPUTATION"})," only applies to the cache expiry, see ",(0,t.jsx)(n.a,{href:"#authentik_reputation__expiry-authentik-202382",children:(0,t.jsx)(n.code,{children:"AUTHENTIK_REPUTATION__EXPIRY"})})," to control how long reputation is persisted for."]})}),"\n"]}),"\n"]}),"\n",(0,t.jsx)(n.h2,{id:"channel-layer-settings-inter-instance-communication",children:"Channel Layer Settings (inter-instance communication)"}),"\n",(0,t.jsxs)(n.ul,{children:["\n",(0,t.jsxs)(n.li,{children:[(0,t.jsx)(n.code,{children:"AUTHENTIK_CHANNEL__URL"}),": Channel layers configuration URL, uses ",(0,t.jsx)(n.a,{href:"#redis-settings",children:"the Redis Settings"})," by default"]}),"\n"]}),"\n",(0,t.jsx)(n.h2,{id:"broker-settings",children:"Broker Settings"}),"\n",(0,t.jsxs)(n.ul,{children:["\n",(0,t.jsxs)(n.li,{children:["\n",(0,t.jsxs)(n.p,{children:[(0,t.jsx)(n.code,{children:"AUTHENTIK_BROKER__URL"}),": Broker configuration URL, defaults to Redis using ",(0,t.jsx)(n.a,{href:"#redis-settings",children:"the respective settings"})]}),"\n"]}),"\n",(0,t.jsxs)(n.li,{children:["\n",(0,t.jsxs)(n.p,{children:[(0,t.jsx)(n.code,{children:"AUTHENTIK_BROKER__TRANSPORT_OPTIONS"}),": Base64-encoded broker transport options"]}),"\n",(0,t.jsx)(n.admonition,{type:"info",children:(0,t.jsxs)(n.p,{children:[(0,t.jsx)(n.code,{children:"AUTHENTIK_REDIS__CACHE_TIMEOUT_REPUTATION"})," only applies to the cache expiry, see ",(0,t.jsx)(n.a,{href:"#authentik_reputation__expiry-authentik-202382",children:(0,t.jsx)(n.code,{children:"AUTHENTIK_REPUTATION__EXPIRY"})})," to control how long reputation is persisted for."]})}),"\n"]}),"\n"]}),"\n",(0,t.jsx)(n.h2,{id:"listen-settings",children:"Listen Settings"}),"\n",(0,t.jsxs)(n.ul,{children:["\n",(0,t.jsxs)(n.li,{children:["\n",(0,t.jsxs)(n.p,{children:[(0,t.jsx)(n.code,{children:"AUTHENTIK_LISTEN__HTTP"}),": Listening address",":port"," (e.g. ",(0,t.jsx)(n.code,{children:"0.0.0.0:9000"}),") for HTTP (Applies to Server and Proxy outpost)"]}),"\n"]}),"\n",(0,t.jsxs)(n.li,{children:["\n",(0,t.jsxs)(n.p,{children:[(0,t.jsx)(n.code,{children:"AUTHENTIK_LISTEN__HTTPS"}),": Listening address",":port"," (e.g. ",(0,t.jsx)(n.code,{children:"0.0.0.0:9443"}),") for HTTPS (Applies to Server and Proxy outpost)"]}),"\n"]}),"\n",(0,t.jsxs)(n.li,{children:["\n",(0,t.jsxs)(n.p,{children:[(0,t.jsx)(n.code,{children:"AUTHENTIK_LISTEN__LDAP"}),": Listening address",":port"," (e.g. ",(0,t.jsx)(n.code,{children:"0.0.0.0:3389"}),") for LDAP (Applies to LDAP outpost)"]}),"\n"]}),"\n",(0,t.jsxs)(n.li,{children:["\n",(0,t.jsxs)(n.p,{children:[(0,t.jsx)(n.code,{children:"AUTHENTIK_LISTEN__LDAPS"}),": Listening address",":port"," (e.g. ",(0,t.jsx)(n.code,{children:"0.0.0.0:6636"}),") for LDAPS (Applies to LDAP outpost)"]}),"\n"]}),"\n",(0,t.jsxs)(n.li,{children:["\n",(0,t.jsxs)(n.p,{children:[(0,t.jsx)(n.code,{children:"AUTHENTIK_LISTEN__METRICS"}),": Listening address",":port"," (e.g. ",(0,t.jsx)(n.code,{children:"0.0.0.0:9300"}),") for Prometheus metrics (Applies to All)"]}),"\n"]}),"\n",(0,t.jsxs)(n.li,{children:["\n",(0,t.jsxs)(n.p,{children:[(0,t.jsx)(n.code,{children:"AUTHENTIK_LISTEN__DEBUG"}),": Listening address",":port"," (e.g. ",(0,t.jsx)(n.code,{children:"0.0.0.0:9900"}),") for Go Debugging metrics (Applies to All)"]}),"\n"]}),"\n",(0,t.jsxs)(n.li,{children:["\n",(0,t.jsxs)(n.p,{children:[(0,t.jsx)(n.code,{children:"AUTHENTIK_LISTEN__DEBUG_PY"}),": Listening address",":port"," (e.g. ",(0,t.jsx)(n.code,{children:"0.0.0.0:9901"}),") for Python debugging server (Applies to Server, see ",(0,t.jsx)(n.a,{href:"/docs/developer-docs/setup/debugging",children:"Debugging"}),")"]}),"\n"]}),"\n",(0,t.jsxs)(n.li,{children:["\n",(0,t.jsxs)(n.p,{children:[(0,t.jsx)(n.code,{children:"AUTHENTIK_LISTEN__TRUSTED_PROXY_CIDRS"}),": List of comma-separated CIDRs that proxy headers should be accepted from (Applies to Server)"]}),"\n",(0,t.jsxs)(n.p,{children:["Defaults to ",(0,t.jsx)(n.code,{children:"127.0.0.0/8"}),", ",(0,t.jsx)(n.code,{children:"10.0.0.0/8"}),", ",(0,t.jsx)(n.code,{children:"172.16.0.0/12"}),", ",(0,t.jsx)(n.code,{children:"192.168.0.0/16"}),", ",(0,t.jsx)(n.code,{children:"fe80::/10"}),", ",(0,t.jsx)(n.code,{children:"::1/128"}),"."]}),"\n",(0,t.jsxs)(n.p,{children:["Requests directly coming from one an address within a CIDR specified here are able to set proxy headers, such as ",(0,t.jsx)(n.code,{children:"X-Forwarded-For"}),". Requests coming from other addresses will not be able to set these headers."]}),"\n"]}),"\n"]}),"\n",(0,t.jsx)(n.h2,{id:"media-storage-settings",children:"Media Storage Settings"}),"\n",(0,t.jsxs)(n.p,{children:["These settings affect where media files are stored. Those files include applications and sources icons. By default, they are stored on disk in the ",(0,t.jsx)(n.code,{children:"/media"})," directory of the authentik container. S3 storage is also supported."]}),"\n",(0,t.jsxs)(n.ul,{children:["\n",(0,t.jsxs)(n.li,{children:[(0,t.jsx)(n.code,{children:"AUTHENTIK_STORAGE__MEDIA__BACKEND"}),": Where to store files. Valid values are ",(0,t.jsx)(n.code,{children:"file"})," and ",(0,t.jsx)(n.code,{children:"s3"}),". For ",(0,t.jsx)(n.code,{children:"file"})," storage, files are stored in a ",(0,t.jsx)(n.code,{children:"/media"})," directory in the container. For ",(0,t.jsx)(n.code,{children:"s3"}),", see below."]}),"\n",(0,t.jsxs)(n.li,{children:[(0,t.jsx)(n.code,{children:"AUTHENTIK_STORAGE__MEDIA__S3__REGION"}),": S3 region where the bucket has been created. May be omitted depending on which S3 provider you use. No default."]}),"\n",(0,t.jsxs)(n.li,{children:[(0,t.jsx)(n.code,{children:"AUTHENTIK_STORAGE__MEDIA__S3__USE_SSL"}),": Whether to use HTTPS when talking to the S3 storage providers. Defaults to ",(0,t.jsx)(n.code,{children:"true"}),"."]}),"\n",(0,t.jsxs)(n.li,{children:[(0,t.jsx)(n.code,{children:"AUTHENTIK_STORAGE__MEDIA__S3__ENDPOINT"}),": Endpoint to use to talk to the S3 storage provider. Override the previous region and use_ssl settings. Must be a valid URL in the form of ",(0,t.jsx)(n.code,{children:"https://s3.provider"}),". No default."]}),"\n",(0,t.jsxs)(n.li,{children:[(0,t.jsx)(n.code,{children:"AUTHENTIK_STORAGE__MEDIA__S3__SESSION_PROFILE"}),": Profile to use when using AWS SDK authentication. No default. Supports hot-reloading."]}),"\n",(0,t.jsxs)(n.li,{children:[(0,t.jsx)(n.code,{children:"AUTHENTIK_STORAGE__MEDIA__S3__ACCESS_KEY"}),": Access key to authenticate to S3. May be omitted if using AWS SDK authentication. Supports hot-reloading."]}),"\n",(0,t.jsxs)(n.li,{children:[(0,t.jsx)(n.code,{children:"AUTHENTIK_STORAGE__MEDIA__S3__SECRET_KEY"}),": Secret key to authenticate to S3. May be omitted if using AWS SDK authentication. Supports hot-reloading."]}),"\n",(0,t.jsxs)(n.li,{children:[(0,t.jsx)(n.code,{children:"AUTHENTIK_STORAGE__MEDIA__S3__SECURITY_TOKEN"}),": Security token to authenticate to S3. May be omitted. Supports hot-reloading."]}),"\n",(0,t.jsxs)(n.li,{children:[(0,t.jsx)(n.code,{children:"AUTHENTIK_STORAGE__MEDIA__S3__BUCKET_NAME"}),": Name of the bucket to use to store files."]}),"\n",(0,t.jsxs)(n.li,{children:[(0,t.jsx)(n.code,{children:"AUTHENTIK_STORAGE__MEDIA__S3__CUSTOM_DOMAIN"}),": Domain to use to create URLs for users. Mainly useful for non-AWS providers. May include a port. Must include the bucket. Example: ",(0,t.jsx)(n.code,{children:"s3.company:8080/authentik-media"}),"."]}),"\n",(0,t.jsxs)(n.li,{children:[(0,t.jsx)(n.code,{children:"AUTHENTIK_STORAGE__MEDIA__S3__SECURE_URLS"}),": Whether URLs created use HTTPS (set to ",(0,t.jsx)(n.code,{children:"true"})," by default) or HTTP."]}),"\n"]}),"\n",(0,t.jsx)(n.h2,{id:"authentik-settings",children:"authentik Settings"}),"\n",(0,t.jsx)(n.h3,{id:"authentik_secret_key",children:(0,t.jsx)(n.code,{children:"AUTHENTIK_SECRET_KEY"})}),"\n",(0,t.jsx)(n.p,{children:"Secret key used for cookie signing. Changing this will invalidate active sessions."}),"\n",(0,t.jsx)(n.admonition,{type:"caution",children:(0,t.jsxs)(n.p,{children:["Prior to 2023.6.0 the secret key was also used for unique user IDs. When running a pre-2023.6.0 version of authentik the key should ",(0,t.jsx)(n.em,{children:"not"})," be changed after the first install."]})}),"\n",(0,t.jsx)(n.h3,{id:"authentik_log_level",children:(0,t.jsx)(n.code,{children:"AUTHENTIK_LOG_LEVEL"})}),"\n",(0,t.jsxs)(n.p,{children:["Log level for the server and worker containers. Possible values: ",(0,t.jsx)(n.code,{children:"debug"}),", ",(0,t.jsx)(n.code,{children:"info"}),", ",(0,t.jsx)(n.code,{children:"warning"}),", ",(0,t.jsx)(n.code,{children:"error"}),"."]}),"\n",(0,t.jsxs)(n.p,{children:["Starting with 2021.12.3, you can also set the log level to ",(0,t.jsx)(n.code,{children:"trace"}),". This has no effect on the core authentik server, but shows additional messages for the embedded outpost."]}),"\n",(0,t.jsxs)(n.admonition,{type:"danger",children:[(0,t.jsxs)(n.p,{children:["Setting the log level to ",(0,t.jsx)(n.code,{children:"trace"})," will include sensitive details in logs, so it shouldn't be used in most cases."]}),(0,t.jsxs)(n.p,{children:["Logs generated with ",(0,t.jsx)(n.code,{children:"trace"})," should be treated with care as they can give others access to your instance, and can potentially include things like session cookies to authentik ",(0,t.jsx)(n.strong,{children:"and other pages"}),"."]})]}),"\n",(0,t.jsxs)(n.p,{children:["Defaults to ",(0,t.jsx)(n.code,{children:"info"}),"."]}),"\n",(0,t.jsx)(n.h3,{id:"authentik_cookie_domain",children:(0,t.jsx)(n.code,{children:"AUTHENTIK_COOKIE_DOMAIN"})}),"\n",(0,t.jsx)(n.p,{children:"Which domain the session cookie should be set to. By default, the cookie is set to the domain authentik is accessed under."}),"\n",(0,t.jsx)(n.h3,{id:"authentik_events__context_processors__geoip",children:(0,t.jsx)(n.code,{children:"AUTHENTIK_EVENTS__CONTEXT_PROCESSORS__GEOIP"})}),"\n",(0,t.jsxs)(n.p,{children:["Path to the GeoIP City database. Defaults to ",(0,t.jsx)(n.code,{children:"/geoip/GeoLite2-City.mmdb"}),". If the file is not found, authentik will skip GeoIP support."]}),"\n",(0,t.jsx)(n.h3,{id:"authentik_events__context_processors__asn",children:(0,t.jsx)(n.code,{children:"AUTHENTIK_EVENTS__CONTEXT_PROCESSORS__ASN"})}),"\n",(0,t.jsxs)(n.p,{children:["Path to the GeoIP ASN database. Defaults to ",(0,t.jsx)(n.code,{children:"/geoip/GeoLite2-ASN.mmdb"}),". If the file is not found, authentik will skip GeoIP support."]}),"\n",(0,t.jsx)(n.h3,{id:"authentik_disable_update_check",children:(0,t.jsx)(n.code,{children:"AUTHENTIK_DISABLE_UPDATE_CHECK"})}),"\n",(0,t.jsxs)(n.p,{children:["Disable the inbuilt update-checker. Defaults to ",(0,t.jsx)(n.code,{children:"false"}),"."]}),"\n",(0,t.jsx)(n.h3,{id:"authentik_error_reporting",children:(0,t.jsx)(n.code,{children:"AUTHENTIK_ERROR_REPORTING"})}),"\n",(0,t.jsxs)(n.ul,{children:["\n",(0,t.jsxs)(n.li,{children:["\n",(0,t.jsx)(n.p,{children:(0,t.jsx)(n.code,{children:"AUTHENTIK_ERROR_REPORTING__ENABLED"})}),"\n",(0,t.jsxs)(n.p,{children:["Enable error reporting. Defaults to ",(0,t.jsx)(n.code,{children:"false"}),"."]}),"\n",(0,t.jsxs)(n.p,{children:["Error reports are sent to ",(0,t.jsx)(n.a,{href:"https://sentry.io",children:"https://sentry.io"})," and are used for debugging and general feedback. Anonymous performance data is also sent."]}),"\n"]}),"\n",(0,t.jsxs)(n.li,{children:["\n",(0,t.jsx)(n.p,{children:(0,t.jsx)(n.code,{children:"AUTHENTIK_ERROR_REPORTING__SENTRY_DSN"})}),"\n",(0,t.jsx)(n.p,{children:"Sets the DSN for the Sentry API endpoint."}),"\n",(0,t.jsx)(n.p,{children:"When error reporting is enabled, the default Sentry DSN will allow the authentik developers to receive error reports and anonymous performance data, which is used for general feedback about authentik, and in some cases, may be used for debugging purposes."}),"\n",(0,t.jsx)(n.p,{children:"Users can create their own hosted Sentry account (or self-host Sentry) and opt to collect this data themselves."}),"\n"]}),"\n",(0,t.jsxs)(n.li,{children:["\n",(0,t.jsx)(n.p,{children:(0,t.jsx)(n.code,{children:"AUTHENTIK_ERROR_REPORTING__ENVIRONMENT"})}),"\n",(0,t.jsxs)(n.p,{children:["The environment tag associated with all data sent to Sentry. Defaults to ",(0,t.jsx)(n.code,{children:"customer"}),"."]}),"\n",(0,t.jsx)(n.p,{children:"When error reporting has been enabled to aid in debugging issues, this should be set to a unique value, such as an email address."}),"\n"]}),"\n",(0,t.jsxs)(n.li,{children:["\n",(0,t.jsx)(n.p,{children:(0,t.jsx)(n.code,{children:"AUTHENTIK_ERROR_REPORTING__SEND_PII"})}),"\n",(0,t.jsxs)(n.p,{children:["Whether or not to send personal data, like usernames. Defaults to ",(0,t.jsx)(n.code,{children:"false"}),"."]}),"\n"]}),"\n",(0,t.jsxs)(n.li,{children:["\n",(0,t.jsx)(n.p,{children:(0,t.jsx)(n.code,{children:"AUTHENTIK_ERROR_REPORTING__EXTRA_ARGS"})}),"\n",(0,t.jsxs)(n.p,{children:["Base64-encoded sentry_init arguments. See ",(0,t.jsx)(n.a,{href:"https://docs.sentry.io/platforms/python/configuration/options/",children:"Sentry's documentation"})," for available options."]}),"\n"]}),"\n"]}),"\n",(0,t.jsx)(n.h3,{id:"authentik_email",children:(0,t.jsx)(n.code,{children:"AUTHENTIK_EMAIL"})}),"\n",(0,t.jsxs)(n.ul,{children:["\n",(0,t.jsxs)(n.li,{children:["\n",(0,t.jsx)(n.p,{children:(0,t.jsx)(n.code,{children:"AUTHENTIK_EMAIL__HOST"})}),"\n",(0,t.jsxs)(n.p,{children:["Default: ",(0,t.jsx)(n.code,{children:"localhost"})]}),"\n"]}),"\n",(0,t.jsxs)(n.li,{children:["\n",(0,t.jsx)(n.p,{children:(0,t.jsx)(n.code,{children:"AUTHENTIK_EMAIL__PORT"})}),"\n",(0,t.jsxs)(n.p,{children:["Default: ",(0,t.jsx)(n.code,{children:"25"})]}),"\n"]}),"\n",(0,t.jsxs)(n.li,{children:["\n",(0,t.jsx)(n.p,{children:(0,t.jsx)(n.code,{children:"AUTHENTIK_EMAIL__USERNAME"})}),"\n",(0,t.jsx)(n.p,{children:"Default: `` (Don't add quotation marks)"}),"\n"]}),"\n",(0,t.jsxs)(n.li,{children:["\n",(0,t.jsx)(n.p,{children:(0,t.jsx)(n.code,{children:"AUTHENTIK_EMAIL__PASSWORD"})}),"\n",(0,t.jsx)(n.p,{children:"Default: `` (Don't add quotation marks)"}),"\n"]}),"\n",(0,t.jsxs)(n.li,{children:["\n",(0,t.jsx)(n.p,{children:(0,t.jsx)(n.code,{children:"AUTHENTIK_EMAIL__USE_TLS"})}),"\n",(0,t.jsxs)(n.p,{children:["Default: ",(0,t.jsx)(n.code,{children:"false"})]}),"\n"]}),"\n",(0,t.jsxs)(n.li,{children:["\n",(0,t.jsx)(n.p,{children:(0,t.jsx)(n.code,{children:"AUTHENTIK_EMAIL__USE_SSL"})}),"\n",(0,t.jsxs)(n.p,{children:["Default: ",(0,t.jsx)(n.code,{children:"false"})]}),"\n"]}),"\n",(0,t.jsxs)(n.li,{children:["\n",(0,t.jsx)(n.p,{children:(0,t.jsx)(n.code,{children:"AUTHENTIK_EMAIL__TIMEOUT"})}),"\n",(0,t.jsxs)(n.p,{children:["Default: ",(0,t.jsx)(n.code,{children:"10"})]}),"\n"]}),"\n",(0,t.jsxs)(n.li,{children:["\n",(0,t.jsx)(n.p,{children:(0,t.jsx)(n.code,{children:"AUTHENTIK_EMAIL__FROM"})}),"\n",(0,t.jsxs)(n.p,{children:["Default: ",(0,t.jsx)(n.code,{children:"authentik@localhost"})]}),"\n",(0,t.jsxs)(n.p,{children:["Email address authentik will send from, should have a correct ",(0,t.jsx)(n.a,{href:"https://github.com/domain",children:(0,t.jsx)(n.strong,{children:"@domain"})})]}),"\n",(0,t.jsxs)(n.p,{children:["To change the sender's display name, use a format like ",(0,t.jsx)(n.code,{children:"Name <account@domain>"}),"."]}),"\n"]}),"\n"]}),"\n",(0,t.jsx)(n.h3,{id:"authentik_outposts",children:(0,t.jsx)(n.code,{children:"AUTHENTIK_OUTPOSTS"})}),"\n",(0,t.jsxs)(n.ul,{children:["\n",(0,t.jsxs)(n.li,{children:["\n",(0,t.jsx)(n.p,{children:(0,t.jsx)(n.code,{children:"AUTHENTIK_OUTPOSTS__CONTAINER_IMAGE_BASE"})}),"\n",(0,t.jsx)(n.p,{children:"Placeholders:"}),"\n",(0,t.jsxs)(n.ul,{children:["\n",(0,t.jsxs)(n.li,{children:[(0,t.jsx)(n.code,{children:"%(type)s"}),": Outpost type; proxy, ldap, etc"]}),"\n",(0,t.jsxs)(n.li,{children:[(0,t.jsx)(n.code,{children:"%(version)s"}),": Current version; 2021.4.1"]}),"\n",(0,t.jsxs)(n.li,{children:[(0,t.jsx)(n.code,{children:"%(build_hash)s"}),": Build hash if you're running a beta version"]}),"\n"]}),"\n",(0,t.jsxs)(n.p,{children:["Placeholder for outpost docker images. Default: ",(0,t.jsx)(n.code,{children:"ghcr.io/goauthentik/%(type)s:%(version)s"}),"."]}),"\n"]}),"\n",(0,t.jsxs)(n.li,{children:["\n",(0,t.jsx)(n.p,{children:(0,t.jsx)(n.code,{children:"AUTHENTIK_OUTPOSTS__DISCOVER"})}),"\n",(0,t.jsxs)(n.p,{children:["Configure the automatic discovery of integrations. Defaults to ",(0,t.jsx)(n.code,{children:"true"}),"."]}),"\n",(0,t.jsx)(n.p,{children:"By default, the following is discovered:"}),"\n",(0,t.jsxs)(n.ul,{children:["\n",(0,t.jsx)(n.li,{children:"Kubernetes in-cluster config"}),"\n",(0,t.jsx)(n.li,{children:"Kubeconfig"}),"\n",(0,t.jsx)(n.li,{children:"Existence of a docker socket"}),"\n"]}),"\n"]}),"\n"]}),"\n",(0,t.jsxs)(n.h3,{id:"authentik_ldap__task_timeout_hours-authentik-20231",children:[(0,t.jsx)(n.code,{children:"AUTHENTIK_LDAP__TASK_TIMEOUT_HOURS"})," ",(0,t.jsx)("span",{class:"badge badge--version",children:"authentik 2023.1+"})]}),"\n",(0,t.jsx)(n.p,{children:"Timeout in hours for LDAP synchronization tasks."}),"\n",(0,t.jsxs)(n.p,{children:["Defaults to ",(0,t.jsx)(n.code,{children:"2"}),"."]}),"\n",(0,t.jsxs)(n.h3,{id:"authentik_ldap__page_size-authentik-202361",children:[(0,t.jsx)(n.code,{children:"AUTHENTIK_LDAP__PAGE_SIZE"})," ",(0,t.jsx)("span",{class:"badge badge--version",children:"authentik 2023.6.1+"})]}),"\n",(0,t.jsx)(n.p,{children:"Page size for LDAP synchronization. Controls the number of objects created in a single task."}),"\n",(0,t.jsxs)(n.p,{children:["Defaults to ",(0,t.jsx)(n.code,{children:"50"}),"."]}),"\n",(0,t.jsxs)(n.h3,{id:"authentik_ldap__tls__ciphers-authentik-20227",children:[(0,t.jsx)(n.code,{children:"AUTHENTIK_LDAP__TLS__CIPHERS"})," ",(0,t.jsx)("span",{class:"badge badge--version",children:"authentik 2022.7+"})]}),"\n",(0,t.jsx)(n.p,{children:"Allows configuration of TLS Cliphers for LDAP connections used by LDAP sources. Setting applies to all sources."}),"\n",(0,t.jsxs)(n.p,{children:["Defaults to ",(0,t.jsx)(n.code,{children:"null"}),"."]}),"\n",(0,t.jsxs)(n.h3,{id:"authentik_reputation__expiry-authentik-202382",children:[(0,t.jsx)(n.code,{children:"AUTHENTIK_REPUTATION__EXPIRY"})," ",(0,t.jsx)("span",{class:"badge badge--version",children:"authentik 2023.8.2+"})]}),"\n",(0,t.jsxs)(n.p,{children:["Configure how long reputation scores should be saved for in seconds. Note that this is different than ",(0,t.jsx)(n.a,{href:"#redis-settings",children:(0,t.jsx)(n.code,{children:"AUTHENTIK_REDIS__CACHE_TIMEOUT_REPUTATION"})}),", as reputation is saved to the database every 5 minutes."]}),"\n",(0,t.jsxs)(n.p,{children:["Defaults to ",(0,t.jsx)(n.code,{children:"86400"}),"."]}),"\n",(0,t.jsxs)(n.h3,{id:"authentik_session_storage-authentik-20244",children:[(0,t.jsx)(n.code,{children:"AUTHENTIK_SESSION_STORAGE"})," ",(0,t.jsx)("span",{class:"badge badge--version",children:"authentik 2024.4+"})]}),"\n",(0,t.jsxs)(n.p,{children:["Configure if the sessions are stored in the cache or the database. Defaults to ",(0,t.jsx)(n.code,{children:"cache"}),". Allowed values are ",(0,t.jsx)(n.code,{children:"cache"})," and ",(0,t.jsx)(n.code,{children:"db"}),". Note that changing this value will invalidate all previous sessions."]}),"\n",(0,t.jsxs)(n.h3,{id:"authentik_web__workers-authentik-20229",children:[(0,t.jsx)(n.code,{children:"AUTHENTIK_WEB__WORKERS"})," ",(0,t.jsx)("span",{class:"badge badge--version",children:"authentik 2022.9+"})]}),"\n",(0,t.jsxs)(n.p,{children:["Configure how many gunicorn worker processes should be started (see ",(0,t.jsx)(n.a,{href:"https://docs.gunicorn.org/en/stable/design.html",children:"https://docs.gunicorn.org/en/stable/design.html"}),")."]}),"\n",(0,t.jsx)(n.p,{children:"Defaults to 2. A value below 2 workers is not recommended. In environments where scaling with multiple replicas of the authentik server is not possible, this number can be increased to handle higher loads."}),"\n",(0,t.jsxs)(n.h3,{id:"authentik_web__threads-authentik-20229",children:[(0,t.jsx)(n.code,{children:"AUTHENTIK_WEB__THREADS"})," ",(0,t.jsx)("span",{class:"badge badge--version",children:"authentik 2022.9+"})]}),"\n",(0,t.jsxs)(n.p,{children:["Configure how many gunicorn threads a worker processes should have (see ",(0,t.jsx)(n.a,{href:"https://docs.gunicorn.org/en/stable/design.html",children:"https://docs.gunicorn.org/en/stable/design.html"}),")."]}),"\n",(0,t.jsx)(n.p,{children:"Defaults to 4."}),"\n",(0,t.jsxs)(n.h3,{id:"authentik_worker__concurrency-authentik-20239",children:[(0,t.jsx)(n.code,{children:"AUTHENTIK_WORKER__CONCURRENCY"})," ",(0,t.jsx)("span",{class:"badge badge--version",children:"authentik 2023.9+"})]}),"\n",(0,t.jsxs)(n.p,{children:["Configure Celery worker concurrency for authentik worker (see ",(0,t.jsx)(n.a,{href:"https://docs.celeryq.dev/en/latest/userguide/configuration.html#worker-concurrency",children:"https://docs.celeryq.dev/en/latest/userguide/configuration.html#worker-concurrency"}),"). This essentially defines the number of worker processes spawned for a single worker."]}),"\n",(0,t.jsx)(n.p,{children:"Defaults to 2."}),"\n",(0,t.jsx)(n.h3,{id:"authentik_web__path",children:(0,t.jsx)(n.code,{children:"AUTHENTIK_WEB__PATH"})}),"\n",(0,t.jsx)(n.admonition,{type:"info",children:(0,t.jsx)(n.p,{children:"Requires authentik 2024.8"})}),"\n",(0,t.jsxs)(n.p,{children:["Configure the path under which authentik is serverd. For example to access authentik under ",(0,t.jsx)(n.code,{children:"https://my.domain/authentik/"}),", set this to ",(0,t.jsx)(n.code,{children:"/authentik/"}),". Value ",(0,t.jsx)(n.em,{children:"must"})," contain both a leading and trailing slash."]}),"\n",(0,t.jsxs)(n.p,{children:["Defaults to ",(0,t.jsx)(n.code,{children:"/"}),"."]}),"\n",(0,t.jsxs)(n.h2,{id:"system-settings-authentik-20242",children:["System settings ",(0,t.jsx)("span",{class:"badge badge--version",children:"authentik 2024.2+"})]}),"\n",(0,t.jsxs)(n.p,{children:["Additional settings are configurable using the Admin interface, under ",(0,t.jsx)(n.strong,{children:"System"})," -> ",(0,t.jsx)(n.strong,{children:"Settings"})," or using the API."]}),"\n",(0,t.jsx)(n.h2,{id:"custom-python-settings",children:"Custom python settings"}),"\n",(0,t.jsxs)(n.p,{children:["To modify additional settings further than the options above allow, you can create a custom Python file and mount it to ",(0,t.jsx)(n.code,{children:"/data/user_settings.py"}),". This file will be loaded on startup by both the server and the worker. All default settings are ",(0,t.jsx)(n.a,{href:"https://github.com/goauthentik/authentik/blob/main/authentik/root/settings.py",children:"here"})]}),"\n",(0,t.jsx)(n.admonition,{type:"caution",children:(0,t.jsx)(n.p,{children:"Using these custom settings is not supported and can prevent your authentik instance from starting. Use with caution."})})]})}function _(e={}){const{wrapper:n}={...(0,o.R)(),...e.components};return n?(0,t.jsx)(n,{...e,children:(0,t.jsx)(u,{...e})}):u(e)}},64911:(e,n,s)=>{s.d(n,{A:()=>_});var i=s(96540),t=s(34164),o=s(65627),r=s(77448),d=s(9136);const l={tabList:"tabList__CuJ",tabItem:"tabItem_LNqP"};var c=s(74848);function a(e){let{className:n,block:s,selectedValue:i,selectValue:r,tabValues:d}=e;const a=[],{blockElementScrollPositionUntilNextRender:h}=(0,o.a_)(),u=e=>{const n=e.currentTarget,s=a.indexOf(n),t=d[s].value;t!==i&&(h(n),r(t))},_=e=>{let n=null;switch(e.key){case"Enter":u(e);break;case"ArrowRight":{const s=a.indexOf(e.currentTarget)+1;n=a[s]??a[0];break}case"ArrowLeft":{const s=a.indexOf(e.currentTarget)-1;n=a[s]??a[a.length-1];break}}n?.focus()};return(0,c.jsx)("ul",{role:"tablist","aria-orientation":"horizontal",className:(0,t.A)("tabs",{"tabs--block":s},n),children:d.map((e=>{let{value:n,label:s,attributes:o}=e;return(0,c.jsx)("li",{role:"tab",tabIndex:i===n?0:-1,"aria-selected":i===n,ref:e=>{a.push(e)},onKeyDown:_,onClick:u,...o,className:(0,t.A)("tabs__item",l.tabItem,o?.className,{"tabs__item--active":i===n}),children:s??n},n)}))})}function h(e){let{lazy:n,children:s,selectedValue:o}=e;const r=(Array.isArray(s)?s:[s]).filter(Boolean);if(n){const e=r.find((e=>e.props.value===o));return e?(0,i.cloneElement)(e,{className:(0,t.A)("margin-top--md",e.props.className)}):null}return(0,c.jsx)("div",{className:"margin-top--md",children:r.map(((e,n)=>(0,i.cloneElement)(e,{key:n,hidden:e.props.value!==o})))})}function u(e){const n=(0,r.u)(e);return(0,c.jsxs)("div",{className:(0,t.A)("tabs-container",l.tabList),children:[(0,c.jsx)(a,{...n,...e}),(0,c.jsx)(h,{...n,...e})]})}function _(e){const n=(0,d.default)();return(0,c.jsx)(u,{...e,children:(0,r.v)(e.children)},String(n))}}}]);