"use strict";(self.webpackChunk_goauthentik_website_docs=self.webpackChunk_goauthentik_website_docs||[]).push([[96697],{48765:(e,s,n)=>{n.r(s),n.d(s,{assets:()=>a,contentTitle:()=>c,default:()=>p,frontMatter:()=>t,metadata:()=>r,toc:()=>d});const r=JSON.parse('{"id":"users-sources/sources/protocols/scim/index","title":"SCIM Source","description":"The SCIM source allows other applications to directly create users and groups within authentik. SCIM provides predefined schema for users and groups, with a RESTful API, to enable automatic user provisioning and deprovisioning, SCIM is supported by applications such as Microsoft Entra ID, Google Workspace, and Okta.","source":"@site/docs/users-sources/sources/protocols/scim/index.md","sourceDirName":"users-sources/sources/protocols/scim","slug":"/users-sources/sources/protocols/scim/","permalink":"/docs/users-sources/sources/protocols/scim/","draft":false,"unlisted":false,"editUrl":"https://github.com/goauthentik/authentik/edit/main/website/docs/users-sources/sources/protocols/scim/index.md","tags":[],"version":"current","frontMatter":{"title":"SCIM Source"},"sidebar":"docs","previous":{"title":"SAML Source","permalink":"/docs/users-sources/sources/protocols/saml/"},"next":{"title":"Source property mappings","permalink":"/docs/users-sources/sources/property-mappings/"}}');var i=n(74848),o=n(28453);const t={title:"SCIM Source"},c=void 0,a={},d=[{value:"First steps",id:"first-steps",level:2},{value:"Supported Options &amp; Resource types",id:"supported-options--resource-types",level:2},{value:"<code>/v2/Users</code>",id:"v2users",level:3},{value:"<code>/v2/Groups</code>",id:"v2groups",level:3},{value:"SCIM source property mappings",id:"scim-source-property-mappings",level:2},{value:"Expression data",id:"expression-data",level:3}];function l(e){const s={a:"a",admonition:"admonition",code:"code",h2:"h2",h3:"h3",li:"li",p:"p",pre:"pre",strong:"strong",ul:"ul",...(0,o.R)(),...e.components};return(0,i.jsxs)(i.Fragment,{children:[(0,i.jsx)(s.p,{children:"The SCIM source allows other applications to directly create users and groups within authentik. SCIM provides predefined schema for users and groups, with a RESTful API, to enable automatic user provisioning and deprovisioning, SCIM is supported by applications such as Microsoft Entra ID, Google Workspace, and Okta."}),"\n",(0,i.jsxs)(s.p,{children:["The base SCIM URL is in the format of ",(0,i.jsx)(s.code,{children:"https://authentik.company/source/scim/<source-slug>/v2"}),". Authentication is done via Bearer tokens that are generated by authentik. When an SCIM source is created, a service account is created and a matching token is provided."]}),"\n",(0,i.jsx)(s.h2,{id:"first-steps",children:"First steps"}),"\n",(0,i.jsxs)(s.p,{children:["To set up an SCIM source, log in as an administrator into authentik. Navigate to ",(0,i.jsx)(s.strong,{children:"Directory->Federation & Social login"}),", and click on ",(0,i.jsx)(s.strong,{children:"Create"}),". Select the ",(0,i.jsx)(s.strong,{children:"SCIM Source"})," type, and give the source a name."]}),"\n",(0,i.jsxs)(s.p,{children:["After the source is created, click on the name of the source in the list, and you will see the ",(0,i.jsx)(s.strong,{children:"SCIM Base URL"})," which is used by the SCIM client. Use the ",(0,i.jsx)(s.strong,{children:"Click to copy token"})," button to copy the token which is used by the client to authenticate SCIM requests."]}),"\n",(0,i.jsx)(s.h2,{id:"supported-options--resource-types",children:"Supported Options & Resource types"}),"\n",(0,i.jsx)(s.h3,{id:"v2users",children:(0,i.jsx)(s.code,{children:"/v2/Users"})}),"\n",(0,i.jsx)(s.p,{children:"Endpoint to list, create, update and delete users."}),"\n",(0,i.jsx)(s.h3,{id:"v2groups",children:(0,i.jsx)(s.code,{children:"/v2/Groups"})}),"\n",(0,i.jsx)(s.p,{children:"Endpoint to list, create, update and delete groups."}),"\n",(0,i.jsxs)(s.p,{children:["There is also the ",(0,i.jsx)(s.code,{children:"/v2/ServiceProviderConfig"})," and ",(0,i.jsx)(s.code,{children:"/v2/ResourceTypes"}),", which is used by SCIM-enabled applications to find out which features authentik supports."]}),"\n",(0,i.jsx)(s.h2,{id:"scim-source-property-mappings",children:"SCIM source property mappings"}),"\n",(0,i.jsxs)(s.p,{children:["See the ",(0,i.jsx)(s.a,{href:"/docs/users-sources/sources/property-mappings/",children:"overview"})," for information on how property mappings work."]}),"\n",(0,i.jsx)(s.h3,{id:"expression-data",children:"Expression data"}),"\n",(0,i.jsx)(s.p,{children:"Each top level SCIM attribute is available as a variable in the expression. For example given an SCIM request with the payload of"}),"\n",(0,i.jsx)(s.pre,{children:(0,i.jsx)(s.code,{className:"language-json",children:'{\n    "schemas": [\n        "urn:scim:schemas:core:2.0",\n        "urn:scim:schemas:extension:enterprise:2.0"\n    ],\n    "userName": "foo.bar",\n    "name": {\n        "familyName": "bar",\n        "givenName": "foo",\n        "formatted": "foo.bar"\n    },\n    "emails": [\n        {\n            "value": "foo.bar@authentik.company",\n            "type": "work",\n            "primary": true\n        }\n    ],\n    "title": "",\n    "urn:scim:schemas:extension:enterprise:2.0": {\n        "department": ""\n    }\n}\n'})}),"\n",(0,i.jsx)(s.p,{children:"The following variables are available in the expression:"}),"\n",(0,i.jsxs)(s.ul,{children:["\n",(0,i.jsxs)(s.li,{children:["\n",(0,i.jsxs)(s.p,{children:[(0,i.jsx)(s.code,{children:"schemas"})," as a list of strings"]}),"\n"]}),"\n",(0,i.jsxs)(s.li,{children:["\n",(0,i.jsxs)(s.p,{children:[(0,i.jsx)(s.code,{children:"userName"})," as a string"]}),"\n"]}),"\n",(0,i.jsxs)(s.li,{children:["\n",(0,i.jsxs)(s.p,{children:[(0,i.jsx)(s.code,{children:"name"})," as a dictionary"]}),"\n"]}),"\n",(0,i.jsxs)(s.li,{children:["\n",(0,i.jsxs)(s.p,{children:[(0,i.jsx)(s.code,{children:"emails"})," as a dictionary"]}),"\n"]}),"\n",(0,i.jsxs)(s.li,{children:["\n",(0,i.jsxs)(s.p,{children:[(0,i.jsx)(s.code,{children:"title"})," as a string"]}),"\n"]}),"\n",(0,i.jsxs)(s.li,{children:["\n",(0,i.jsxs)(s.p,{children:[(0,i.jsx)(s.code,{children:"urn_scim_schemas_extension_enterprise_2_0"})," as a dictionary"]}),"\n",(0,i.jsx)(s.admonition,{type:"info",children:(0,i.jsxs)(s.p,{children:["Top-level keys which include symbols not allowed in python syntax are converted to ",(0,i.jsx)(s.code,{children:"_"}),"."]})}),"\n"]}),"\n"]})]})}function p(e={}){const{wrapper:s}={...(0,o.R)(),...e.components};return s?(0,i.jsx)(s,{...e,children:(0,i.jsx)(l,{...e})}):l(e)}}}]);