"use strict";(self.webpackChunk_goauthentik_website_docs=self.webpackChunk_goauthentik_website_docs||[]).push([[37009],{73735:(e,s,n)=>{n.r(s),n.d(s,{assets:()=>d,contentTitle:()=>a,default:()=>h,frontMatter:()=>o,metadata:()=>t,toc:()=>c});const t=JSON.parse('{"id":"services/sssd/index","title":"Integrate with sssd","description":"Support level: Community","source":"@site/integrations/services/sssd/index.md","sourceDirName":"services/sssd","slug":"/services/sssd/","permalink":"/integrations/services/sssd/","draft":false,"unlisted":false,"editUrl":"https://github.com/goauthentik/authentik/edit/main/website/integrations/services/sssd/index.md","tags":[],"version":"current","frontMatter":{"title":"Integrate with sssd","sidebar_label":"sssd"},"sidebar":"integrations","previous":{"title":"Snipe-IT","permalink":"/integrations/services/snipe-it/"},"next":{"title":"Terrakube","permalink":"/integrations/services/terrakube/"}}');var i=n(74848),r=n(28453);const o={title:"Integrate with sssd",sidebar_label:"sssd"},a="Integrate with sssd",d={},c=[{value:"What is sssd",id:"what-is-sssd",level:2},{value:"Preparation",id:"preparation",level:2},{value:"Deployment",id:"deployment",level:2},{value:"Client Configuration",id:"client-configuration",level:2},{value:"Additional Resources",id:"additional-resources",level:2}];function l(e){const s={a:"a",admonition:"admonition",blockquote:"blockquote",code:"code",em:"em",h1:"h1",h2:"h2",header:"header",li:"li",p:"p",pre:"pre",strong:"strong",ul:"ul",...(0,r.R)(),...e.components};return(0,i.jsxs)(i.Fragment,{children:[(0,i.jsx)(s.header,{children:(0,i.jsx)(s.h1,{id:"integrate-with-sssd",children:"Integrate with sssd"})}),"\n",(0,i.jsx)("span",{class:"badge badge--secondary",children:"Support level: Community"}),"\n",(0,i.jsx)(s.h2,{id:"what-is-sssd",children:"What is sssd"}),"\n",(0,i.jsxs)(s.blockquote,{children:["\n",(0,i.jsxs)(s.p,{children:[(0,i.jsx)(s.strong,{children:"SSSD"})," is an acronym for System Security Services Daemon. It is the client component of centralized identity management solutions such as FreeIPA, 389 Directory Server, Microsoft Active Directory, OpenLDAP and other directory servers. The client serves and caches the information stored in the remote directory server and provides identity, authentication and authorization services to the host machine."]}),"\n",(0,i.jsxs)(s.p,{children:["-- ",(0,i.jsx)(s.a,{href:"https://sssd.io/",children:"https://sssd.io/"})]}),"\n"]}),"\n",(0,i.jsxs)(s.p,{children:["Note that authentik supports ",(0,i.jsx)(s.em,{children:"only"})," user and group objects. As\na consequence, it cannot be used to provide automount or sudo\nconfiguration nor can it provide netgroups or services to ",(0,i.jsx)(s.code,{children:"nss"}),".\nKerberos is also not supported."]}),"\n",(0,i.jsx)(s.h2,{id:"preparation",children:"Preparation"}),"\n",(0,i.jsx)(s.p,{children:"The following placeholders are used in this guide:"}),"\n",(0,i.jsxs)(s.ul,{children:["\n",(0,i.jsxs)(s.li,{children:[(0,i.jsx)(s.code,{children:"authentik.company"})," is the FQDN of the authentik installation."]}),"\n",(0,i.jsxs)(s.li,{children:[(0,i.jsx)(s.code,{children:"ldap.baseDN"})," is the Base DN you configure in the LDAP provider."]}),"\n",(0,i.jsxs)(s.li,{children:[(0,i.jsx)(s.code,{children:"ldap.domain"})," is (typically) an FQDN for your domain. Usually\nit is just the components of your base DN. For example, if\n",(0,i.jsx)(s.code,{children:"ldap.baseDN"})," is ",(0,i.jsx)(s.code,{children:"dc=ldap,dc=goauthentik,dc=io"})," then the domain\nmight be ",(0,i.jsx)(s.code,{children:"ldap.goauthentik.io"}),"."]}),"\n",(0,i.jsxs)(s.li,{children:[(0,i.jsx)(s.code,{children:"ldap.searchGroup"}),' is the "Search Group" that can can see all\nusers and groups in authentik.']}),"\n",(0,i.jsxs)(s.li,{children:[(0,i.jsx)(s.code,{children:"sssd.serviceAccount"})," is a service account created in authentik"]}),"\n",(0,i.jsxs)(s.li,{children:[(0,i.jsx)(s.code,{children:"sssd.serviceAccountToken"})," is the service account token generated\nby authentik."]}),"\n"]}),"\n",(0,i.jsx)(s.admonition,{type:"note",children:(0,i.jsx)(s.p,{children:"This documentation lists only the settings that you need to change from their default values. Be aware that any changes other than those explicitly mentioned in this guide could cause issues accessing your application."})}),"\n",(0,i.jsxs)(s.p,{children:["Create an LDAP Provider if you don't already have one setup.\nThis guide assumes you will be running with TLS and that you've\ncorrectly setup certificates both in authentik and on the host\nrunning sssd. See the ",(0,i.jsx)(s.a,{href:"https://docs.goauthentik.io/docs/add-secure-apps/providers/ldap",children:"ldap provider docs"})," for setting up SSL on the authentik side."]}),"\n",(0,i.jsx)(s.p,{children:"Remember the Base DN you have configured for the provider as you'll\nneed it in the sssd configuration."}),"\n",(0,i.jsxs)(s.p,{children:["Create a new service account for all of your hosts to use to connect\nto LDAP and perform searches. Make sure this service account is added\nto ",(0,i.jsx)(s.code,{children:"ldap.searchGroup"}),"."]}),"\n",(0,i.jsx)(s.h2,{id:"deployment",children:"Deployment"}),"\n",(0,i.jsxs)(s.p,{children:["Create an outpost deployment for the provider you've created above, as described ",(0,i.jsx)(s.a,{href:"https://docs.goauthentik.io/add-secure-apps/outposts",children:"here"}),". Deploy this Outpost either on the same host or a different host that your\nhost(s) running sssd can access."]}),"\n",(0,i.jsx)(s.p,{children:"The outpost will connect to authentik and configure itself."}),"\n",(0,i.jsx)(s.h2,{id:"client-configuration",children:"Client Configuration"}),"\n",(0,i.jsxs)(s.p,{children:["First, install the necessary sssd packages on your host. Very likely\nthe package is just ",(0,i.jsx)(s.code,{children:"sssd"}),"."]}),"\n",(0,i.jsx)(s.admonition,{type:"note",children:(0,i.jsxs)(s.p,{children:["This guide well help you configure the ",(0,i.jsx)(s.code,{children:"sssd.conf"}),' for LDAP only. You\nwill likely need to perform other tasks for a usable setup\nlike setting up automounted or autocreated home directories that\nare beyond the scope of this guide. See the "additional resources"\nsection for some help.']})}),"\n",(0,i.jsxs)(s.p,{children:["Create a file at ",(0,i.jsx)(s.code,{children:"/etc/sssd/sssd.conf"})," with contents similar to\nthe following:"]}),"\n",(0,i.jsx)(s.pre,{children:(0,i.jsx)(s.code,{className:"language-ini",children:"[nss]\nfilter_groups = root\nfilter_users = root\nreconnection_retries = 3\n\n[sssd]\nconfig_file_version = 2\nreconnection_retries = 3\ndomains = ${ldap.domain}\nservices = nss, pam, ssh\n\n[pam]\nreconnection_retries = 3\n\n[domain/${ldap.domain}]\ncache_credentials = True\nid_provider = ldap\nchpass_provider = ldap\nauth_provider = ldap\naccess_provider = ldap\nldap_uri = ldaps://${authentik.company}:636\n\nldap_schema = rfc2307bis\nldap_search_base = ${ldap.baseDN}\nldap_user_search_base = ou=users,${ldap.baseDN}\nldap_group_search_base = ${ldap.baseDN}\n\nldap_user_object_class = user\nldap_user_name = cn\nldap_group_object_class = group\nldap_group_name = cn\n\n# Optionally, filter logins to only a specific group\n#ldap_access_order = filter\n#ldap_access_filter = memberOf=cn=authentik Admins,ou=groups,${ldap.baseDN}\n\nldap_default_bind_dn = cn=${sssd.serviceAccount},ou=users,${ldap.baseDN}\nldap_default_authtok = ${sssd.serviceAccountToken}\n"})}),"\n",(0,i.jsxs)(s.p,{children:["You should now be able to start sssd; however, the system may not\nyet be setup to use it. Depending on your platform, you may need to\nuse ",(0,i.jsx)(s.code,{children:"authconfig"})," or ",(0,i.jsx)(s.code,{children:"pam-auth-update"})," to configure your system. See\nthe additional resources section for details."]}),"\n",(0,i.jsx)(s.admonition,{type:"note",children:(0,i.jsxs)(s.p,{children:["You can store SSH authorized keys in LDAP by adding the\n",(0,i.jsx)(s.code,{children:"sshPublicKey"})," attribute to any user with their public key as\nthe value."]})}),"\n",(0,i.jsx)(s.h2,{id:"additional-resources",children:"Additional Resources"}),"\n",(0,i.jsx)(s.p,{children:"The setup of sssd may vary based on Linux distribution and version,\nhere are some resources that can help you get this setup:"}),"\n",(0,i.jsx)(s.admonition,{type:"note",children:(0,i.jsx)(s.p,{children:"authentik is providing a simple LDAP server, not an Active Directory\ndomain. Be sure you're looking at the correct sections in these guides."})}),"\n",(0,i.jsxs)(s.ul,{children:["\n",(0,i.jsx)(s.li,{children:(0,i.jsx)(s.a,{href:"https://sssd.io/docs/quick-start.html#quick-start-ldap",children:"https://sssd.io/docs/quick-start.html#quick-start-ldap"})}),"\n",(0,i.jsx)(s.li,{children:(0,i.jsx)(s.a,{href:"https://access.redhat.com/documentation/en-us/red_hat_enterprise_linux/7/html/system-level_authentication_guide/configuring_services",children:"https://access.redhat.com/documentation/en-us/red_hat_enterprise_linux/7/html/system-level_authentication_guide/configuring_services"})}),"\n",(0,i.jsx)(s.li,{children:(0,i.jsx)(s.a,{href:"https://ubuntu.com/server/docs/service-sssd",children:"https://ubuntu.com/server/docs/service-sssd"})}),"\n",(0,i.jsx)(s.li,{children:(0,i.jsx)(s.a,{href:"https://manpages.debian.org/unstable/sssd-ldap/sssd-ldap.5.en.html",children:"https://manpages.debian.org/unstable/sssd-ldap/sssd-ldap.5.en.html"})}),"\n",(0,i.jsx)(s.li,{children:(0,i.jsx)(s.a,{href:"https://wiki.archlinux.org/title/LDAP_authentication",children:"https://wiki.archlinux.org/title/LDAP_authentication"})}),"\n"]})]})}function h(e={}){const{wrapper:s}={...(0,r.R)(),...e.components};return s?(0,i.jsx)(s,{...e,children:(0,i.jsx)(l,{...e})}):l(e)}}}]);