"use strict";(self.webpackChunk_goauthentik_website_docs=self.webpackChunk_goauthentik_website_docs||[]).push([[41134],{27812:(e,t,n)=>{n.d(t,{Ay:()=>r,RM:()=>i});var s=n(74848),o=n(28453);const i=[];function a(e){const t={code:"code",pre:"pre",...(0,o.R)(),...e.components};return(0,s.jsx)(t.pre,{children:(0,s.jsx)(t.code,{className:"language-yaml",children:"# Log level that the outpost will set\n# Allowed levels: trace, debug, info, warning, error\n# Applies to: non-embedded\nlog_level: debug\n# Interval at which the outpost will refresh the providers\n# from authentik. For caching outposts (such as LDAP), the\n# cache will also be invalidated at that interval.\n# (Format: hours=1;minutes=2;seconds=3).\nrefresh_interval: minutes=5\n########################################\n# The settings below are only relevant when using a managed outpost\n########################################\n# URL that the outpost uses to connect back to authentik\nauthentik_host: https://authentik.tld/\n# Disable SSL Validation for the authentik connection\nauthentik_host_insecure: false\n# Optionally specify a different URL used for user-facing interactions\n# Applies to: proxy outposts\nauthentik_host_browser:\n# Template used for objects created (deployments/containers, services, secrets, etc)\nobject_naming_template: ak-outpost-%(name)s\n# Use a specific docker image for this outpost rather than the default. This also applies to Kubernetes\n# outposts.\n# Applies to: non-embedded\ncontainer_image:\n########################################\n# Docker outpost specific settings\n########################################\n# Network the outpost container should be connected to\n# Applies to: non-embedded\ndocker_network: null\n# Optionally disable mapping of ports to outpost container, may be useful when using docker networks\n# (Available with 2021.9.4+)\n# Applies to: non-embedded\ndocker_map_ports: true\n# Optionally additional labels for docker containers\n# (Available with 2022.1.2)\n# Applies to: non-embedded\ndocker_labels: null\n########################################\n# Kubernetes outpost specific settings\n########################################\n# Replica count for the deployment of the outpost\n# Applies to: non-embedded\nkubernetes_replicas: 1\n# Namespace to deploy in, defaults to the same namespace authentik is deployed in (if available)\nkubernetes_namespace: authentik\n# Any additional annotations to add to the ingress object, for example cert-manager\nkubernetes_ingress_annotations: {}\n# Name of the secret that is used for TLS connections, leave empty to disable TLS\nkubernetes_ingress_secret_name: authentik-outpost-tls\n# Service kind created, can be set to LoadBalancer for LDAP outposts for example\nkubernetes_service_type: ClusterIP\n# Disable any components of the kubernetes integration, can be any of\n# - 'secret'\n# - 'deployment'\n# - 'service'\n# - 'prometheus servicemonitor'\n# - 'ingress'\n# - 'traefik middleware'\nkubernetes_disabled_components: []\n# If the above docker image is in a private repository, use these secrets to pull.\n# NOTE: The secret must be created manually in the namespace first.\n# Applies to: non-embedded\nkubernetes_image_pull_secrets: []\n# Optionally configure an ingress class name. If not set, the ingress will use the cluster's\n# default ingress class\n# (Available with 2022.11.0+)\n# Applies to: proxy outposts\nkubernetes_ingress_class_name: null\n# Optionally apply an RFC 6902 compliant patch to the Kubernetes objects.\n# For an understanding of how this works, refer to the link below:\n# https://github.com/kubernetes-sigs/kustomize/blob/master/examples/jsonpatch.md\n#\n# This value expects a mapping where the key represents\n# the Kubernetes component that shall be patched.\n# It can be any of the same values supported by `kubernetes_disabled_components`.\n#\n# For example use this patch to add custom resource requests and limits\n# to the outpost deployment:\n#\n# deployment:\n#   - op: add\n#     path: \"/spec/template/spec/containers/0/resources\"\n#     value:\n#       requests:\n#         cpu: 2000m\n#         memory: 2000Mi\n#       limits:\n#         cpu: 4000m\n#         memory: 8000Mi\nkubernetes_json_patches: null\n"})})}function r(e={}){const{wrapper:t}={...(0,o.R)(),...e.components};return t?(0,s.jsx)(t,{...e,children:(0,s.jsx)(a,{...e})}):a(e)}},25223:(e,t,n)=>{n.r(t),n.d(t,{assets:()=>d,contentTitle:()=>c,default:()=>h,frontMatter:()=>r,metadata:()=>s,toc:()=>l});const s=JSON.parse('{"id":"add-secure-apps/outposts/index","title":"Outposts","description":"An outpost is a single deployment of an authentik component, essentially a service, that can be deployed anywhere that allows for a connection to the authentik API.","source":"@site/docs/add-secure-apps/outposts/index.mdx","sourceDirName":"add-secure-apps/outposts","slug":"/add-secure-apps/outposts/","permalink":"/docs/add-secure-apps/outposts/","draft":false,"unlisted":false,"editUrl":"https://github.com/goauthentik/authentik/edit/main/website/docs/add-secure-apps/outposts/index.mdx","tags":[],"version":"current","frontMatter":{"title":"Outposts"},"sidebar":"docs","previous":{"title":"Work with bindings","permalink":"/docs/add-secure-apps/flows-stages/bindings/work_with_bindings"},"next":{"title":"Embedded Outpost","permalink":"/docs/add-secure-apps/outposts/embedded/"}}');var o=n(74848),i=n(28453),a=n(27812);const r={title:"Outposts"},c=void 0,d={},l=[{value:"Create and configure an outpost",id:"create-and-configure-an-outpost",level:2},{value:"More about outpost integrations",id:"more-about-outpost-integrations",level:3},{value:"Configuration",id:"configuration",level:3},...a.RM,{value:"Prometheus Metrics",id:"prometheus-metrics",level:2}];function p(e){const t={a:"a",code:"code",em:"em",h2:"h2",h3:"h3",img:"img",li:"li",ol:"ol",p:"p",strong:"strong",ul:"ul",...(0,i.R)(),...e.components};return(0,o.jsxs)(o.Fragment,{children:[(0,o.jsx)(t.p,{children:"An outpost is a single deployment of an authentik component, essentially a service, that can be deployed anywhere that allows for a connection to the authentik API."}),"\n",(0,o.jsx)(t.p,{children:"An outpost is required if you use any of the following types of providers with your application:"}),"\n",(0,o.jsxs)(t.ul,{children:["\n",(0,o.jsx)(t.li,{children:(0,o.jsx)(t.a,{href:"/docs/add-secure-apps/providers/ldap/",children:"LDAP Provider"})}),"\n",(0,o.jsx)(t.li,{children:(0,o.jsx)(t.a,{href:"/docs/add-secure-apps/providers/proxy/",children:"Proxy Provider"})}),"\n",(0,o.jsx)(t.li,{children:(0,o.jsx)(t.a,{href:"/docs/add-secure-apps/providers/radius/",children:"RADIUS Provider"})}),"\n",(0,o.jsx)(t.li,{children:(0,o.jsx)(t.a,{href:"/docs/add-secure-apps/providers/rac/",children:"RAC Provider"})}),"\n"]}),"\n",(0,o.jsx)(t.p,{children:"These types of providers use an outpost for increased flexibility and speed. Instead of the provider logic being implemented in authentik Core, these providers use an outpost to handle the logic, which provides improved performance."}),"\n",(0,o.jsx)(t.p,{children:"An additional advantage of using an outpost is that outposts, like authentik itself, do not require access to the wider internet. Transactions between the application, the provider, and the outpost occur via the authentik API, and support single sign-on operations in firewalled or airgapped deployments and offline connections to remote machines that are not on the internet."}),"\n",(0,o.jsx)(t.p,{children:"An outpost is given permissions to access the authentik API using a service account and token, both of which are auto-generated when you create a new outpost. The outpost is granted rights to only the application/provider pairs configured (and other necessary related objects such as certificates)."}),"\n",(0,o.jsx)(t.p,{children:"Any change made to the outpost's associated app or provider immediately triggers an event to update the configuration data stored on the outpost, via websockets. Websockets are used also by the outpost to send healthchecks to the authentik Core."}),"\n",(0,o.jsx)(t.h2,{id:"create-and-configure-an-outpost",children:"Create and configure an outpost"}),"\n",(0,o.jsxs)(t.ol,{children:["\n",(0,o.jsxs)(t.li,{children:["\n",(0,o.jsx)(t.p,{children:"To create a new outpost, log in to authentik as an administrator, and open to the Admin interface."}),"\n"]}),"\n",(0,o.jsxs)(t.li,{children:["\n",(0,o.jsxs)(t.p,{children:["Navigate to ",(0,o.jsx)(t.strong,{children:"Applications --\x3e Outposts"})," and then click ",(0,o.jsx)(t.strong,{children:"Create"}),"."]}),"\n"]}),"\n"]}),"\n",(0,o.jsx)(t.p,{children:(0,o.jsx)(t.img,{src:n(41259).A+"",width:"3020",height:"1540"})}),"\n",(0,o.jsxs)(t.ol,{start:"3",children:["\n",(0,o.jsx)(t.li,{children:"Define the following values:"}),"\n"]}),"\n",(0,o.jsxs)(t.ul,{children:["\n",(0,o.jsxs)(t.li,{children:[(0,o.jsx)(t.strong,{children:"Name"}),": a name for the new outpost"]}),"\n",(0,o.jsxs)(t.li,{children:[(0,o.jsx)(t.strong,{children:"Type"}),": select the provider type (Proxy, LDAP, Radius, RAC)"]}),"\n",(0,o.jsxs)(t.li,{children:[(0,o.jsx)(t.strong,{children:"Integration"})," (",(0,o.jsx)(t.em,{children:"optional"}),"): select either your ",(0,o.jsx)(t.a,{href:"#more-about-outpost-integrations",children:"Docker or Kubernetes connection"})]}),"\n",(0,o.jsxs)(t.li,{children:[(0,o.jsx)(t.strong,{children:"Applications"}),": select the applications that you want the outpost to serve"]}),"\n",(0,o.jsxs)(t.li,{children:[(0,o.jsx)(t.strong,{children:"Advanced settings"})," (",(0,o.jsx)(t.em,{children:"optional"}),"): For further optional configuration settings, refer to ",(0,o.jsx)(t.a,{href:"#configuration",children:"Configuration"})," below."]}),"\n"]}),"\n",(0,o.jsxs)(t.ol,{start:"4",children:["\n",(0,o.jsxs)(t.li,{children:["Click ",(0,o.jsx)(t.strong,{children:"Create"})," to save your new outpost settings and close the box."]}),"\n"]}),"\n",(0,o.jsx)(t.p,{children:"Upon creation, a service account and a token is generated. The service account only has permissions to read the outpost and provider configuration. This token is used by the outpost to connect to authentik."}),"\n",(0,o.jsx)(t.h3,{id:"more-about-outpost-integrations",children:"More about outpost integrations"}),"\n",(0,o.jsx)(t.p,{children:"authentik can manage the deployment, updating, and general lifecycle of an outpost. To communicate with the underlying platforms on which the outpost is deployed, authentik has several built-in integrations."}),"\n",(0,o.jsxs)(t.ul,{children:["\n",(0,o.jsxs)(t.li,{children:["If you've deployed authentik on Docker Compose, authentik automatically creates an integration for the local docker socket (See ",(0,o.jsx)(t.a,{href:"/docs/add-secure-apps/outposts/integrations/docker",children:"Docker"}),")."]}),"\n",(0,o.jsxs)(t.li,{children:["If you've deployed authentik on Kubernetes, with ",(0,o.jsx)(t.code,{children:"kubernetesIntegration"})," set to true (default), authentik automatically creates an integrations for the local Kubernetes Cluster (see ",(0,o.jsx)(t.a,{href:"/docs/add-secure-apps/outposts/integrations/kubernetes",children:"Kubernetes"}),")."]}),"\n"]}),"\n",(0,o.jsxs)(t.p,{children:["To deploy an outpost with these integrations, select them during the creation of an outpost. A background task is started, which creates the container/deployment. The outpost deployment can be monitored from the ",(0,o.jsx)(t.strong,{children:"Dashboards -> System Tasks"})," page in the Admin interface."]}),"\n",(0,o.jsx)(t.p,{children:"To deploy an outpost manually, see:"}),"\n",(0,o.jsxs)(t.ul,{children:["\n",(0,o.jsx)(t.li,{children:(0,o.jsx)(t.a,{href:"/docs/add-secure-apps/outposts/manual-deploy-kubernetes",children:"Kubernetes"})}),"\n",(0,o.jsx)(t.li,{children:(0,o.jsx)(t.a,{href:"/docs/add-secure-apps/outposts/manual-deploy-docker-compose",children:"Docker Compose"})}),"\n"]}),"\n",(0,o.jsx)(t.h3,{id:"configuration",children:"Configuration"}),"\n",(0,o.jsx)(t.p,{children:"Outposts fetch their configuration from authentik. Below are all the options you can set, and how they influence the outpost."}),"\n","\n",(0,o.jsx)(a.Ay,{}),"\n",(0,o.jsx)(t.h2,{id:"prometheus-metrics",children:"Prometheus Metrics"}),"\n",(0,o.jsxs)(t.p,{children:["Each authentik outpost has a Prometheus metrics endpoint accessible under port ",(0,o.jsx)(t.code,{children:":9300/metrics"}),". This endpoint is not mapped via Docker, as the endpoint doesn't have any authentication."]}),"\n",(0,o.jsx)(t.p,{children:"For the embedded outpost, the metrics of the outpost and the metrics of the core authentik server are both returned under the same endpoint."})]})}function h(e={}){const{wrapper:t}={...(0,i.R)(),...e.components};return t?(0,o.jsx)(t,{...e,children:(0,o.jsx)(p,{...e})}):p(e)}},41259:(e,t,n)=>{n.d(t,{A:()=>s});const s=n.p+"assets/images/outpost-create-43dfe76fec5f49785f4ccb4418dcbd8c.png"}}]);