"use strict";(self.webpackChunk_goauthentik_website_docs=self.webpackChunk_goauthentik_website_docs||[]).push([[36140],{7536:(e,t,n)=>{n.r(t),n.d(t,{assets:()=>d,contentTitle:()=>r,default:()=>h,frontMatter:()=>o,metadata:()=>a,toc:()=>l});const a=JSON.parse('{"id":"sys-mgmt/tenancy","title":"Tenancy","description":"Enterprise","source":"@site/docs/sys-mgmt/tenancy.md","sourceDirName":"sys-mgmt","slug":"/sys-mgmt/tenancy","permalink":"/docs/sys-mgmt/tenancy","draft":false,"unlisted":false,"editUrl":"https://github.com/goauthentik/authentik/edit/main/website/docs/sys-mgmt/tenancy.md","tags":[],"version":"current","frontMatter":{"title":"Tenancy"}}');var i=n(74848),s=n(28453);const o={title:"Tenancy"},r=void 0,d={},l=[{value:"About tenants",id:"about-tenants",level:2},{value:"Licensing",id:"licensing",level:3},{value:"Important considerations",id:"important-considerations",level:3},{value:"Usage",id:"usage",level:2},{value:"1. Configure authentik to allow multiple tenants",id:"1-configure-authentik-to-allow-multiple-tenants",level:3},{value:"2. Create a new tenant with authentik API endpoints",id:"2-create-a-new-tenant-with-authentik-api-endpoints",level:3},{value:"3. Associate the new tenant with a domain",id:"3-associate-the-new-tenant-with-a-domain",level:3}];function c(e){const t={a:"a",admonition:"admonition",code:"code",em:"em",h2:"h2",h3:"h3",hr:"hr",li:"li",p:"p",ul:"ul",...(0,s.R)(),...e.components};return(0,i.jsxs)(i.Fragment,{children:[(0,i.jsx)("span",{class:"badge badge--primary",children:"Enterprise"}),"\n",(0,i.jsx)(t.hr,{}),"\n",(0,i.jsx)(t.admonition,{type:"warning",children:(0,i.jsx)(t.p,{children:"This feature is in alpha. Use at your own risk."})}),"\n",(0,i.jsx)(t.admonition,{type:"info",children:(0,i.jsxs)(t.p,{children:["This feature is available from 2024.2 and is not to be confused with ",(0,i.jsx)(t.a,{href:"/docs/brands",children:"brands"}),", which were previously called tenants."]})}),"\n",(0,i.jsx)(t.h2,{id:"about-tenants",children:"About tenants"}),"\n",(0,i.jsx)(t.p,{children:"Starting with version 2024.2, authentik allows an administrator or operator to create multiple tenants. This means that an operator can manage several different and distinct authentik installations, each with it's own Install ID and license(s). The relationships between tenant and installation (Install ID) is a 1:1 relationship, so for each tenant, there is a unique Install ID."}),"\n",(0,i.jsx)(t.admonition,{type:"danger",children:(0,i.jsx)(t.p,{children:"Expression policies currently have access to all tenants."})}),"\n",(0,i.jsx)(t.p,{children:"The data for each tenant is stored in a separate PostgreSQL schema, providing full separation of user data. License data for the tenant is also stored in the schema."}),"\n",(0,i.jsx)(t.p,{children:"Note that creating and managing multiple tenants is handled using authentik APIs, not in the Admin interface. For typical authentik installations in which only a single tenant is needed, the default tenant is automatically created by authentik, and does not need to be managed in the Admin interface."}),"\n",(0,i.jsx)(t.h3,{id:"licensing",children:"Licensing"}),"\n",(0,i.jsx)(t.p,{children:"For each additional tenant (beyond the default one), one or more licenses is required; a license key cannot be used for more than one tenant. Note that the license for the default tenant must be valid and up-to-date in order to create additional tenants."}),"\n",(0,i.jsx)(t.p,{children:"A single tenant and its corresponding installation can have multiple license keys. For example, a company might purchase one license for 50 users, and then later in the same year need to buy another license for 50 more users, due to company growth. Both licenses are associated to the one installation, the one tenant."}),"\n",(0,i.jsxs)(t.p,{children:["Learn more in our documentation about ",(0,i.jsx)(t.a,{href:"/docs/enterprise/manage-enterprise#license-management",children:"Enterprise licenses"}),"."]}),"\n",(0,i.jsx)(t.h3,{id:"important-considerations",children:"Important considerations"}),"\n",(0,i.jsxs)(t.ul,{children:["\n",(0,i.jsxs)(t.li,{children:["\n",(0,i.jsxs)(t.p,{children:["Upon creating another tenant, a new schema will be created by cloning the ",(0,i.jsx)(t.code,{children:"template"})," schema. This special schema is like a tenant with no data created in it. Cloning an existing schema instead of creating a new one and running migrations on it is done for efficiency purposes."]}),"\n"]}),"\n",(0,i.jsxs)(t.li,{children:["\n",(0,i.jsxs)(t.p,{children:["In a typical deployment, all data stored in Redis (such as tasks, locks, and cached objects) will have its keys prefixed by the ",(0,i.jsx)(t.code,{children:"schema_name"}),"."]}),"\n"]}),"\n",(0,i.jsxs)(t.li,{children:["\n",(0,i.jsxs)(t.p,{children:["Files are isolated on a per-tenant basis, with each tenant folder named according to the schema_name. For example, ",(0,i.jsx)(t.code,{children:"/media/t_example"}),". The same is true regardless of the storage backend."]}),"\n"]}),"\n",(0,i.jsxs)(t.li,{children:["\n",(0,i.jsxs)(t.p,{children:["Using an ",(0,i.jsx)(t.a,{href:"/docs/add-secure-apps/outposts/embedded/",children:"embedded outpost"})," with multi-tenancy is not currently supported. Disable the embedded outpost with ",(0,i.jsx)(t.code,{children:"AUTHENTIK_OUTPOSTS__DISABLE_EMBEDDED_OUTPOST=true"})," configuration setting."]}),"\n"]}),"\n"]}),"\n",(0,i.jsx)(t.h2,{id:"usage",children:"Usage"}),"\n",(0,i.jsx)(t.p,{children:"To create one or more additional tenants (beyond the default tenant) use the following instructions."}),"\n",(0,i.jsx)(t.h3,{id:"1-configure-authentik-to-allow-multiple-tenants",children:"1. Configure authentik to allow multiple tenants"}),"\n",(0,i.jsxs)(t.p,{children:["First, enable the multi-tenancy feature with the ",(0,i.jsx)(t.code,{children:"AUTHENTIK_TENANTS__ENABLED=true"})," ",(0,i.jsx)(t.a,{href:"/docs/install-config/configuration/",children:"configuration setting"}),"."]}),"\n",(0,i.jsxs)(t.p,{children:["Next, set ",(0,i.jsx)(t.code,{children:"AUTHENTIK_TENANTS__API_KEY"})," to a random string. This string will be used to authenticate to the tenancy API. This key allows the creation of recovery keys for every tenant hosted by authentik, so be sure to ",(0,i.jsx)(t.em,{children:"store it securely"}),". Be aware that creating a recovery key allows access to all data stored inside a tenant."]}),"\n",(0,i.jsxs)(t.p,{children:["Be sure to disable the embedded outpost with ",(0,i.jsx)(t.code,{children:"AUTHENTIK_OUTPOSTS__DISABLE_EMBEDDED_OUTPOST=true"})," because it is not supported with tenants."]}),"\n",(0,i.jsx)(t.h3,{id:"2-create-a-new-tenant-with-authentik-api-endpoints",children:"2. Create a new tenant with authentik API endpoints"}),"\n",(0,i.jsxs)(t.p,{children:["Tenants are created using the API routes associated. Search for ",(0,i.jsx)(t.code,{children:"tenant"})," in the ",(0,i.jsx)(t.a,{href:"../developer-docs/api/reference/authentik",children:"API browser"})," for the available endpoints."]}),"\n",(0,i.jsxs)(t.p,{children:["When creating a tenant you must specify a ",(0,i.jsx)(t.code,{children:"name"}),", used for display purposes, and a ",(0,i.jsx)(t.code,{children:"schema_name"}),", used to create the PostgreSQL schema associated with the tenant."]}),"\n",(0,i.jsx)(t.admonition,{type:"info",children:(0,i.jsxs)(t.p,{children:["The ",(0,i.jsx)(t.code,{children:"schema_name"})," must start with ",(0,i.jsx)(t.code,{children:"t_"})," and not be more than 64 characters long."]})}),"\n",(0,i.jsxs)(t.p,{children:["There is always at least one tenant, ",(0,i.jsx)(t.code,{children:"public"}),". This is the default tenant and cannot be deleted. Despite its name, it is not freely available to the world. Instead, it is stored in the ",(0,i.jsx)(t.code,{children:"public"})," schema of the PostgreSQL database."]}),"\n",(0,i.jsx)(t.h3,{id:"3-associate-the-new-tenant-with-a-domain",children:"3. Associate the new tenant with a domain"}),"\n",(0,i.jsx)(t.p,{children:"By default, all requests that do not explicitly belong to a tenant are redirected to the default tenant. Thus, after creating a tenant, you must associate a domain for which incoming requests will be redirected to said tenant."}),"\n",(0,i.jsxs)(t.p,{children:["You can do so with API endpoints. After creating a domain ",(0,i.jsx)(t.code,{children:"example.org"})," that is associated to the tenant ",(0,i.jsx)(t.code,{children:"t_example"}),", all requests made to ",(0,i.jsx)(t.code,{children:"example.org"})," will use the ",(0,i.jsx)(t.code,{children:"t_example"})," tenant. However, requests made to ",(0,i.jsx)(t.code,{children:"authentik.tld"}),", ",(0,i.jsx)(t.code,{children:"subdomain.example.org"})," and any other domain that is not associated with the ",(0,i.jsx)(t.code,{children:"t_example"})," tenant will use the default tenant."]}),"\n",(0,i.jsx)(t.p,{children:"In summary, if you access a domain that is not explicitly associated with a specific tenant, it will be routed to the default tenant."})]})}function h(e={}){const{wrapper:t}={...(0,s.R)(),...e.components};return t?(0,i.jsx)(t,{...e,children:(0,i.jsx)(c,{...e})}):c(e)}}}]);