"use strict";(self.webpackChunk_goauthentik_website_docs=self.webpackChunk_goauthentik_website_docs||[]).push([[5044],{703:(e,i,s)=>{s.r(i),s.d(i,{assets:()=>d,contentTitle:()=>a,default:()=>p,frontMatter:()=>o,metadata:()=>t,toc:()=>l});const t=JSON.parse('{"id":"add-secure-apps/providers/scim/index","title":"SCIM Provider","description":"SCIM (System for Cross-domain Identity Management) is a set of APIs to provision users and groups. The SCIM provider in authentik supports SCIM 2.0 and can be used to provision and sync users from authentik into other applications.","source":"@site/docs/add-secure-apps/providers/scim/index.md","sourceDirName":"add-secure-apps/providers/scim","slug":"/add-secure-apps/providers/scim/","permalink":"/docs/add-secure-apps/providers/scim/","draft":false,"unlisted":false,"editUrl":"https://github.com/goauthentik/authentik/edit/main/website/docs/add-secure-apps/providers/scim/index.md","tags":[],"version":"current","frontMatter":{"title":"SCIM Provider"},"sidebar":"docs","previous":{"title":"SAML Provider","permalink":"/docs/add-secure-apps/providers/saml/"},"next":{"title":"SSF Provider","permalink":"/docs/add-secure-apps/providers/ssf/"}}');var n=s(74848),r=s(28453);const o={title:"SCIM Provider"},a=void 0,d={},l=[{value:"Configuration",id:"configuration",level:3},{value:"Syncing",id:"syncing",level:3},{value:"Attribute mapping",id:"attribute-mapping",level:3},{value:"Filtering",id:"filtering",level:3},{value:"Supported features",id:"supported-features",level:3},{value:"Using in conjunction with other providers",id:"using-in-conjunction-with-other-providers",level:3},{value:"OAuth/OIDC",id:"oauthoidc",level:4},{value:"SAML",id:"saml",level:4}];function h(e){const i={admonition:"admonition",code:"code",em:"em",h3:"h3",h4:"h4",li:"li",p:"p",strong:"strong",ul:"ul",...(0,r.R)(),...e.components};return(0,n.jsxs)(n.Fragment,{children:[(0,n.jsx)(i.p,{children:"SCIM (System for Cross-domain Identity Management) is a set of APIs to provision users and groups. The SCIM provider in authentik supports SCIM 2.0 and can be used to provision and sync users from authentik into other applications."}),"\n",(0,n.jsx)(i.h3,{id:"configuration",children:"Configuration"}),"\n",(0,n.jsx)(i.p,{children:"A SCIM provider requires a base URL and a token. SCIM works via HTTP requests, so authentik must be able to reach the specified endpoint."}),"\n",(0,n.jsxs)(i.p,{children:["When configuring SCIM, you'll get an endpoint and a token from the application that accepts SCIM data. This endpoint usually ends in ",(0,n.jsx)(i.code,{children:"/v2"}),", which corresponds to the SCIM version supported."]}),"\n",(0,n.jsx)(i.p,{children:"The token given by the application will be sent with all outgoing SCIM requests to authenticate them."}),"\n",(0,n.jsx)(i.admonition,{type:"info",children:(0,n.jsxs)(i.p,{children:["When adding the SCIM provider, you must define the **Backchannel provider using the name of the SCIM provider that you created in authentik. Do NOT add any value in the ",(0,n.jsx)(i.strong,{children:"Provider"})," field (doing so will cause the provider to display as an application on the user interface, under **My apps**, which is not supported for SCIM)."]})}),"\n",(0,n.jsx)(i.h3,{id:"syncing",children:"Syncing"}),"\n",(0,n.jsx)(i.p,{children:"Data is synchronized in multiple ways:"}),"\n",(0,n.jsxs)(i.ul,{children:["\n",(0,n.jsx)(i.li,{children:"When a user/group is created/modified/deleted, that action is sent to all SCIM providers"}),"\n",(0,n.jsx)(i.li,{children:"Periodically (once an hour), all SCIM providers are fully synchronized"}),"\n"]}),"\n",(0,n.jsx)(i.p,{children:"The actual synchronization process is run in the authentik worker. To allow this process to better to scale, a task is started for each 100 users and groups, so when multiple workers are available the workload will be distributed."}),"\n",(0,n.jsx)(i.h3,{id:"attribute-mapping",children:"Attribute mapping"}),"\n",(0,n.jsx)(i.p,{children:"Attribute mapping from authentik to SCIM users is done via property mappings as with other providers. The default mappings for users and groups make some assumptions that should work for most setups, but it is also possible to define custom mappings to add fields."}),"\n",(0,n.jsx)(i.p,{children:"All selected mappings are applied in the order of their name, and are deeply merged onto the final user data. The final data is then validated against the SCIM schema, and if the data is not valid, the sync is stopped."}),"\n",(0,n.jsx)(i.h3,{id:"filtering",children:"Filtering"}),"\n",(0,n.jsxs)(i.p,{children:["By default, service accounts are excluded from being synchronized. This can be configured in the SCIM provider. Additionally, an optional group can be configured to only synchronize the users that are members of the selected group. Changing this group selection does ",(0,n.jsx)(i.em,{children:"not"})," remove members outside of the group that might have been created previously."]}),"\n",(0,n.jsx)(i.h3,{id:"supported-features",children:"Supported features"}),"\n",(0,n.jsx)(i.p,{children:"SCIM defines multiple optional features, some of which are supported by the SCIM provider."}),"\n",(0,n.jsxs)(i.ul,{children:["\n",(0,n.jsxs)(i.li,{children:["\n",(0,n.jsx)(i.p,{children:"Patch updates"}),"\n",(0,n.jsx)(i.p,{children:"If the service provider supports patch updates, authentik will use patch requests to add/remove members of groups. For all other updates, such as user updates and other group updates, PUT requests are used."}),"\n"]}),"\n"]}),"\n",(0,n.jsx)(i.h3,{id:"using-in-conjunction-with-other-providers",children:"Using in conjunction with other providers"}),"\n",(0,n.jsx)(i.p,{children:"A lot of applications support SCIM in conjunction with another SSO protocol like OAuth/OIDC or SAML. With default settings, the unique user IDs in SCIM and other protocols are identical, which should easily allow applications to link users the are provisioned with users that are logging in."}),"\n",(0,n.jsxs)(i.p,{children:["Applications can either match users on a unique ID sent by authentik called ",(0,n.jsx)(i.code,{children:"externalId"}),", by their email or username."]}),"\n",(0,n.jsx)(i.h4,{id:"oauthoidc",children:"OAuth/OIDC"}),"\n",(0,n.jsxs)(i.p,{children:["The default provider configuration for the ",(0,n.jsx)(i.em,{children:"Subject mode"})," option of ",(0,n.jsx)(i.em,{children:"Based on the User's hashed ID"})," matches the ",(0,n.jsx)(i.code,{children:"externalId"})," that's generated by default. If any other ",(0,n.jsx)(i.em,{children:"Subject mode"})," is selected, the ",(0,n.jsx)(i.code,{children:"externalId"})," attribute can be customized via SCIM mappings."]}),"\n",(0,n.jsx)(i.h4,{id:"saml",children:"SAML"}),"\n",(0,n.jsxs)(i.p,{children:["The SAML NameID policy ",(0,n.jsx)(i.em,{children:"urn:oasis:names:tc:SAML:2.0:nameid-format:persistent"})," uses the same unique user identifier as the default ",(0,n.jsx)(i.code,{children:"externalId"})," value used by the SCIM provider. If a SAML application does not send a NameID request, this value is also used as fallback."]})]})}function p(e={}){const{wrapper:i}={...(0,r.R)(),...e.components};return i?(0,n.jsx)(i,{...e,children:(0,n.jsx)(h,{...e})}):h(e)}}}]);