"use strict";(self.webpackChunk_goauthentik_website_docs=self.webpackChunk_goauthentik_website_docs||[]).push([[7939],{44124:(e,t,s)=>{s.r(t),s.d(t,{assets:()=>a,contentTitle:()=>c,default:()=>l,frontMatter:()=>r,metadata:()=>n,toc:()=>d});const n=JSON.parse('{"id":"add-secure-apps/outposts/integrations/docker","title":"Docker","description":"The Docker integration automatically deploys and manages outpost containers using the Docker HTTP API.","source":"@site/docs/add-secure-apps/outposts/integrations/docker.md","sourceDirName":"add-secure-apps/outposts/integrations","slug":"/add-secure-apps/outposts/integrations/docker","permalink":"/docs/add-secure-apps/outposts/integrations/docker","draft":false,"unlisted":false,"editUrl":"https://github.com/goauthentik/authentik/edit/main/website/docs/add-secure-apps/outposts/integrations/docker.md","tags":[],"version":"current","frontMatter":{"title":"Docker"},"sidebar":"docs","previous":{"title":"Embedded Outpost","permalink":"/docs/add-secure-apps/outposts/embedded/"},"next":{"title":"Kubernetes","permalink":"/docs/add-secure-apps/outposts/integrations/kubernetes"}}');var i=s(74848),o=s(28453);const r={title:"Docker"},c=void 0,a={},d=[{value:"Permissions",id:"permissions",level:2},{value:"Docker Socket Proxy",id:"docker-socket-proxy",level:2},{value:"Remote hosts (TLS)",id:"remote-hosts-tls",level:2},{value:"Remote hosts (SSH)",id:"remote-hosts-ssh",level:2},{value:"Advanced SSH config",id:"advanced-ssh-config",level:4}];function h(e){const t={a:"a",code:"code",em:"em",h2:"h2",h4:"h4",li:"li",p:"p",pre:"pre",ul:"ul",...(0,o.R)(),...e.components};return(0,i.jsxs)(i.Fragment,{children:[(0,i.jsx)(t.p,{children:"The Docker integration automatically deploys and manages outpost containers using the Docker HTTP API."}),"\n",(0,i.jsx)(t.p,{children:"This integration has the advantage over manual deployments of automatic updates that whenever authentik is upgraded to a later version, it also upgrades the outposts."}),"\n",(0,i.jsx)(t.p,{children:"The following outpost settings are used:"}),"\n",(0,i.jsxs)(t.ul,{children:["\n",(0,i.jsxs)(t.li,{children:[(0,i.jsx)(t.code,{children:"object_naming_template"}),": Configures how the container is called."]}),"\n",(0,i.jsxs)(t.li,{children:[(0,i.jsx)(t.code,{children:"container_image"}),": Optionally overwrites the standard container image (see ",(0,i.jsx)(t.a,{href:"/docs/install-config/configuration/#authentik_outposts",children:"Configuration"})," to configure the global default)."]}),"\n",(0,i.jsxs)(t.li,{children:[(0,i.jsx)(t.code,{children:"docker_network"}),": The Docker network the container should be added to. This needs to be modified if you plan to connect to authentik using the internal hostname."]}),"\n",(0,i.jsxs)(t.li,{children:[(0,i.jsx)(t.code,{children:"docker_map_ports"}),": Enable/disable the mapping of ports. When using a proxy outpost with Traefik for example, you might not want to bind ports as they are routed through Traefik."]}),"\n",(0,i.jsxs)(t.li,{children:[(0,i.jsx)(t.code,{children:"docker_labels"}),": Optional additional labels that can be applied to the container."]}),"\n"]}),"\n",(0,i.jsx)(t.p,{children:"The container is created with the following hardcoded properties:"}),"\n",(0,i.jsxs)(t.ul,{children:["\n",(0,i.jsxs)(t.li,{children:["\n",(0,i.jsx)(t.p,{children:"Labels"}),"\n",(0,i.jsxs)(t.ul,{children:["\n",(0,i.jsxs)(t.li,{children:[(0,i.jsx)(t.code,{children:"io.goauthentik.outpost-uuid"}),": Used by authentik to identify the container, and to allow for name changes."]}),"\n"]}),"\n",(0,i.jsx)(t.p,{children:"Additionally, the proxy outposts have the following extra labels to add themselves into Traefik automatically."}),"\n",(0,i.jsxs)(t.ul,{children:["\n",(0,i.jsxs)(t.li,{children:[(0,i.jsx)(t.code,{children:"traefik.enable"}),': "true"']}),"\n",(0,i.jsxs)(t.li,{children:[(0,i.jsx)(t.code,{children:"traefik.http.routers.ak-outpost-<outpost-name>-router.rule"}),": ",(0,i.jsx)(t.code,{children:"Host(...)"})]}),"\n",(0,i.jsxs)(t.li,{children:[(0,i.jsx)(t.code,{children:"traefik.http.routers.ak-outpost-<outpost-name>-router.service"}),": ",(0,i.jsx)(t.code,{children:"ak-outpost-<outpost-name>-service"})]}),"\n",(0,i.jsxs)(t.li,{children:[(0,i.jsx)(t.code,{children:"traefik.http.routers.ak-outpost-<outpost-name>-router.tls"}),': "true"']}),"\n",(0,i.jsxs)(t.li,{children:[(0,i.jsx)(t.code,{children:"traefik.http.services.ak-outpost-<outpost-name>-service.loadbalancer.healthcheck.path"}),': "/outpost.goauthentik.io/ping"']}),"\n",(0,i.jsxs)(t.li,{children:[(0,i.jsx)(t.code,{children:"traefik.http.services.ak-outpost-<outpost-name>-service.loadbalancer.healthcheck.port"}),': "9300"']}),"\n",(0,i.jsxs)(t.li,{children:[(0,i.jsx)(t.code,{children:"traefik.http.services.ak-outpost-<outpost-name>-service.loadbalancer.server.port"}),': "9000"']}),"\n"]}),"\n"]}),"\n"]}),"\n",(0,i.jsx)(t.h2,{id:"permissions",children:"Permissions"}),"\n",(0,i.jsx)(t.p,{children:"authentik requires the following permissions from the Docker API:"}),"\n",(0,i.jsxs)(t.ul,{children:["\n",(0,i.jsx)(t.li,{children:"Images/Pull: authentik tries to pre-pull the custom image if one is configured, otherwise falling back to the default image."}),"\n",(0,i.jsx)(t.li,{children:"Containers/Read: Gather infos about currently running container"}),"\n",(0,i.jsx)(t.li,{children:"Containers/Create: Create new containers"}),"\n",(0,i.jsx)(t.li,{children:"Containers/Kill: Cleanup during upgrades"}),"\n",(0,i.jsx)(t.li,{children:"Containers/Remove: Removal of outposts"}),"\n",(0,i.jsx)(t.li,{children:"System/Info: Gather information about the version of Docker running"}),"\n"]}),"\n",(0,i.jsx)(t.h2,{id:"docker-socket-proxy",children:"Docker Socket Proxy"}),"\n",(0,i.jsx)(t.p,{children:"Mapping the Docker socket to a container comes with some inherent security risks. Applications inside these containers have unfettered access to the full Docker API, which can be used to gain unauthorized access to sensitive Docker functions."}),"\n",(0,i.jsx)(t.p,{children:"It can also result in possible root escalation on the host system."}),"\n",(0,i.jsxs)(t.p,{children:["To prevent this, many people use projects like ",(0,i.jsx)(t.a,{href:"https://docs.linuxserver.io/images/docker-socket-proxy/",children:"docker-socket-proxy"}),", which limit access to the Docker socket by filtering and restricting API calls that these applications can make."]}),"\n",(0,i.jsxs)(t.p,{children:["See ",(0,i.jsx)(t.a,{href:"#permissions",children:"permissions"})," for the list of APIs that authentik needs access to."]}),"\n",(0,i.jsxs)(t.p,{children:["Note: Connections from authentik to Docker socket proxy must be made over HTTP, not TCP, e.g. ",(0,i.jsx)(t.code,{children:"http://<docker-socket-proxy hostname/container name>:<port>"}),"."]}),"\n",(0,i.jsx)(t.h2,{id:"remote-hosts-tls",children:"Remote hosts (TLS)"}),"\n",(0,i.jsxs)(t.p,{children:["To connect remote hosts, follow this guide from Docker ",(0,i.jsx)(t.a,{href:"https://docs.docker.com/engine/security/protect-access/#use-tls-https-to-protect-the-docker-daemon-socket",children:"Use TLS (HTTPS) to protect the Docker daemon socket"})," to configure Docker."]}),"\n",(0,i.jsx)(t.p,{children:"Afterwards, create two certificate-keypairs in authentik:"}),"\n",(0,i.jsxs)(t.ul,{children:["\n",(0,i.jsxs)(t.li,{children:[(0,i.jsx)(t.code,{children:"Docker CA"}),", with the contents of ",(0,i.jsx)(t.code,{children:"~/.docker/ca.pem"})," as Certificate"]}),"\n",(0,i.jsxs)(t.li,{children:[(0,i.jsx)(t.code,{children:"Docker Cert"}),", with the contents of ",(0,i.jsx)(t.code,{children:"~/.docker/cert.pem"})," as the certificate and ",(0,i.jsx)(t.code,{children:"~/.docker/key.pem"})," as the private key."]}),"\n"]}),"\n",(0,i.jsxs)(t.p,{children:["Create an integration with ",(0,i.jsx)(t.code,{children:"Docker CA"})," as ",(0,i.jsx)(t.em,{children:"TLS Verification Certificate"})," and ",(0,i.jsx)(t.code,{children:"Docker Cert"})," as ",(0,i.jsx)(t.em,{children:"TLS Authentication Certificate"}),"."]}),"\n",(0,i.jsx)(t.h2,{id:"remote-hosts-ssh",children:"Remote hosts (SSH)"}),"\n",(0,i.jsx)(t.p,{children:"authentik can connect to remote Docker hosts using SSH. To configure this, create a new SSH keypair using these commands:"}),"\n",(0,i.jsx)(t.pre,{children:(0,i.jsx)(t.code,{children:'# Generate the keypair itself, using RSA keys in the PEM format\nssh-keygen -t rsa -f authentik  -N "" -m pem\n# Generate a certificate from the private key, required by authentik.\n# The values that openssl prompts you for are not relevant\nopenssl req -x509 -sha256 -nodes -days 365 -out certificate.pem -key authentik\n'})}),"\n",(0,i.jsx)(t.p,{children:"You'll end up with three files:"}),"\n",(0,i.jsxs)(t.ul,{children:["\n",(0,i.jsxs)(t.li,{children:[(0,i.jsx)(t.code,{children:"authentik.pub"})," is the public key, this should be added to the ",(0,i.jsx)(t.code,{children:"~/.ssh/authorized_keys"})," file on the target host and user."]}),"\n",(0,i.jsxs)(t.li,{children:[(0,i.jsx)(t.code,{children:"authentik"})," is the private key, which should be imported into a Keypair in authentik."]}),"\n",(0,i.jsxs)(t.li,{children:[(0,i.jsx)(t.code,{children:"certificate.pem"})," is the matching certificate for the keypair above."]}),"\n"]}),"\n",(0,i.jsxs)(t.p,{children:["Modify/create a new Docker integration, and set your ",(0,i.jsx)(t.em,{children:"Docker URL"})," to ",(0,i.jsx)(t.code,{children:"ssh://hostname"}),", and select the keypair you created above as ",(0,i.jsx)(t.em,{children:"TLS Authentication Certificate/SSH Keypair"}),"."]}),"\n",(0,i.jsxs)(t.p,{children:["The ",(0,i.jsx)(t.em,{children:"Docker URL"})," field include a user, if none is specified authentik connects with the user ",(0,i.jsx)(t.code,{children:"authentik"}),"."]}),"\n",(0,i.jsx)(t.h4,{id:"advanced-ssh-config",children:"Advanced SSH config"}),"\n",(0,i.jsxs)(t.p,{children:["With the above configuration, authentik will create and manage an ",(0,i.jsx)(t.code,{children:"~/.ssh/config"})," file. If you need advanced configuration, for example SSH Certificates, you can mount a custom SSH Config file."]}),"\n",(0,i.jsxs)(t.p,{children:["Mount the config file into ",(0,i.jsx)(t.code,{children:"/authentik/.ssh/config"}),", and mount any other relevant files into a directory under ",(0,i.jsx)(t.code,{children:"/opt"}),". Afterwards, create an integration using ",(0,i.jsx)(t.code,{children:"ssh://hostname"}),", and don't select a keypair."]})]})}function l(e={}){const{wrapper:t}={...(0,o.R)(),...e.components};return t?(0,i.jsx)(t,{...e,children:(0,i.jsx)(h,{...e})}):h(e)}}}]);