"use strict";(self.webpackChunk_goauthentik_website_docs=self.webpackChunk_goauthentik_website_docs||[]).push([[54169],{99938:(e,s,t)=>{t.r(s),t.d(s,{assets:()=>d,contentTitle:()=>a,default:()=>h,frontMatter:()=>o,metadata:()=>r,toc:()=>c});const r=JSON.parse('{"id":"core/architecture","title":"Architecture","description":"authentik consists of a handful of components, most of which are required for a functioning setup.","source":"@site/docs/core/architecture.md","sourceDirName":"core","slug":"/core/architecture","permalink":"/docs/core/architecture","draft":false,"unlisted":false,"editUrl":"https://github.com/goauthentik/authentik/edit/main/website/docs/core/architecture.md","tags":[],"version":"current","frontMatter":{"title":"Architecture"},"sidebar":"docs","previous":{"title":"Terminology","permalink":"/docs/terminology"},"next":{"title":"Welcome to authentik Enterprise","permalink":"/docs/enterprise/"}}');var i=t(74848),n=t(28453);const o={title:"Architecture"},a=void 0,d={},c=[{value:"Server",id:"server",level:3},{value:"Core",id:"core",level:4},{value:"Embedded outpost",id:"embedded-outpost",level:4},{value:"Persistence",id:"persistence",level:4},{value:"Background Worker",id:"background-worker",level:3},{value:"Persistence",id:"persistence-1",level:4},{value:"PostgreSQL",id:"postgresql",level:3},{value:"Persistence",id:"persistence-2",level:4},{value:"Redis",id:"redis",level:3},{value:"Persistence",id:"persistence-3",level:4}];function l(e){const s={a:"a",code:"code",em:"em",h3:"h3",h4:"h4",li:"li",mermaid:"mermaid",p:"p",ul:"ul",...(0,n.R)(),...e.components};return(0,i.jsxs)(i.Fragment,{children:[(0,i.jsx)(s.p,{children:"authentik consists of a handful of components, most of which are required for a functioning setup."}),"\n",(0,i.jsx)(s.mermaid,{value:"graph LR\n    user(User) --\x3e ak_server(authentik Server)\n    ak_server --\x3e ak_server_core(authentik Server Core)\n    ak_server --\x3e ak_outpost(Embedded outpost)\n    ak_server_core --\x3e db(PostgreSQL)\n    ak_server_core --\x3e cache(Redis)\n    ak_worker(Background Worker) --\x3e db(PostgreSQL)\n    ak_worker(Background Worker) --\x3e cache(Redis)"}),"\n",(0,i.jsx)(s.h3,{id:"server",children:"Server"}),"\n",(0,i.jsxs)(s.p,{children:["The server container consists of two sub-components, the actual server itself and the embedded outpost. Incoming requests to the server container(s) are routed by a lightweight router to either the ",(0,i.jsx)(s.em,{children:"Core"})," server or the embedded outpost. This router also handles requests for any static assets such as JavaScript and CSS files."]}),"\n",(0,i.jsx)(s.h4,{id:"core",children:"Core"}),"\n",(0,i.jsx)(s.p,{children:"The core sub-component handles most of authentik's logic, such as API requests, flow executions, any kind of SSO requests, etc."}),"\n",(0,i.jsx)(s.h4,{id:"embedded-outpost",children:"Embedded outpost"}),"\n",(0,i.jsxs)(s.p,{children:["Similar to ",(0,i.jsx)(s.a,{href:"/docs/add-secure-apps/outposts/",children:"other outposts"}),", this outpost allows using ",(0,i.jsx)(s.a,{href:"/docs/add-secure-apps/providers/proxy/",children:"Proxy providers"})," without deploying a separate outpost."]}),"\n",(0,i.jsx)(s.h4,{id:"persistence",children:"Persistence"}),"\n",(0,i.jsxs)(s.ul,{children:["\n",(0,i.jsxs)(s.li,{children:[(0,i.jsx)(s.code,{children:"/media"})," is used to store icons and such, but not required, and if not mounted, authentik will allow you to set a URL to icons in place of a file upload"]}),"\n"]}),"\n",(0,i.jsx)(s.h3,{id:"background-worker",children:"Background Worker"}),"\n",(0,i.jsxs)(s.p,{children:["This container executes background tasks, such as sending emails, the event notification system, and everything you can see on the ",(0,i.jsx)(s.em,{children:"System Tasks"})," page in the frontend."]}),"\n",(0,i.jsx)(s.h4,{id:"persistence-1",children:"Persistence"}),"\n",(0,i.jsxs)(s.ul,{children:["\n",(0,i.jsxs)(s.li,{children:[(0,i.jsx)(s.code,{children:"/certs"})," is used for authentik to import external certs, which in most cases shouldn't be used for SAML, but rather if you use authentik without a reverse proxy, this can be used for example for the ",(0,i.jsx)(s.a,{href:"/docs/sys-mgmt/certificates#lets-encrypt",children:"Let's Encrypt integration"})]}),"\n",(0,i.jsxs)(s.li,{children:[(0,i.jsx)(s.code,{children:"/templates"})," is used for ",(0,i.jsx)(s.a,{href:"/docs/add-secure-apps/flows-stages/stages/email/#custom-templates",children:"custom email templates"}),", and as with the other ones fully optional"]}),"\n"]}),"\n",(0,i.jsx)(s.h3,{id:"postgresql",children:"PostgreSQL"}),"\n",(0,i.jsx)(s.p,{children:"authentik uses PostgreSQL to store all of its configuration and other data (excluding uploaded files)."}),"\n",(0,i.jsx)(s.h4,{id:"persistence-2",children:"Persistence"}),"\n",(0,i.jsxs)(s.ul,{children:["\n",(0,i.jsxs)(s.li,{children:[(0,i.jsx)(s.code,{children:"/var/lib/postgresql/data"})," is used to store the PostgreSQL database"]}),"\n"]}),"\n",(0,i.jsx)(s.p,{children:"On Kubernetes, with the default Helm chart and using the packaged PostgreSQL sub-chart, persistent data is stored in a PVC."}),"\n",(0,i.jsx)(s.h3,{id:"redis",children:"Redis"}),"\n",(0,i.jsx)(s.p,{children:"authentik uses Redis as a message-queue and a cache. Data in Redis is not required to be persistent, however you should be aware that restarting Redis will cause the loss of all sessions."}),"\n",(0,i.jsx)(s.h4,{id:"persistence-3",children:"Persistence"}),"\n",(0,i.jsxs)(s.ul,{children:["\n",(0,i.jsxs)(s.li,{children:[(0,i.jsx)(s.code,{children:"/data"})," is used to store the Redis data"]}),"\n"]}),"\n",(0,i.jsx)(s.p,{children:"On Kubernetes, with the default Helm chart and using the packaged Redis sub-chart, persistent data is stored in a PVC."})]})}function h(e={}){const{wrapper:s}={...(0,n.R)(),...e.components};return s?(0,i.jsx)(s,{...e,children:(0,i.jsx)(l,{...e})}):l(e)}}}]);