"use strict";(self.webpackChunk_goauthentik_website_docs=self.webpackChunk_goauthentik_website_docs||[]).push([[59629],{82788:(e,t,s)=>{s.r(t),s.d(t,{assets:()=>d,contentTitle:()=>o,default:()=>u,frontMatter:()=>i,metadata:()=>n,toc:()=>l});const n=JSON.parse('{"id":"troubleshooting/postgres/upgrade_kubernetes","title":"Upgrade PostgreSQL on Kubernetes","description":"Preparation","source":"@site/docs/troubleshooting/postgres/upgrade_kubernetes.md","sourceDirName":"troubleshooting/postgres","slug":"/troubleshooting/postgres/upgrade_kubernetes","permalink":"/docs/troubleshooting/postgres/upgrade_kubernetes","draft":false,"unlisted":false,"editUrl":"https://github.com/goauthentik/authentik/edit/main/website/docs/troubleshooting/postgres/upgrade_kubernetes.md","tags":[],"version":"current","frontMatter":{"title":"Upgrade PostgreSQL on Kubernetes"},"sidebar":"docs","previous":{"title":"General troubleshooting steps","permalink":"/docs/troubleshooting/forward_auth/general"},"next":{"title":"Upgrade PostgreSQL on Docker Compose","permalink":"/docs/troubleshooting/postgres/upgrade_docker"}}');var r=s(74848),a=s(28453);const i={title:"Upgrade PostgreSQL on Kubernetes"},o=void 0,d={},l=[{value:"Preparation",id:"preparation",level:2},{value:"Prerequisites",id:"prerequisites",level:3},{value:"Dump the current database",id:"dump-the-current-database",level:3},{value:"Stop PostgreSQL and start the upgrade",id:"stop-postgresql-and-start-the-upgrade",level:3},{value:"Remove the old data",id:"remove-the-old-data",level:3},{value:"Restart PostgreSQL",id:"restart-postgresql",level:3},{value:"Restarting authentik",id:"restarting-authentik",level:3}];function h(e){const t={a:"a",code:"code",em:"em",h2:"h2",h3:"h3",li:"li",p:"p",pre:"pre",ul:"ul",...(0,a.R)(),...e.components};return(0,r.jsxs)(r.Fragment,{children:[(0,r.jsx)(t.h2,{id:"preparation",children:"Preparation"}),"\n",(0,r.jsxs)(t.ul,{children:["\n",(0,r.jsxs)(t.li,{children:[(0,r.jsx)(t.code,{children:"authentik-postgresql-0"})," is the Kubernetes Pod running PostgreSQL."]}),"\n"]}),"\n",(0,r.jsx)(t.h3,{id:"prerequisites",children:"Prerequisites"}),"\n",(0,r.jsx)(t.p,{children:"This migration requires some downtime, during which authentik must be stopped. To do this, run the following command:"}),"\n",(0,r.jsx)(t.pre,{children:(0,r.jsx)(t.code,{className:"language-shell",children:"kubectl scale deploy --replicas 0 authentik-server\nkubectl scale deploy --replicas 0 authentik-worker\n"})}),"\n",(0,r.jsx)(t.h3,{id:"dump-the-current-database",children:"Dump the current database"}),"\n",(0,r.jsxs)(t.p,{children:["Run ",(0,r.jsx)(t.code,{children:"kubectl exec -it authentik-postgresql-0 -- bash"})," to get a shell in the PostgreSQL pod."]}),"\n",(0,r.jsxs)(t.p,{children:["Run the following commands to dump the current data into a ",(0,r.jsx)(t.code,{children:".sql"})," file:"]}),"\n",(0,r.jsx)(t.pre,{children:(0,r.jsx)(t.code,{className:"language-shell",children:"# This is the path where the PVC is mounted, so we'll place the dump here too\ncd /bitnami/postgresql/\n# Set the postgres password based on the `POSTGRES_POSTGRES_PASSWORD` environment variable\nexport PGPASSWORD=$POSTGRES_POSTGRES_PASSWORD\n# Dump the authentik database into an sql file\npg_dump -U $POSTGRES_USER $POSTGRES_DB > dump-11.sql\n"})}),"\n",(0,r.jsx)(t.h3,{id:"stop-postgresql-and-start-the-upgrade",children:"Stop PostgreSQL and start the upgrade"}),"\n",(0,r.jsxs)(t.p,{children:["To upgrade, change the following entries in your ",(0,r.jsx)(t.code,{children:"values.yaml"})," used to deploy authentik:"]}),"\n",(0,r.jsx)(t.pre,{children:(0,r.jsx)(t.code,{className:"language-yaml",children:"postgresql:\n    diagnosticMode:\n        enabled: true\n    image:\n        tag: 15.2.0-debian-11-r26\n"})}),"\n",(0,r.jsxs)(t.p,{children:["Now run ",(0,r.jsx)(t.code,{children:"helm upgrade --install authentik authentik/authentik -f values.yaml"})," to apply these changes. Depending on your configuration, you might have to repeat the steps from ",(0,r.jsx)(t.a,{href:"#prerequisites",children:"Prerequisites"}),"."]}),"\n",(0,r.jsx)(t.p,{children:"After the upgrade is finished, you should have a new PostgreSQL pod running with the updated image."}),"\n",(0,r.jsx)(t.h3,{id:"remove-the-old-data",children:"Remove the old data"}),"\n",(0,r.jsx)(t.p,{children:"Because the PVC mounted by the PostgreSQL pod still contains the old data, we need to remove/rename that data, so that PostgreSQL can initialize it with the new version."}),"\n",(0,r.jsxs)(t.p,{children:["Run ",(0,r.jsx)(t.code,{children:"kubectl exec -it authentik-postgresql-0 -- bash"})," to get a shell in the PostgreSQL pod."]}),"\n",(0,r.jsx)(t.p,{children:"Run the following commands to move the old data:"}),"\n",(0,r.jsx)(t.pre,{children:(0,r.jsx)(t.code,{className:"language-shell",children:"# This is the path where the PVC is mounted\ncd /bitnami/postgresql/\n# Move Postgres' data folder to data-11, which is the version we're upgrading to.\n# The data folder can also be deleted; however it is recommended to rename it first\n# in case the upgrade fails.\nmv data data-11\n"})}),"\n",(0,r.jsx)(t.h3,{id:"restart-postgresql",children:"Restart PostgreSQL"}),"\n",(0,r.jsxs)(t.p,{children:["In the step ",(0,r.jsx)(t.a,{href:"#stop-postgresql-and-start-the-upgrade",children:"Stop PostgreSQL and start the upgrade"}),", we enabled the ",(0,r.jsx)(t.em,{children:"diagnostic mode"}),", which means the PostgreSQL pod is running, but the actual Postgres process isn't running. Now that we've removed the old data directory, we can disable the diagnostic mode."]}),"\n",(0,r.jsxs)(t.p,{children:["Once again, change the following entries in your ",(0,r.jsx)(t.code,{children:"values.yaml"})," used to deploy authentik:"]}),"\n",(0,r.jsx)(t.pre,{children:(0,r.jsx)(t.code,{className:"language-yaml",children:"postgresql:\n    image:\n        tag: 15.2.0-debian-11-r26\n"})}),"\n",(0,r.jsxs)(t.p,{children:["And once again run ",(0,r.jsx)(t.code,{children:"helm upgrade --install authentik authentik/authentik -f values.yaml"})," to apply these changes. Depending on your configuration, you might have to repeat the steps from ",(0,r.jsx)(t.a,{href:"#prerequisites",children:"Prerequisites"}),"."]}),"\n",(0,r.jsx)(t.p,{children:"After the PostgreSQL pod is running again, we need to restore the data from the dump we created above."}),"\n",(0,r.jsxs)(t.p,{children:["Run ",(0,r.jsx)(t.code,{children:"kubectl exec -it authentik-postgresql-0 -- bash"})," to get a shell in the PostgreSQL pod."]}),"\n",(0,r.jsx)(t.p,{children:"Run the following commands to restore the data:"}),"\n",(0,r.jsx)(t.pre,{children:(0,r.jsx)(t.code,{className:"language-shell",children:"# This is the path where the PVC is mounted\ncd /bitnami/postgresql/\n# Set the Postgres password based on the `POSTGRES_POSTGRES_PASSWORD` environment variable.\nexport PGPASSWORD=$POSTGRES_POSTGRES_PASSWORD\npsql -U $POSTGRES_USER $POSTGRES_DB < dump-11.sql\n"})}),"\n",(0,r.jsx)(t.p,{children:"After the last command finishes, all of the data is restored, and you can restart authentik."}),"\n",(0,r.jsx)(t.h3,{id:"restarting-authentik",children:"Restarting authentik"}),"\n",(0,r.jsxs)(t.p,{children:["Run ",(0,r.jsx)(t.code,{children:"helm upgrade --install authentik authentik/authentik -f values.yaml"})," once again, which will restart your authentik server and worker containers."]})]})}function u(e={}){const{wrapper:t}={...(0,a.R)(),...e.components};return t?(0,r.jsx)(t,{...e,children:(0,r.jsx)(h,{...e})}):h(e)}}}]);