"use strict";(self.webpackChunk_goauthentik_website_docs=self.webpackChunk_goauthentik_website_docs||[]).push([[31531],{83903:(e,s,t)=>{t.r(s),t.d(s,{assets:()=>c,contentTitle:()=>r,default:()=>h,frontMatter:()=>d,metadata:()=>o,toc:()=>a});const o=JSON.parse('{"id":"developer-docs/api/websocket","title":"Websocket API","description":"authentik has two different WebSocket endpoints, one is used for web-based clients to get real-time updates, and the other is used for outposts to report their healthiness.","source":"@site/docs/developer-docs/api/websocket.md","sourceDirName":"developer-docs/api","slug":"/developer-docs/api/websocket","permalink":"/docs/developer-docs/api/websocket","draft":false,"unlisted":false,"editUrl":"https://github.com/goauthentik/authentik/edit/main/website/docs/developer-docs/api/websocket.md","tags":[],"version":"current","frontMatter":{"title":"Websocket API"},"sidebar":"docs","previous":{"title":"Making schema changes","permalink":"/docs/developer-docs/api/making-schema-changes"},"next":{"title":"Introduction","permalink":"/docs/developer-docs/api/reference/authentik"}}');var n=t(74848),i=t(28453);const d={title:"Websocket API"},r=void 0,c={},a=[{value:"Web <code>/ws/client/</code>",id:"web-wsclient",level:3},{value:"<code>message</code> type:",id:"message-type",level:4},{value:"Outpost <code>/ws/outpost/&lt;outpost-uuid&gt;/</code>",id:"outpost-wsoutpostoutpost-uuid",level:3}];function l(e){const s={admonition:"admonition",code:"code",h3:"h3",h4:"h4",li:"li",p:"p",pre:"pre",ul:"ul",...(0,i.R)(),...e.components};return(0,n.jsxs)(n.Fragment,{children:[(0,n.jsx)(s.p,{children:"authentik has two different WebSocket endpoints, one is used for web-based clients to get real-time updates, and the other is used for outposts to report their healthiness."}),"\n",(0,n.jsxs)(s.h3,{id:"web-wsclient",children:["Web ",(0,n.jsx)(s.code,{children:"/ws/client/"})]}),"\n",(0,n.jsx)(s.admonition,{type:"info",children:(0,n.jsxs)(s.p,{children:["Authentication is done using the session, so make sure to send the ",(0,n.jsx)(s.code,{children:"Cookie"})," header."]})}),"\n",(0,n.jsxs)(s.p,{children:["All messages have a common field called ",(0,n.jsx)(s.code,{children:"message_type"})," to discern the type of message."]}),"\n",(0,n.jsxs)(s.h4,{id:"message-type",children:[(0,n.jsx)(s.code,{children:"message"})," type:"]}),"\n",(0,n.jsx)(s.p,{children:"This type is used when the backend has a notice to show to the user. A full payload looks like:"}),"\n",(0,n.jsx)(s.pre,{children:(0,n.jsx)(s.code,{className:"language-json",children:'{\n    "message_type": "message",\n    "level": "error" | "warning" | "success" | "info",\n    "tags": "",\n    "message": "a message",\n}\n'})}),"\n",(0,n.jsxs)(s.h3,{id:"outpost-wsoutpostoutpost-uuid",children:["Outpost ",(0,n.jsx)(s.code,{children:"/ws/outpost/<outpost-uuid>/"})]}),"\n",(0,n.jsx)(s.admonition,{type:"info",children:(0,n.jsxs)(s.p,{children:["Authentication is done via the ",(0,n.jsx)(s.code,{children:"Authorization"})," header, same as the regular API. You must send a valid token with a ",(0,n.jsx)(s.code,{children:"Bearer "})," prefix."]})}),"\n",(0,n.jsxs)(s.p,{children:["All messages have two fields, ",(0,n.jsx)(s.code,{children:"instruction"})," and ",(0,n.jsx)(s.code,{children:"args"}),". Instruction is any number from this list:"]}),"\n",(0,n.jsxs)(s.ul,{children:["\n",(0,n.jsxs)(s.li,{children:[(0,n.jsx)(s.code,{children:"0"}),": ACK, simply acknowledges the previous message"]}),"\n",(0,n.jsxs)(s.li,{children:[(0,n.jsx)(s.code,{children:"1"}),": HELLO, used for monitoring and regularly sent by outposts"]}),"\n",(0,n.jsxs)(s.li,{children:[(0,n.jsx)(s.code,{children:"2"}),": TRIGGER_UPDATE, sent by authentik to trigger a reload of the configuration"]}),"\n"]}),"\n",(0,n.jsx)(s.p,{children:"Arguments for these messages vary, all though these common args are always sent:"}),"\n",(0,n.jsxs)(s.ul,{children:["\n",(0,n.jsxs)(s.li,{children:[(0,n.jsx)(s.code,{children:"args['uuid']"}),": A unique UUID generated on startup of an outpost, used to uniquely identify it."]}),"\n"]}),"\n",(0,n.jsx)(s.p,{children:"These fields are only sent for HELLO instructions:"}),"\n",(0,n.jsxs)(s.ul,{children:["\n",(0,n.jsxs)(s.li,{children:[(0,n.jsx)(s.code,{children:"args['version']"}),": Version of the outpost"]}),"\n",(0,n.jsxs)(s.li,{children:[(0,n.jsx)(s.code,{children:"args['buildHash']"}),": Build hash of the outpost, when available"]}),"\n"]})]})}function h(e={}){const{wrapper:s}={...(0,i.R)(),...e.components};return s?(0,n.jsx)(s,{...e,children:(0,n.jsx)(l,{...e})}):l(e)}}}]);