"use strict";(self.webpackChunk_goauthentik_website_docs=self.webpackChunk_goauthentik_website_docs||[]).push([[95313],{66714:(e,i,n)=>{n.r(i),n.d(i,{assets:()=>c,contentTitle:()=>a,default:()=>h,frontMatter:()=>o,metadata:()=>s,toc:()=>l});const s=JSON.parse('{"id":"security/security-hardening","title":"Hardening authentik","description":"While authentik is secure out of the box, you can take steps to further increase the security of an authentik instance. As everyone knows, there is a consequential tradeoff between security and convenience. All of these hardening practices have an impact on the user experience and should only be applied knowing this tradeoff.","source":"@site/docs/security/security-hardening.md","sourceDirName":"security","slug":"/security/security-hardening","permalink":"/docs/security/security-hardening","draft":false,"unlisted":false,"editUrl":"https://github.com/goauthentik/authentik/edit/main/website/docs/security/security-hardening.md","tags":[],"version":"current","frontMatter":{"title":"Hardening authentik"},"sidebar":"docs","previous":{"title":"Security Policy","permalink":"/docs/security/policy"},"next":{"title":"2023-06 Cure53 Code audit","permalink":"/docs/security/audits-and-certs/2023-06-cure53"}}');var t=n(74848),r=n(28453);const o={title:"Hardening authentik"},a=void 0,c={},l=[{value:"Password policy",id:"password-policy",level:3},{value:"Expressions",id:"expressions",level:3},{value:"Blueprints",id:"blueprints",level:3},{value:"CAPTCHA Stage",id:"captcha-stage",level:3},{value:"Content Security Policy (CSP)",id:"content-security-policy-csp",level:3}];function d(e){const i={a:"a",admonition:"admonition",code:"code",h3:"h3",li:"li",p:"p",pre:"pre",ul:"ul",...(0,r.R)(),...e.components};return(0,t.jsxs)(t.Fragment,{children:[(0,t.jsx)(i.p,{children:"While authentik is secure out of the box, you can take steps to further increase the security of an authentik instance. As everyone knows, there is a consequential tradeoff between security and convenience. All of these hardening practices have an impact on the user experience and should only be applied knowing this tradeoff."}),"\n",(0,t.jsx)(i.h3,{id:"password-policy",children:"Password policy"}),"\n",(0,t.jsxs)(i.p,{children:["authentik's default Password policy complies with the ",(0,t.jsx)(i.a,{href:"https://pages.nist.gov/800-63-4/sp800-63b.html#password",children:"NIST SP 800-63 Digital Identity Guidelines"}),"."]}),"\n",(0,t.jsx)(i.p,{children:"However, for further hardening compliant to the NIST Guidelines, consider"}),"\n",(0,t.jsxs)(i.ul,{children:["\n",(0,t.jsx)(i.li,{children:"setting the length of the password to a minimum of 15 characters, and"}),"\n",(0,t.jsx)(i.li,{children:'enabling the "Check haveibeenpwned.com" blocklist comparison (note that this cannot be used on Air-gapped instances)'}),"\n"]}),"\n",(0,t.jsxs)(i.p,{children:["For further options, see ",(0,t.jsx)(i.a,{href:"/docs/customize/policies/#password-policy",children:"Password policy"}),"."]}),"\n",(0,t.jsx)(i.h3,{id:"expressions",children:"Expressions"}),"\n",(0,t.jsxs)(i.p,{children:[(0,t.jsx)(i.a,{href:"/docs/customize/policies/expression",children:"Expressions"})," allow super-users and other highly privileged users to create custom logic within authentik to modify its behaviour. Editing/creating these expressions is, by default, limited to super-users and any related events are fully logged."]}),"\n",(0,t.jsx)(i.p,{children:"However, for further hardening, it is possible to prevent any user (even super-users) from using expressions to create or edit any objects. To do so, configure your deployment to block API requests to these endpoints:"}),"\n",(0,t.jsxs)(i.ul,{children:["\n",(0,t.jsx)(i.li,{children:(0,t.jsx)(i.code,{children:"/api/v3/policies/expression*"})}),"\n",(0,t.jsx)(i.li,{children:(0,t.jsx)(i.code,{children:"/api/v3/propertymappings*"})}),"\n",(0,t.jsx)(i.li,{children:(0,t.jsx)(i.code,{children:"/api/v3/managed/blueprints*"})}),"\n"]}),"\n",(0,t.jsxs)(i.p,{children:["With these restrictions in place, expressions can only be edited using ",(0,t.jsx)(i.a,{href:"/docs/customize/blueprints/#storage---file",children:"Blueprints on the file system"}),". Take care to restrict access to the file system itself."]}),"\n",(0,t.jsx)(i.h3,{id:"blueprints",children:"Blueprints"}),"\n",(0,t.jsx)(i.p,{children:"Blueprints allow for templating and managing the authentik configuration as code. Just like expressions, they can only be created/edited by super-users or users with specific permissions assigned to them. However, because they interact with the authentik API on a lower level, they can create other objects."}),"\n",(0,t.jsx)(i.p,{children:"To prevent any user from creating/editing blueprints, block API requests to this endpoint:"}),"\n",(0,t.jsxs)(i.ul,{children:["\n",(0,t.jsx)(i.li,{children:(0,t.jsx)(i.code,{children:"/api/v3/managed/blueprints*"})}),"\n"]}),"\n",(0,t.jsxs)(i.p,{children:["With these restrictions in place, Blueprints can only be edited via ",(0,t.jsx)(i.a,{href:"/docs/customize/blueprints/#storage---file",children:"the file system"}),"."]}),"\n",(0,t.jsx)(i.h3,{id:"captcha-stage",children:"CAPTCHA Stage"}),"\n",(0,t.jsx)(i.p,{children:"The CAPTCHA stage allows for additional verification of a user while authenticating or authorising an application. Because the CAPTCHA stage supports multiple different CAPTCHA providers, such as Google\u2019s reCAPTCHA and Cloudflare\u2019s Turnstile, the URL for the JavaScript snippet can be modified. Depending on the threat model, this could be exploited by a malicious internal actor."}),"\n",(0,t.jsx)(i.p,{children:"To prevent any user from creating/editing CAPTCHA stages block API requests to these endpoints:"}),"\n",(0,t.jsxs)(i.ul,{children:["\n",(0,t.jsx)(i.li,{children:(0,t.jsx)(i.code,{children:"/api/v3/stages/captcha*"})}),"\n",(0,t.jsx)(i.li,{children:(0,t.jsx)(i.code,{children:"/api/v3/managed/blueprints*"})}),"\n"]}),"\n",(0,t.jsxs)(i.p,{children:["With these restrictions in place, CAPTCHA stages can only be edited using ",(0,t.jsx)(i.a,{href:"/docs/customize/blueprints/#storage---file",children:"Blueprints on the file system"}),"."]}),"\n",(0,t.jsx)(i.h3,{id:"content-security-policy-csp",children:"Content Security Policy (CSP)"}),"\n",(0,t.jsx)(i.admonition,{type:"caution",children:(0,t.jsx)(i.p,{children:"Setting up CSP incorrectly might result in the client not loading necessary third-party code."})}),"\n",(0,t.jsx)(i.admonition,{type:"caution",children:(0,t.jsxs)(i.p,{children:["In some cases, a CSP header will already be set by authentik (for example, in ",(0,t.jsx)(i.a,{href:"https://github.com/goauthentik/authentik/pull/12092/",children:"user uploaded content"}),"). Do not overwrite an already existing header as doing so might result in vulnerabilities. Instead, add a new CSP header."]})}),"\n",(0,t.jsxs)(i.p,{children:["Content Security Policy (CSP) is a security standard that mitigates the risk of content injection vulnerabilities. authentik doesn't currently support CSP natively, so setting it up depends on your installation. We recommend using a ",(0,t.jsx)(i.a,{href:"/docs/install-config/reverse-proxy",children:"reverse proxy"})," to set a CSP header."]}),"\n",(0,t.jsx)(i.p,{children:"authentik requires at least the following allowed locations:"}),"\n",(0,t.jsx)(i.pre,{children:(0,t.jsx)(i.code,{children:"default-src 'self';\nimg-src https: http: data:;\nobject-src 'none';\nstyle-src 'self' 'unsafe-inline';    # Required due to Lit/ShadowDOM\nscript-src 'self' 'unsafe-inline';   # Required for generated scripts\n"})}),"\n",(0,t.jsx)(i.p,{children:"Your use case might require more allowed locations for various directives, e.g."}),"\n",(0,t.jsxs)(i.ul,{children:["\n",(0,t.jsx)(i.li,{children:"when using a CAPTCHA service"}),"\n",(0,t.jsx)(i.li,{children:"when using Sentry"}),"\n",(0,t.jsx)(i.li,{children:"when using any custom JavaScript in a prompt stage"}),"\n",(0,t.jsx)(i.li,{children:"when using Spotlight Sidecar for development"}),"\n"]})]})}function h(e={}){const{wrapper:i}={...(0,r.R)(),...e.components};return i?(0,t.jsx)(i,{...e,children:(0,t.jsx)(d,{...e})}):d(e)}}}]);