"use strict";(self.webpackChunk_goauthentik_website_docs=self.webpackChunk_goauthentik_website_docs||[]).push([[72423],{11849:(e,t,i)=>{i.r(t),i.d(t,{assets:()=>l,contentTitle:()=>r,default:()=>h,frontMatter:()=>o,metadata:()=>s,toc:()=>c});const s=JSON.parse('{"id":"security/audits-and-certs/2024-11-cobalt","title":"2024-11 Cobalt pentest","description":"We are committed to engaging in regular pentesting and security audits of authentik. Defining and adhering to a cadence of external testing ensures a stronger probability that our code base, our features, and our architecture is as secure and non-exploitable as possible.","source":"@site/docs/security/audits-and-certs/2024-11-cobalt.md","sourceDirName":"security/audits-and-certs","slug":"/security/audits-and-certs/2024-11-cobalt","permalink":"/docs/security/audits-and-certs/2024-11-cobalt","draft":false,"unlisted":false,"editUrl":"https://github.com/goauthentik/authentik/edit/main/website/docs/security/audits-and-certs/2024-11-cobalt.md","tags":[],"version":"current","frontMatter":{},"sidebar":"docs","previous":{"title":"2023-06 Cure53 Code audit","permalink":"/docs/security/audits-and-certs/2023-06-cure53"},"next":{"title":"CVE-2025-29928","permalink":"/docs/security/cves/CVE-2025-29928"}}');var n=i(74848),a=i(28453);const o={},r="2024-11 Cobalt pentest",l={},c=[{value:"Summary of findings",id:"summary-of-findings",level:2},{value:"Responses to specific findings",id:"responses-to-specific-findings",level:2},{value:"HTML Injection",id:"html-injection",level:3},{value:"SVG images for icons possible XSS vulnerability",id:"svg-images-for-icons-possible-xss-vulnerability",level:3},{value:"Vulnerability through footer links on website",id:"vulnerability-through-footer-links-on-website",level:3},{value:"Password policy weakness",id:"password-policy-weakness",level:3},{value:"Lack of a CSP header",id:"lack-of-a-csp-header",level:3},{value:"API endpoints strengthened",id:"api-endpoints-strengthened",level:3},{value:"Retest results",id:"retest-results",level:2}];function d(e){const t={a:"a",blockquote:"blockquote",code:"code",h1:"h1",h2:"h2",h3:"h3",header:"header",p:"p",strong:"strong",...(0,a.R)(),...e.components};return(0,n.jsxs)(n.Fragment,{children:[(0,n.jsx)(t.header,{children:(0,n.jsx)(t.h1,{id:"2024-11-cobalt-pentest",children:"2024-11 Cobalt pentest"})}),"\n",(0,n.jsx)(t.p,{children:"We are committed to engaging in regular pentesting and security audits of authentik. Defining and adhering to a cadence of external testing ensures a stronger probability that our code base, our features, and our architecture is as secure and non-exploitable as possible."}),"\n",(0,n.jsxs)(t.p,{children:["In August-September of 2024, we had a pentest conducted by\xa0",(0,n.jsx)(t.a,{href:"https://www.cobalt.io",children:"Cobalt"}),". This document covers the findings of the audit, how we addressed the noted issues, and the subsequent ",(0,n.jsx)(t.a,{href:"https://goauthentik.io/resources/fullReport_authentik-cobalt-test-instance-august-2024-pt26135.pdf",children:"re-testing"})," by Cobalt to confirm that all issues were resolved."]}),"\n",(0,n.jsx)(t.p,{children:"Cobalt described their process for testing:"}),"\n",(0,n.jsxs)(t.blockquote,{children:["\n",(0,n.jsx)(t.p,{children:"This pentest was a manual assessment of the security of the application\u2019s functionality, business logic, and vulnerabilities, such as those cataloged in the Open Web Application Security Project OWASP) Top 10. The assessment also included a review of security controls and requirements listed in the OWASP Application Security Verification Standard (ASVS)."}),"\n"]}),"\n",(0,n.jsx)(t.h2,{id:"summary-of-findings",children:"Summary of findings"}),"\n",(0,n.jsx)(t.p,{children:"Overall, we are pleased with the report's findings and grateful for the opportunity to improve in every area we can."}),"\n",(0,n.jsxs)(t.blockquote,{children:["\n",(0,n.jsx)(t.p,{children:'Cobalt reported "The pentesters found that the Authentik Security team implemented robust and up-to-date security practices throughout the application."'}),"\n"]}),"\n",(0,n.jsxs)(t.p,{children:["In total, there were 5 low-level and one info-level vulnerabilities reported. By early November 2024, all 6 vulnerabilities were addressed and released in the ",(0,n.jsx)(t.a,{href:"https://docs.goauthentik.io/docs/releases/2024.10#fixed-in-2024103",children:"2024.10.4 patch release"}),"."]}),"\n",(0,n.jsx)(t.h2,{id:"responses-to-specific-findings",children:"Responses to specific findings"}),"\n",(0,n.jsx)(t.p,{children:"From the\xa0audit, this is the complete list of findings, with information about how we addressed each."}),"\n",(0,n.jsx)(t.h3,{id:"html-injection",children:"HTML Injection"}),"\n",(0,n.jsxs)(t.p,{children:[(0,n.jsx)(t.strong,{children:"Issue"}),": A vulnerability existed through user-supplied names in our Flow diagrams, where the application did not properly sanitize or escape HTML input when parsing user-entered names. As a result, an attacker could inject arbitrary HTML or JavaScript code into the application, potentially leading to manipulation of the web page or execution of malicious scripts in the context of the user's session. (This action could only be performed by an authenticated admin user, and thus had little practical value as an attack vector.)"]}),"\n",(0,n.jsxs)(t.p,{children:[(0,n.jsx)(t.strong,{children:"Fix"}),": We added strict ",(0,n.jsx)(t.a,{href:"https://github.com/cure53/DOMPurify",children:"DOMpurify"})," configurations for any user-defined names in our diagrams. For details, refer to ",(0,n.jsx)(t.a,{href:"https://github.com/goauthentik/authentik/pull/11783",children:"Pull Request #11783"}),"."]}),"\n",(0,n.jsx)(t.h3,{id:"svg-images-for-icons-possible-xss-vulnerability",children:"SVG images for icons possible XSS vulnerability"}),"\n",(0,n.jsxs)(t.p,{children:[(0,n.jsx)(t.strong,{children:"Issue"}),": The pentesters discovered that the application was susceptible to insecure file upload and stored Cross-Site Scripting (XSS) vulnerabilities by uploading crafted SVG files that were used as application icons. (This action could only be performed by an authenticated admin user, and thus had little practical value as an attack vector.)"]}),"\n",(0,n.jsxs)(t.p,{children:[(0,n.jsx)(t.strong,{children:"Fix"}),": The fix was to add a CSP header to files that are stored in the\xa0",(0,n.jsx)(t.code,{children:"/media"}),"\xa0directory of the installation. For details, refer to ",(0,n.jsx)(t.a,{href:"https://github.com/goauthentik/authentik/pull/12092",children:"Pull Request #12092"}),"."]}),"\n",(0,n.jsx)(t.h3,{id:"vulnerability-through-footer-links-on-website",children:"Vulnerability through footer links on website"}),"\n",(0,n.jsxs)(t.p,{children:[(0,n.jsx)(t.strong,{children:"Issue"}),": It was found that the application was vulnerable to stored XSS through footer links. The footer section of the application accepted and displayed user-provided links without proper sanitization. This could allow an attacker to inject malicious scripts into these links, which would then stored and executed when other users access the footer links, leading to potential script execution in the context of the victim's session. (This action could only be performed by an authenticated admin user, and thus had little practical value as an attack vector.)"]}),"\n",(0,n.jsxs)(t.p,{children:[(0,n.jsx)(t.strong,{children:"Fix"}),": Again, as with the diagram issue above, we added strict ",(0,n.jsx)(t.a,{href:"https://github.com/cure53/DOMPurify",children:"DOMpurify"})," configurations. For more details, refer to ",(0,n.jsx)(t.a,{href:"https://github.com/goauthentik/authentik/pull/11773",children:"Pull Request #11773"}),"."]}),"\n",(0,n.jsx)(t.h3,{id:"password-policy-weakness",children:"Password policy weakness"}),"\n",(0,n.jsxs)(t.p,{children:[(0,n.jsx)(t.strong,{children:"Issue"}),": It was determined that the password policy in place on the testing environment was weak, allowing users to create passwords that lacked complexity and were easily guessable. This made the application more susceptible to brute-force and dictionary attacks."]}),"\n",(0,n.jsxs)(t.p,{children:[(0,n.jsx)(t.strong,{children:"Fix"}),": This was not a vulnerability in authentik, but rather a poor configuration of our provided test environment. Rather than simply improve our test instance\u2019s configuration once, to make this issue easier to avoid for all our users and customers, we added a strong default password policy that applies to all new instances. (As always, admins can still configure their own custom policies.) For more details, refer to ",(0,n.jsx)(t.a,{href:"https://github.com/goauthentik/authentik/pull/11793",children:"Pull Request #11793"}),"."]}),"\n",(0,n.jsx)(t.h3,{id:"lack-of-a-csp-header",children:"Lack of a CSP header"}),"\n",(0,n.jsx)(t.p,{children:"The absence of Content Security Policy (CSP) headers means that the application may lack a mechanism to restrict sources of content and scripts, which can potentially expose it to XSS attacks and other forms of content injection."}),"\n",(0,n.jsxs)(t.p,{children:[(0,n.jsx)(t.strong,{children:"Fix"}),": We added CSP headers to control the sources of content and scripts that the application can load for our provided test instance. Again, this is not a direct vulnerability in authentik itself. Given the variety of architectures in which authentik is deployed, adding our own CSP headers would be more likely to break functionality than to provide improved security."]}),"\n",(0,n.jsx)(t.h3,{id:"api-endpoints-strengthened",children:"API endpoints strengthened"}),"\n",(0,n.jsxs)(t.p,{children:[(0,n.jsx)(t.strong,{children:"Issue"}),": Finally, the only informational level finding was the potential for the unauthenticated download of private key and certificate values via a direct URL. (Guessing the URL required the knowledge of the UUID of an object.) We had already fixed this issue in 2024.8.0, but the instance tested against was the immediately preceding version."]}),"\n",(0,n.jsxs)(t.p,{children:[(0,n.jsx)(t.strong,{children:"Fix"}),": For more details, refer to ",(0,n.jsx)(t.a,{href:"https://docs.goauthentik.io/docs/security/cves/CVE-2024-42490",children:"CVE-2024-42490"}),"."]}),"\n",(0,n.jsx)(t.h2,{id:"retest-results",children:"Retest results"}),"\n",(0,n.jsxs)(t.p,{children:["The subsequent retest conducted by Cobalt deemed all issues resolved. See page 17 of the ",(0,n.jsx)(t.a,{href:"https://goauthentik.io/resources/fullReport_authentik-cobalt-test-instance-august-2024-pt26135.pdf",children:"report"}),' for the mitigation status ("fixed") for each of the issues discovered in September.']}),"\n",(0,n.jsxs)(t.p,{children:["We are pleased to share this pentest and the final results of the retest. We encourage an open and ongoing communication with our users and community. For more information abut our security stance, read our ",(0,n.jsx)(t.a,{href:"https://docs.goauthentik.io/docs/security/policy",children:"Security Policy"}),", ",(0,n.jsx)(t.a,{href:"https://docs.goauthentik.io/docs/security/security-hardening",children:"Hardening authentik"}),", and our other ",(0,n.jsx)(t.a,{href:"https://docs.goauthentik.io/docs/security",children:"security-related documentation"}),". If you have any questions or feedback you can reach us on\xa0",(0,n.jsx)(t.a,{href:"https://github.com/goauthentik/authentik",children:"GitHub"}),",\xa0",(0,n.jsx)(t.a,{href:"https://discord.com/channels/809154715984199690/809154716507963434",children:"Discord"}),", or via email to\xa0",(0,n.jsx)(t.a,{href:"mailto:hello@goauthentik.io",children:"hello@goauthentik.io"}),"."]})]})}function h(e={}){const{wrapper:t}={...(0,a.R)(),...e.components};return t?(0,n.jsx)(t,{...e,children:(0,n.jsx)(d,{...e})}):d(e)}}}]);