"use strict";(self.webpackChunk_goauthentik_website_docs=self.webpackChunk_goauthentik_website_docs||[]).push([[42838],{27812:(e,t,n)=>{n.d(t,{Ay:()=>r,RM:()=>i});var s=n(74848),o=n(28453);const i=[];function a(e){const t={code:"code",pre:"pre",...(0,o.R)(),...e.components};return(0,s.jsx)(t.pre,{children:(0,s.jsx)(t.code,{className:"language-yaml",children:"# Log level that the outpost will set\n# Allowed levels: trace, debug, info, warning, error\n# Applies to: non-embedded\nlog_level: debug\n# Interval at which the outpost will refresh the providers\n# from authentik. For caching outposts (such as LDAP), the\n# cache will also be invalidated at that interval.\n# (Format: hours=1;minutes=2;seconds=3).\nrefresh_interval: minutes=5\n########################################\n# The settings below are only relevant when using a managed outpost\n########################################\n# URL that the outpost uses to connect back to authentik\nauthentik_host: https://authentik.tld/\n# Disable SSL Validation for the authentik connection\nauthentik_host_insecure: false\n# Optionally specify a different URL used for user-facing interactions\n# Applies to: proxy outposts\nauthentik_host_browser:\n# Template used for objects created (deployments/containers, services, secrets, etc)\nobject_naming_template: ak-outpost-%(name)s\n# Use a specific docker image for this outpost rather than the default. This also applies to Kubernetes\n# outposts.\n# Applies to: non-embedded\ncontainer_image:\n########################################\n# Docker outpost specific settings\n########################################\n# Network the outpost container should be connected to\n# Applies to: non-embedded\ndocker_network: null\n# Optionally disable mapping of ports to outpost container, may be useful when using docker networks\n# (Available with 2021.9.4+)\n# Applies to: non-embedded\ndocker_map_ports: true\n# Optionally additional labels for docker containers\n# (Available with 2022.1.2)\n# Applies to: non-embedded\ndocker_labels: null\n########################################\n# Kubernetes outpost specific settings\n########################################\n# Replica count for the deployment of the outpost\n# Applies to: non-embedded\nkubernetes_replicas: 1\n# Namespace to deploy in, defaults to the same namespace authentik is deployed in (if available)\nkubernetes_namespace: authentik\n# Any additional annotations to add to the ingress object, for example cert-manager\nkubernetes_ingress_annotations: {}\n# Name of the secret that is used for TLS connections, leave empty to disable TLS\nkubernetes_ingress_secret_name: authentik-outpost-tls\n# Service kind created, can be set to LoadBalancer for LDAP outposts for example\nkubernetes_service_type: ClusterIP\n# Disable any components of the kubernetes integration, can be any of\n# - 'secret'\n# - 'deployment'\n# - 'service'\n# - 'prometheus servicemonitor'\n# - 'ingress'\n# - 'traefik middleware'\nkubernetes_disabled_components: []\n# If the above docker image is in a private repository, use these secrets to pull.\n# NOTE: The secret must be created manually in the namespace first.\n# Applies to: non-embedded\nkubernetes_image_pull_secrets: []\n# Optionally configure an ingress class name. If not set, the ingress will use the cluster's\n# default ingress class\n# (Available with 2022.11.0+)\n# Applies to: proxy outposts\nkubernetes_ingress_class_name: null\n# Optionally apply an RFC 6902 compliant patch to the Kubernetes objects.\n# For an understanding of how this works, refer to the link below:\n# https://github.com/kubernetes-sigs/kustomize/blob/master/examples/jsonpatch.md\n#\n# This value expects a mapping where the key represents\n# the Kubernetes component that shall be patched.\n# It can be any of the same values supported by `kubernetes_disabled_components`.\n#\n# For example use this patch to add custom resource requests and limits\n# to the outpost deployment:\n#\n# deployment:\n#   - op: add\n#     path: \"/spec/template/spec/containers/0/resources\"\n#     value:\n#       requests:\n#         cpu: 2000m\n#         memory: 2000Mi\n#       limits:\n#         cpu: 4000m\n#         memory: 8000Mi\nkubernetes_json_patches: null\n"})})}function r(e={}){const{wrapper:t}={...(0,o.R)(),...e.components};return t?(0,s.jsx)(t,{...e,children:(0,s.jsx)(a,{...e})}):a(e)}},58818:(e,t,n)=>{n.r(t),n.d(t,{assets:()=>l,contentTitle:()=>d,default:()=>h,frontMatter:()=>r,metadata:()=>s,toc:()=>c});const s=JSON.parse('{"id":"add-secure-apps/outposts/embedded/embedded","title":"Embedded Outpost","description":"Starting with 2021.8.1, authentik comes with an embedded outpost. This has been added to simplify deployment for users using the Proxy provider.","source":"@site/docs/add-secure-apps/outposts/embedded/embedded.mdx","sourceDirName":"add-secure-apps/outposts/embedded","slug":"/add-secure-apps/outposts/embedded/","permalink":"/docs/add-secure-apps/outposts/embedded/","draft":false,"unlisted":false,"editUrl":"https://github.com/goauthentik/authentik/edit/main/website/docs/add-secure-apps/outposts/embedded/embedded.mdx","tags":[],"version":"current","frontMatter":{"title":"Embedded Outpost"},"sidebar":"docs","previous":{"title":"Outposts","permalink":"/docs/add-secure-apps/outposts/"},"next":{"title":"Docker","permalink":"/docs/add-secure-apps/outposts/integrations/docker"}}');var o=n(74848),i=n(28453),a=n(27812);const r={title:"Embedded Outpost"},d=void 0,l={},c=[{value:"Configuration",id:"configuration",level:3},...a.RM,{value:"Routing",id:"routing",level:3},{value:"Differences",id:"differences",level:3}];function u(e){const t={code:"code",h3:"h3",li:"li",ol:"ol",p:"p",...(0,i.R)(),...e.components};return(0,o.jsxs)(o.Fragment,{children:[(0,o.jsx)(t.p,{children:"Starting with 2021.8.1, authentik comes with an embedded outpost. This has been added to simplify deployment for users using the Proxy provider."}),"\n",(0,o.jsxs)(t.p,{children:["The embedded outpost runs in the main ",(0,o.jsx)(t.code,{children:"server"})," container, and is managed by authentik itself. The embedded outpost authenticates itself via the secret key."]}),"\n",(0,o.jsx)(t.p,{children:"You can access the embedded outpost on the same ports as authentik itself, 9000 and 9443."}),"\n",(0,o.jsx)(t.p,{children:"If the embedded outpost doesn't make sense for your deployment, you can simply ignore it."}),"\n",(0,o.jsx)(t.h3,{id:"configuration",children:"Configuration"}),"\n",(0,o.jsx)(t.p,{children:"Since authentik doesn't know it's own \"primary\" URL, there might be some configuration required."}),"\n",(0,o.jsx)(t.p,{children:"By default, when opening the admin dashboard on a fresh install, authentik will automatically configure the outpost to use the same URL as was used to access authentik."}),"\n",(0,o.jsxs)(t.p,{children:["If this isn't correct, or needs to be changed, click the edit button on the right of the outpost, and set the value of ",(0,o.jsx)(t.code,{children:"authentik_host"})," to the URL you want to login with.\nMake sure to set it to full URL, only configuring a hostname or FQDN will not work."]}),"\n",(0,o.jsx)(t.p,{children:'Additionally, most of the other configuration options can be used as with any other outpost, except from items which are marked as "non-embedded"'}),"\n","\n",(0,o.jsx)(a.Ay,{}),"\n",(0,o.jsx)(t.h3,{id:"routing",children:"Routing"}),"\n",(0,o.jsx)(t.p,{children:"Routing is handled like this:"}),"\n",(0,o.jsxs)(t.ol,{children:["\n",(0,o.jsxs)(t.li,{children:["Paths starting with ",(0,o.jsx)(t.code,{children:"/static"}),", ",(0,o.jsx)(t.code,{children:"/media"})," and ",(0,o.jsx)(t.code,{children:"/help"})," return packaged CSS/JS files, and user-uploaded media files."]}),"\n",(0,o.jsxs)(t.li,{children:["Paths starting with ",(0,o.jsx)(t.code,{children:"/outpost.goauthentik.io"})," are sent to the embedded outpost."]}),"\n",(0,o.jsx)(t.li,{children:"Any hosts configured in the providers assigned to the embedded outpost are sent to the outpost."}),"\n",(0,o.jsx)(t.li,{children:"Everything remaining is sent to the authentik backend server."}),"\n"]}),"\n",(0,o.jsx)(t.h3,{id:"differences",children:"Differences"}),"\n",(0,o.jsx)(t.p,{children:"There are a few more differences between managed outposts and the embedded outpost, mainly due to the fact that authentik can't fully manage the containers."}),"\n",(0,o.jsxs)(t.ol,{children:["\n",(0,o.jsxs)(t.li,{children:["\n",(0,o.jsx)(t.p,{children:"(Docker-only) No automatic traefik labels are added to the server container."}),"\n",(0,o.jsx)(t.p,{children:"When you deploy a managed outpost on docker, the container has several labels to automatically configure traefik. This is not done for the embedded outpost."}),"\n"]}),"\n",(0,o.jsxs)(t.li,{children:["\n",(0,o.jsx)(t.p,{children:"(Kubernetes-only) An additional service is created."}),"\n",(0,o.jsx)(t.p,{children:"Since authentik does not know what the normal authentik Service is called, another one is created with a common set of labels that is always set."}),"\n"]}),"\n"]})]})}function h(e={}){const{wrapper:t}={...(0,i.R)(),...e.components};return t?(0,o.jsx)(t,{...e,children:(0,o.jsx)(u,{...e})}):u(e)}}}]);